/* Includes ------------------------------------------------------------------*/
#include "ADC.h"

uint8_t ADCComplete = 0;
uint32_t VREF122Sample;

//ADCУ׼
/*********************************************************************************
Name:ADC_Calibration
Purpose:Calibration the ADC offset
Paramenters:no
Return:no
*********************************************************************************/
void ADC_Calibration(void)
{
    ADC_CALR->Bits.CALEN = 1;                               //У׼
    while(ADC_ISR->Bits.EOCAL == 0);                        //ȴУ׼־
    ADC_ISR->Bits.EOCAL = 1;                                //־
}



//ʹVREF1P2¶ȴTS
void VREF_Enable(void)
{
    CMU_PCLKCR1->Bits.VREF1P2_PCE = 1;                      //ʹVREF1p2ģʱ
    VREF_CR->Bits.VREF_EN = 1;                              //ʹVREF1p2
    VREF_CR->Bits.PTAT_EN = 1;                              //ʹ¶ȴ
    while(VREF_ISR->Bits.IF == 0);                          //ȴVREF1p2(1.5ms)
    VREF_ISR->Bits.IF = 1;                                  //VREF1p2׼ѹ־
}


//λADC
void ADC_DeInit(void)
{
    RMU_PRSTEN->Bits.PERHRSTEN = PERHRSTEN_KEY;             //ʹ踴λ
    RMU_APBRSTCR2->Bits.ADCRST = 1;                         //ADCģ鸴λ
    RMU_APBRSTCR2->Bits.ADCRST = 0;
    RMU_APBRSTCR2->Bits.ADCCRST = 1;                        //ADCλ
    RMU_APBRSTCR2->Bits.ADCCRST = 0;
    RMU_PRSTEN->Bits.PERHRSTEN = ~PERHRSTEN_KEY;            //ر踴λ
}


//ʼADC
void ADC_Init(void)
{
    //IO Init
    CT_A_ADCIN
    CT_B_ADCIN
    VALCHK_ADCIN
    LEAK_ALARM_ADCIN
    PWRCHK_ADCIN
    
    CMU_PCLKCR2->Bits.ADC_PCE = 1;                          //ʹADCʱ
    CMU_OPCCR2->Bits.ADCCKS = 1;                            //ѡADCʱ 1:RCHF
    CMU_OPCCR2->Bits.ADCPSC = 3;                            //ADCʱӷƵ 3:8Ƶ
    CMU_OPCCR3->Bits.ADCCKE = 1;                            //ʹADCʱ
//    ADC_CFGR1->Bits.APBCLK_PSC = 0;                         //APBCLKADCʱʱԤƵ
    ADC_CFGR1->Bits.CLKSEL = 0;                             //ѡADCʱ 0:ADCCLK  1:APBCLK
    ADC_CFGR1->Bits.REFSEL = 0;                             //ѡADC׼Դ 0 or 3:VDDA  1:VREFP  2:VDD15
    ADC_CFGR1->Bits.BITSEL = 0;                             //ѡADCλ 0:12bit  1:10bit  2:8bit  3:6bit
    
    VREF_Enable();                                          //ʹVREF1P2¶ȴTS
    
    ADC_CR1->Bits.ADEN = 1;                                 //ADC
    ADC_Calibration();                                      //ADCУ׼
    ADC_CR1->Bits.ADEN = 0;                                 //رADC(رպADCУ׼ֵȻ)
    
    ADC_CFGR2->Bits.CONT = 0;                               //תģʽ 0:ת  1:ת
    ADC_CFGR2->Bits.SEMI = 0;                               //õתģʽ 0:Զ  1:Զ
    ADC_CFGR2->Bits.WAIT = 1;                               //õȴģʽ 1:ȴݶȡ  0:ȴݶȡ(overrun)
    ADC_CFGR2->Bits.OVRM = 1;                               //Overrunģʽ 0:ϴ  1:ϴ
    ADC_CFGR2->Bits.SCANDIR = 0;                            //ⲿͨɨ˳ 0:  1:
    ADC_CFGR1->Bits.EXSOC = 0;                              //ֹⲿŴת
    ADC_CR2->Bits.TRGCFG = 0;                               //0:(TRGCFG=0޸ӲԴ)
//    ADC_CFGR2->Bits.EXTS = 0;                               //ѡӲԴ
//    ADC_CR2->Bits.TRGCFG = 2;                               //2:Ӳ½ش
    ADC_SMTR->Bits.SMTS2 = 0;                               //ÿͨ 0:2cycle
    ADC_SMTR->Bits.SMTS1 = 4;                               //ͨ 4:16cycle
//    ADC_CFGR2->Bits.OVSR = 2;                               //ù 2:8x
//    ADC_CFGR2->Bits.OVSS = 3;                               //ùλ 3:3bit
    ADC_CFGR2->Bits.OVSEN = 0;                              //ֹ
}



//ڲ¶ȴȡ¶ֵ
/*********************************************************************************
Name:GetTemprerature
Purpose:get temprerature
Paramenters:temp_value:the point to get  the temprerature value
Return:SUCCEED/FAILED
*********************************************************************************/

//VREF1p2
uint32_t GetVREF1P2Sample(void)
{
    uint16_t ADCRdresult;
    VREF_BUFCR->Bits.VREFBUFFER_EN = 1;                     //ʹVREF BUFFER
    ADC_CHER->Bits.VREF1P2 = 1;                             //ʹڲ׼ѹͨ
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADC_CR1->Bits.ADEN = 1;                                 //ADC
    ADC_CR1->Bits.SWTRIG = 1;                               //ʼת
    while(ADC_ISR->Bits.EOC == 0);                          //ȴת
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADCRdresult = ADC_DR->Bits.DATA;                        //ȡֵ
    ADC_CR1->Bits.ADEN = 0;                                 //رADC
    ADC_CHER->Bits.VREF1P2 = 0;                             //رڲ׼ѹͨ
    VREF_BUFCR->Bits.VREFBUFFER_EN = 0;                     //رVREF BUFFER
    return ADCRdresult;
}


//¶TS
uint32_t GetTSSample(void)
{
    uint16_t ADCRdresult;
    VREF_BUFCR->Bits.VPTATBUFFER_EN = 1;                    //ʹVPTAT BUFFER
    ADC_CHER->Bits.TS = 1;                                  //ʹ¶ȴͨ
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADC_CR1->Bits.ADEN = 1;                                 //ADC
    ADC_CR1->Bits.SWTRIG = 1;                               //ʼת
    while(ADC_ISR->Bits.EOC == 0);                          //ȴת
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADCRdresult = ADC_DR->Bits.DATA;                        //ȡֵ
    ADC_CR1->Bits.ADEN = 0;                                 //رADC
    ADC_CHER->Bits.TS = 0;                                  //ر¶ȴͨ
    VREF_BUFCR->Bits.VPTATBUFFER_EN = 0;                    //رVPTAT BUFFER
    return ADCRdresult;
}

//ȡ¶ֵ
INT16 GetTemprerature(INT16 *temp_value)
{
    uint32_t VREF122Sample, VPTAT, VPTAT_30;
    uint64_t TSSample;
    float GetTS; 
    VREF122Sample = GetVREF1P2Sample();
    TSSample = GetTSSample();
    VPTAT = (TSSample * 3000 * (ADC_VREF))/(VREF122Sample * 4095);
    VPTAT_30 = (ADC_TS * 3000)/(4095);
    GetTS =  (float)(VPTAT * 1.0 - VPTAT_30 * 1.0)/(2.97) + 30 - 2;
    return GetTS;
}



//ָADCͨвת
/*********************************************************************************
Name:ADC_Convert
Purpose:convert the speciese channel and obtain the convert data
Paramenters:channel:LEAK_ALARM_CHANNEL/PWRCHK_CHANNEL/VALCHK_CHANNEL/CT_B_CHANNEL/CT_A_CHANNEL/RTC_CAL_CHANNEL
            adc_value:the point to get convert result
Return:SUCCESS/ERROR
*********************************************************************************/

INT16 AD_Scan(INT32U channel, INT16U* adc_value)
{
    uint16_t ADCRdresult;
    switch(channel)
    {
        case VALCHK:
            ADC_CHER->Bits.ECH2 = 1;                        //ʹⲿͨ2
            break;
        case LEAK_ALARM:
            ADC_CHER->Bits.ECH3 = 1;                        //ʹⲿͨ3
            break;
        case CT_A:
            ADC_CHER->Bits.ECH6 = 1;                        //ʹⲿͨ6
            break;
        case PWRCHK:
            ADC_CHER->Bits.ECH10 = 1;                       //ʹⲿͨ10
            break;
        case CT_B:
            ADC_CHER->Bits.ECH13 = 1;                       //ʹⲿͨ13
            break;
        default:
            return 0;   //ERROR
    }
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADC_CR1->Bits.ADEN = 1;                                 //ADC
    ADC_CR1->Bits.SWTRIG = 1;                               //ʼת
    while(ADC_ISR->Bits.EOC == 0);                          //ȴת
    ADC_ISR->Bits.EOC = 1;                                  //ת־
    ADCRdresult = ADC_DR->Bits.DATA;                        //ȡֵ
    ADC_CR1->Bits.ADEN = 0;                                 //رADC
    switch(channel)
    {
        case VALCHK:
            ADC_CHER->Bits.ECH2 = 0;                        //رⲿͨ2
            break;
        case LEAK_ALARM:
            ADC_CHER->Bits.ECH3 = 0;                        //رⲿͨ3
            break;
        case CT_A:
            ADC_CHER->Bits.ECH6 = 0;                        //رⲿͨ6
            break;
        case PWRCHK:
            ADC_CHER->Bits.ECH10 = 0;                       //رⲿͨ10
            break;
        case CT_B:
            ADC_CHER->Bits.ECH13 = 0;                       //رⲿͨ13
            break;
    }
    *adc_value = (ADCRdresult * 3000 * (ADC_VREF))/(VREF122Sample * 4095);
    return 1;   //SUCCESS;
}



void ADC_IRQHandler(void)
{
    if(ADC_ISR->Bits.EOC == 1)
    {
        ADC_ISR->Bits.EOC = 1;
        ADCComplete = 1;
    }
}


void ADC_EnableIT_EndOfConversion(void)
{
    ADC_IER->Bits.EOCIE = 1;
}


void ADC_DisableIT_EndOfConversion(void)
{
    ADC_IER->Bits.EOCIE = 0;
}