#ifndef _ADC_H
#define _ADC_H

/* Includes ------------------------------------------------------------------*/
#include "fm33xx.h"
#include "HAL_LIB.h"


#define ADC_VREF    (*((uint16_t *)(0x1FFFFB08)))           // 30℃ vref1.22采样值
#define ADC_TS      (*((uint16_t *)(0x1FFFFa92)))           // 30℃ PTAT采样值

#define CT_A                6
#define CT_B                13
#define VALCHK              2
#define LEAK_ALARM          3
#define PWRCHK              10


//CT_A  ADC_IN6  PC7
#define CT_A_ADCIN          {GPIOC_INEN->Bits.PIN7 = 0; GPIOC_ODEN->Bits.PIN7 = 0; GPIOC_PUEN->Bits.PIN7 = 0; GPIOC_FCR->Bits.P7FCR = 3;}

//CT_B  ADC_IN13  PC8
#define CT_B_ADCIN          {GPIOC_INEN->Bits.PIN8 = 0; GPIOC_ODEN->Bits.PIN8 = 0; GPIOC_PUEN->Bits.PIN8 = 0; GPIOC_FCR->Bits.P8FCR = 3;}

//VALCHK  ADC_IN2  PD3
#define VALCHK_ADCIN        {GPIOD_INEN->Bits.PIN3 = 0; GPIOD_ODEN->Bits.PIN3 = 0; GPIOD_PUEN->Bits.PIN3 = 0; GPIOD_FCR->Bits.P3FCR = 3;}

//LEAK_ALARM  ADC_IN3  PD5
#define LEAK_ALARM_ADCIN    {GPIOD_INEN->Bits.PIN5 = 0; GPIOD_ODEN->Bits.PIN5 = 0; GPIOD_PUEN->Bits.PIN5 = 0; GPIOD_FCR->Bits.P5FCR = 3;}

//PWRCHK  ADC_IN10  PD6
#define PWRCHK_ADCIN        {GPIOD_INEN->Bits.PIN6 = 0; GPIOD_ODEN->Bits.PIN6 = 0; GPIOD_PUEN->Bits.PIN6 = 0; GPIOD_FCR->Bits.P6FCR = 3;}




#define RTC_CAL_CHANNEL    0






#define AD_CHANNEL_SA       ADC1_CHANNEL_10   //PC00   ADIN10
#define ADC1_CHANNEL_10     10

#define AD_CHANNEL_SB       ADC1_CHANNEL_12   //PC02   ADIN12
#define ADC1_CHANNEL_12     12



#define VALCHK_CHANNEL     ADC1_CHANNEL_13   //PC03   ADIN13
#define ADC1_CHANNEL_13    13

#if NBIOT_HARDWARE

#if(LI_BATTERY_ENABLE)
#define AD_CHANNEL_POWER     ADC1_CHANNEL_1
#define ADC1_CHANNEL_1     ((uint32_t)0x00000002)

#else
#define AD_CHANNEL_POWER     ADC1_CHANNEL_6  //PA06   ADIN6
#define ADC1_CHANNEL_6       6
#endif

#define AD_CHANNEL_LEAK_ALARM ADC1_CHANNEL_4 //PA04   ADIN4
#define ADC1_CHANNEL_4     4

#define AD_CHANNEL_SLANT      ADC1_CHANNEL_8//PB0
#define ADC1_CHANNEL_8     ((uint32_t)0x00000100)
#else
#define AD_CHANNEL_POWER     ADC1_CHANNEL_1
#define ADC1_CHANNEL_1     ((uint32_t)0x00000002)

#define AD_CHANNEL_LEAK_ALARM ADC1_CHANNEL_8
#define ADC1_CHANNEL_8     ((uint32_t)0x00000100)
#endif

#if HW_Li_3V	
	#define AD_CHANNEL_VREFINT     ADC1_CHANNEL_3  //PA3
	#define ADC1_CHANNEL_3     ((uint32_t)0x00000008)
#else
	#define AD_CHANNEL_VREFINT    ADC1_CHANNEL_17
	#define ADC1_CHANNEL_17    ((uint32_t)0x00020000)
#endif
typedef struct
{
  volatile uint16_t ADC_SAData;
  volatile uint16_t ADC_SBData;
  volatile uint16_t ADC_VALCHKData;
  volatile uint16_t ADC_RTCCALData;
  volatile uint16_t ADC_PWRCHKData;
  volatile uint16_t ADC_LEAKALData;
}ADC_ConvertData;


void ADC_Calibration(void);

INT16 AD_Scan(INT32U channel,INT16U* adc_value);
#endif