/* Includes ------------------------------------------------------------------*/
#include "I2C.h"

//IOģIICӿ


//void I2CInit(void)
//{

//    
//    
//}


//INT16 I2CSendByte(uint8_t data)
//{
//    
//}

//void I2CStart(void)
//{
//    
//}

//void I2CStop(void)
//{
//    
//}


//ӲIICӿ

//#define I2CPINREMAP      //ndef:I2C_SCL=PA11 I2C_SDA=PA12  def:I2C_SCL=PB15 I2C_SDA=PD12

#define     I2CREAD             1                                               //I2C
#define     I2CWRITE            0                                               //I2Cд

#define     STARTBIT            0
#define     RESTARTBIT          1
#define     STOPBIT             2

#define     DEVICE_EE256        0xA0                                            //FM24C256豸ַ
#define     ADDRLEN_EE256       2                                               //FM24C256ݵַΪ2ֽ




uint8_t I2C_Send_Bit(uint8_t BIT_def)
{
    switch(BIT_def)
    {
        case STARTBIT:
            I2C_MSPCR->Bits.SEN = 1;
            while(I2C_MSPISR->Bits.S == 0);
            break;
        case RESTARTBIT:
            I2C_MSPCR->Bits.RSEN = 1;
            while(I2C_MSPISR->Bits.S == 0);
            break;
        case STOPBIT:
            I2C_MSPCR->Bits.PEN = 1;
            while(I2C_MSPISR->Bits.P == 0);
            break;
        default: return 1;
    }
    return 0;                                                                   //success
}




uint8_t I2C_Send_Byte(uint8_t x_byte)
{
    I2C_MSPBUF->Bits.MSPBUF = x_byte;
    while(I2C_MSPISR->Bits.TXIF == 0)                                           //ȴжϱ־
    I2C_MSPISR->Bits.TXIF = 1;                                                  //㷢жϱ־
    if(I2C_MSPISR->Bits.ACKSTA == 0)                                            //Ӧź
    {
        return 1;                                                               //յACK
    }
    else
    {
        I2C_MSPISR->Bits.ACKSTA = 1;
        return 0;                                                               //յNACK
    }
}

uint8_t I2C_Receive_Byte(uint8_t *x_byte)
{
    I2C_MSPCR->Bits.RCEN = 1;                                                   //ʹܽ
    while(I2C_MSPISR->Bits.RXIF == 0);                                          //ȴжϱ־
    I2C_MSPISR->Bits.RXIF = 1;                                                  //жϱ־
    *x_byte = I2C_MSPBUF->Bits.MSPBUF;
    return 0;
}


uint8_t Sendaddr(uint8_t DeviceAddr, uint16_t Addr, uint8_t AddrLen, uint8_t Opt)
{
    uint8_t status;
    
    /*-------------- start bit ---------------*/
    status = I2C_Send_Bit(STARTBIT);                                            //ʼλ
    if(status != 0)return 1;                                                    //failure
    
    /*-------------- disable read ------------*/
    I2C_MSPCR->Bits.RCEN = 0;                                                   //رս
    
    /*-------------- device addr -------------*/
    status = I2C_Send_Byte(DeviceAddr);                                          //豸ַ
    if(status != 0)return 2;                                                    //failure

    /*--------------- data addr --------------*/
    if(AddrLen == 2)
    {
        status = I2C_Send_Byte(Addr >> 8);                                      //ݵַ8λ
        if(status != 0)return 3;                                                //failure
    }
    status = I2C_Send_Byte( Addr>>0 ); //ݵַ8λ
    if(status != 0)return 3;                                                    //failure

    if(Opt == I2CREAD)                                                          //
    {
        status = I2C_Send_Bit(RESTARTBIT);                                      //ʼλ
        if(status != 0) return 5;                                               //failure
        status = I2C_Send_Byte(DeviceAddr | 1U); //ַ
        if(status != 0) return 5;                                               //failure
    }
    return 0;                                                                   //success
}




uint8_t Wait_for_end(uint8_t DeviceAddr)
{
    uint8_t status;
    
    SysTick->LOAD = 0x1000000-1;
    SysTick->VAL = 0; 
    Do_DelayStart();                                                            //Ҫ5msڲд, ѭһʱ: 42Delay()
    {
        I2C_Send_Bit(STARTBIT);                                                 //ʼλ
        status = I2C_Send_Byte(DeviceAddr);                                     //豸ַ
        I2C_Send_Bit(STOPBIT);                                                  //ֹͣλ
        if(status == 0)return 0;                                                //õַɹ, дڽ
    }While_DelayMsEnd(3000);
    return 1;                                                                   //õַʧ
}




uint8_t I2C_Write_Data(uint8_t Device, uint16_t Addr, uint8_t AddrLen, uint8_t *Buf, uint8_t Len)
{
    uint8_t k, n, status;
    
    if(Len > 128) return 0xFF;                                                  //һ128ֽ
    for(k = 0; k < 3; k++)                                                      //ÿд3
    {
        status = 0;
        if(Sendaddr(Device, Addr, AddrLen, I2CWRITE))
        {
          status = 1;                                                           //дʧ
        }
        else 
        {
            for(n = 0; n < Len; n++)
            {
                if(I2C_Send_Byte(Buf[n]))                                       //һֽ
                {
                  status = 1; 
                  break;                                                        //дʧ
                }
            }
        }
        if(I2C_Send_Bit(STOPBIT))status = 1;                                    //ֹͣλ
        if(status == 0)
        {
            status = Wait_for_end(Device);
            break;
        }                                                                       //дȷ
    }
    return status;
}




uint8_t I2C_Read_Data(uint8_t Device, uint16_t Addr, uint8_t AddrLen, uint8_t *Buf, uint8_t Len)
{
    uint8_t k, n, status;
    
    if(Len > 128)return 0xFF;                                                   //һ128ֽ
    for(k = 0; k < 3; k++)                                                      //ÿ3
    {
        status = 0;
        if(Sendaddr(Device, Addr, AddrLen, I2CREAD))
        {
            status = 1;                                                         //дʧ
        }
        else
        {
            for(n = 0; n < Len; n++)
            {
                if(n < (Len-1))
                    I2C_MSPSR->Bits.ACKMO = 0;                                  //ûطACK:0
                else
                    I2C_MSPSR->Bits.ACKMO = 1;                                  //ûطNACK:1
                //һֽ
                if(I2C_Receive_Byte(Buf+n))
                    {
                        status = 1;
                        break;
                    }
            }
        }
        if(I2C_Send_Bit(STOPBIT))status = 1;                                    //ֹͣλ
        if(status == 0)break;                                                   //ȷ
    }
    return status;
}



void I2C_Init(uint32_t baudRate)
{
    uint32_t I2C_Clk_Freq = 0, BRG = 0;
    
#ifndef I2CPINREMAP
            /* I2C_SCL=PA11 I2C_SDA=PA12 */
            GPIOA_INEN->Bits.PIN11 = 0;                                         //رʹ
            GPIOA_INEN->Bits.PIN12 = 0;
            GPIOA_ODEN->Bits.PIN11 = 1;                                         //©ģʽ(PxODEN=1)
            GPIOA_ODEN->Bits.PIN12 = 1;
            GPIOA_PUEN->Bits.PIN11 = 0;                                         //ر
            GPIOA_PUEN->Bits.PIN12 = 0;
            GPIOA_DFS->Bits.PIN11 = 0;                                          //ض:PxDFS=0
            GPIOA_DFS->Bits.PIN12 = 0;
            GPIOA_FCR->Bits.P11FCR = 2;                                         //Ź:Digital function(0x2)
            GPIOA_FCR->Bits.P12FCR = 2;
#else
            /* I2C_SCL=PB15 I2C_SDA=PD12 */
            GPIOB_INEN->Bits.PIN15 = 0;                                         //رʹ
            GPIOD_INEN->Bits.PIN12 = 0;
            GPIOB_ODEN->Bits.PIN15 = 1;                                         //©ģʽ(PxODEN=1)
            GPIOD_ODEN->Bits.PIN12 = 1;
            GPIOB_PUEN->Bits.PIN15 = 0;                                         //ر
            GPIOD_PUEN->Bits.PIN12 = 0;
            GPIOB_DFS->Bits.PIN15 = 0;                                          //ض:PxDFS=0
            GPIOD_DFS->Bits.PIN12 = 0;
            GPIOB_FCR->Bits.P15FCR = 2;                                         //Ź:Digital function(0x2)
            GPIOD_FCR->Bits.P12FCR = 2;
#endif

    CMU_PCLKCR3->Bits.I2C_PCE = 1;                                              //ʹI2Cʱ
    CMU_OPCCR3->Bits.I2CCKE = 1;                                                //ʹI2Cʱ
    CMU_OPCCR1->Bits.I2CCKS = 0;                                                //ѡI2CʱԴ:APBCLK(0x0U)
    I2C_Clk_Freq = APB_FREQUENCY;                                               //ȡAPBCLKƵ
    /* ҪļĴֵؼĴ */
    BRG = (uint32_t)(I2C_Clk_Freq / (2 * baudRate)) - 1;
    I2C_MSPBGR->Bits.MSPBRGH = BRG;
    I2C_MSPBGR->Bits.MSPBRGL = BRG;
    I2C_MSPTCR->Bits.SDAHD = (uint32_t)(BRG / 2.0 + 0.5);
    I2C_MSPCFGR->Bits.MSPEN = 1;                                                //ʹI2Cģ
}


