/* Includes ------------------------------------------------------------------*/
#include "IWDG.h"



/**
  * @brief  ʼIWDT
  *
  * @param  None
  * @retval None
  */
void IWDT_Init(void)
{
    CMU_PCLKCR1->Bits.IWDT_PCE = 1;                                             //IWDTʱ
    IWDT_CR->Bits.OVP = IWDT_PERIOD_16S;                                        //IWDTʱ
    IWDT_CR->Bits.FREEZE = 0;                                                   //IWDT߶ 0:Sleep/DeepSleepģʽIWDT
//    IWDT_CR->Bits.FREEZE = 1;                                                   //IWDT߶ 1:Sleep/DeepSleepģʽIWDT
    IWDT_WIN->Bits.CNT = 0;                                                     //IWDT幷 12bit
    IWDT_SERV->Bits.SERV = IWDT_RELOAD_KEY;                                     //IWDT
}

/**
  * @brief  IWDT
  *
  * @param  None
  * @retval None
  */
void IWDT_ReloadCounter(void)
{
    IWDT_SERV->Bits.SERV = IWDT_RELOAD_KEY;
}

/**
  * @brief    Set IWDT overflow period
  * 
  * @param    period This parameter can be one of the following values:
  *           @arg @ref IWDT_PERIOD_125MS
  *           @arg @ref IWDT_PERIOD_250MS
  *           @arg @ref IWDT_PERIOD_500MS
  *           @arg @ref IWDT_PERIOD_1S
  *           @arg @ref IWDT_PERIOD_2S
  *           @arg @ref IWDT_PERIOD_4S
  *           @arg @ref IWDT_PERIOD_8S
  *           @arg @ref IWDT_PERIOD_16S
  * @retval   None
  */
void IWDT_SetPeriod(uint32_t period)
{
    IWDT_SERV->Bits.SERV = IWDT_RELOAD_KEY;                                     //IWDT
    IWDT_CR->Bits.OVP = period;                                                 //IWDTʱ
}


/******************************************
Name: IWDG_WriteEnable
Purpose: enable write to IWDG_PR and IWDG_RLR
Parameters: no
Return: no
******************************************/
void IWDG_WriteEnable(void)
{
  
}




/***************************************************************
Name:IWDG_SetPrescaler
Purpose:set the IWDG clock prescaler
Parameters: IWDG_Prescaler_4: IWDG prescaler set to 4
            IWDG_Prescaler_8: IWDG prescaler set to 8
            IWDG_Prescaler_16: IWDG prescaler set to 16
            IWDG_Prescaler_32: IWDG prescaler set to 32
            IWDG_Prescaler_64: IWDG prescaler set to 64
            IWDG_Prescaler_128: IWDG prescaler set to 128
            IWDG_Prescaler_256: IWDG prescaler set to 256
Return: no
***************************************************************/
void IWDG_SetPrescaler(uint8_t IWDG_Prescaler)
{
  
}


/************************************************************
Name:IWDG_SetPeriod
Purpose:set the IWDG reset period
Paramenters:the IWDG_RLR RL is 12 bits,range frome 0 to 0xfff
Return: no
*************************************************************/
void IWDG_SetPeriod(uint16_t IWDG_SetPeriod)
{
  
}




