/* Includes ------------------------------------------------------------------*/
#include "RCC.h"



//ƵʱӣƵϵȲ

/**********************************************************
Name:RCC_SetSysCLK
Purpose:set system clock,AHB/APB1/APB2 clock set FLASH access 
Paramenters:no
Return:no
***********************************************************/
void RCC_SetSysCLK(void)
{
    CMU_RCHCR->Bits.FSEL = 0x1;                             //RCHF=16MHZ
    CMU_RCHCR->Bits.RCHFEN = 1;                             //ʹRCHF
    CMU_RCHTR->Bits.RCHFTRIM = RCHF16M_TRIM;                //д16MHzУ׼ֵ
//    CMU_RCLFCR->Bits.RCLF_PSC = 3;                          //614.4KHz 16Ƶ 38400Hz
//    CMU_RCLFCR->Bits.RCLF_EN = 1;                           //ʹRCLF
    CMU_SYSCLKCR->Bits.SYSCLKSEL = 0;                       //ѡRCHFʱ
    CMU_SYSCLKCR->Bits.STCLKSEL = 0;                        //ѡSCLKںsystickʱ
    CMU_SYSCLKCR->Bits.AHBPRES = 0;                         //AHBƵ
    CMU_SYSCLKCR->Bits.APBPRES = 0;                         //APBƵ
    CMU_SYSCLKCR->Bits.SLP_ENEXTI = 1;                      //Sleep/DeepSleepģʽʹⲿжϲʱΪLSCLK
    CMU_SYSCLKCR->Bits.LSCATS = 1;                          //ʹLSCLKԶл
}



/**
  * @brief  ȡRCHFʱƵ
  * @param  None
  *
  * @retval RCHFʱƵ(Hz)
  *
  */
uint32_t GetRCHFClockFreq(void)
{
    uint32_t frequency = 0;
    switch(CMU_RCHCR->Bits.FSEL)
    {
        case 0x00: frequency = 8000000; break;
        case 0x01: frequency = 16000000; break;
        case 0x02: frequency = 24000000; break;
        case 0x03: frequency = 32000000; break;
        case 0x07: frequency = 40000000; break;
        case 0x0f: frequency = 48000000; break;
        default: frequency = 8000000;
    }
    return frequency;
}



/**
  * @brief  ȡRCLFʱƵ
  * @param  None
  *         
  * @retval RCLFʱƵ(Hz)
  *                 
  */
uint32_t GetRCLFClockFreq(void)
{
    uint32_t frequency = 0;
    
    switch(CMU_RCLFCR->Bits.RCLF_PSC)
    {       
        case 0x00: frequency = 614400; break;       //RCLF_PSC_DIV1:
        case 0x01: frequency = 153600; break;       //RCLF_PSC_DIV4:
        case 0x02: frequency = 76800; break;        //RCLF_PSC_DIV8:
        case 0x03: frequency = 38400; break;        //RCLF_PSC_DIV16:
        default: frequency = 614400;
    }
    return frequency;
}


/*******************************************************************************************************
Name:RCC_GetClocksFreq
Purpose:get the SYSCLK,HCLK,PCLK1,PCLK2
Paramenters:RCC_Clocks:the clock struct
Return:no
********************************************************************************************************/
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks)
{
    RCC_Clocks->SYSCLK_Frequency = 0;
    RCC_Clocks->HCLK_Frequency = 0;
    RCC_Clocks->PCLK1_Frequency = 0;
    
    //ȡϵͳʱSYSCLK
    switch(CMU_SYSCLKCR->Bits.SYSCLKSEL)
    {
        case 0x00:                          //RCHF
            RCC_Clocks->SYSCLK_Frequency = GetRCHFClockFreq();
            break;
        case 0x01:                          //XTHF
            RCC_Clocks->SYSCLK_Frequency = XTHF_VALUE;
            break;
        case 0x02:                          //PLL
            RCC_Clocks->SYSCLK_Frequency = 1000000 * (CMU_PLLCR->Bits.PLLDB + 1);
            break;
        case 0x04:                          //RCLF
            RCC_Clocks->SYSCLK_Frequency = GetRCLFClockFreq();
            break;
        case 0x05:                          //XTLF
            RCC_Clocks->SYSCLK_Frequency = XTLF_VALUE;
            break;
        case 0x06:                          //RCLP
            RCC_Clocks->SYSCLK_Frequency = 32000;
            break;
        default:
            RCC_Clocks->SYSCLK_Frequency = GetRCHFClockFreq();
    }
    //ȡAHBʱ
    switch(CMU_SYSCLKCR->Bits.AHBPRES)
    {
        case 0x04:                          //AHBCLK_PSC_DIV2:
            RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency / 2;
            break;
        case 0x05:                          //AHBCLK_PSC_DIV4:
            RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency / 4;
            break;
        case 0x06:                          //AHBCLK_PSC_DIV8:
            RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency / 8;
            break;
        case 0x07:                          //AHBCLK_PSC_DIV16:
            RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency / 16;
            break;
        default:                            //AHBCLK_PSC_DIV1:
            RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency;
    }
    //ȡAPBʱ
    switch(CMU_SYSCLKCR->Bits.APBPRES)
    {
        case 0x04:                          //AHBCLK_PSC_DIV2:
            RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency / 2;
            break;
        case 0x05:                          //AHBCLK_PSC_DIV4:
            RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency / 4;
            break;
        case 0x06:                          //AHBCLK_PSC_DIV8:
            RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency / 8;
            break;
        case 0x07:                          //AHBCLK_PSC_DIV16:
            RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency / 16;
            break;
        default:                            //AHBCLK_PSC_DIV1:
            RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency;
    }
}



//ϵͳƵͨIO
/****************************************************************************************************
Name:RCC_MCO
Purpose:
Paramenters:
Return:
*****************************************************************************************************/
void RCC_MCO(void)
{
    //FOUT0
    GPIO_FOUTSEL->Bits.FOUT0SEL = 0x0B;         //RCHF=0x0B XTLF=0x00
    GPIOD_INEN->Bits.PIN11 = 0;
    GPIOD_ODEN->Bits.PIN11 = 0;
    GPIOD_PUEN->Bits.PIN11 = 0;
    GPIOD_DFS->Bits.PIN11 = 0;
    GPIOD_FCR->Bits.P11FCR = 2;
    
//    //FOUT1
//    GPIO_FOUTSEL->Bits.FOUT1SEL = 0x00;         //XTLF
//    GPIOB_INEN->Bits.PIN12 = 0;
//    GPIOB_ODEN->Bits.PIN12 = 0;
//    GPIOB_PUEN->Bits.PIN12 = 0;
//    GPIOB_DFS->Bits.PIN12 = 0;
//    GPIOB_FCR->Bits.P12FCR = 2;
}

