#ifndef _RTC_H
#define _RTC_H

/* Includes ------------------------------------------------------------------*/
#include "fm33xx.h"
#include <string.h>


typedef struct DateTime
{
    uint8_t Year[2];                     //BCD
    uint8_t Month;
    uint8_t Day;
    uint8_t Hour;
    uint8_t Minute;
    uint8_t Second;
}DATETIME;


typedef struct
{
    uint8_t sec;
    uint8_t sec_msk;
    uint8_t min;
    uint8_t min_msk;
    uint8_t hour;
    uint8_t hour_msk;
    uint8_t day;
    uint8_t day_msk;
    uint8_t week_sel;
}RTC_Alarm_TypeDef;


//RTC 仯ر־
typedef union _RTC_FLAG
{
    struct
    {
        uint8_t sec:1;                  //
        uint8_t min:1;                  //
        uint8_t hour:1;                 //ʱ
        uint8_t day:1;                  //
        uint8_t rtcDay:1;               //
        uint8_t month:1;                //
        uint8_t year:1;                 //
        uint8_t setHourChg1:1;          //
    }bits;
    uint8_t all;
}RTC_FLAG;


void Disable_RTCWrite(void);
void Enable_RTCWrite(void);
INT16 RTC_WaitForSynchro(void);
void RTC_Reset(uint8_t NewState);
void Enable_LSE(void);
void RTC_SetTime(DATETIME * Calendar_Point);
void RTC_ReadTime(DATETIME* rtcTime);
int16_t RTC_GetDateTime(DATETIME * Calendar_Point);

void RTC_SetAlarm(uint32_t RTC_alarm,RTC_Alarm_TypeDef * Alarm_struct);
void RTC_EnableCount(void);
void RTC_AlarmITEnable(uint32_t RTC_alarm);
void RTC_InitCalendar(DATETIME * Calendar_Point);
void RTC_WakeupEN(void);
void RTC_WakeupInterruptEN(void);
void RTC_WakeupInit(int16_t period);
BOOL setSysTick(INT16 SysWakeInterval);
void SetRTCCalibration(INT8U RTC_Plus_set,INT16U RTC_Cal);
void RTCWakeup(void);
#if (RTC_LSE_SWITCH)
void RTCClockRecover(void);
void RTCLSEToLSI(void);
#endif

#endif
