/* Includes ------------------------------------------------------------------*/
#include "U7816.h"

void U7816_Init(void)
{
    uint32_t Fclk;
    uint32_t tmpClkdiv;
    
    /* 7816 */
    GPIOC_INEN->Bits.PIN13 = 0;                             //رʹ
    GPIOC_INEN->Bits.PIN14 = 0;
    GPIOC_ODEN->Bits.PIN13 = 0;                             //ģʽ  0: 1:©
    GPIOC_ODEN->Bits.PIN14 = 0;
    GPIOC_PUEN->Bits.PIN13 = 0;                             //ر
    GPIOC_PUEN->Bits.PIN14 = 0;
    GPIOC_DFS->Bits.PIN13 = 0;                              //ֹѡ 0
    GPIOC_DFS->Bits.PIN14 = 0;
    GPIOC_FCR->Bits.P13FCR = 2;                             //Źѡ 2:Digital function
    GPIOC_FCR->Bits.P14FCR = 2;
    /* E-RST */
    E_RST_OUT;
    /* E-POW */
    E_POW_OUT;
    /* 7816 */
    CMU_PCLKCR3->Bits.U7816_PCE = 1;                        //ʹ7816ʱ
    U7816_FFR->Bits.PAR = 0;                                //Уλ 0:Even 1:Odd
    U7816_FFR->Bits.REP_T = 0;                              //żУʱԶط 0:1 1:3
    U7816_FFR->Bits.TREPEN = 1;                             //յżУ־(error signal)Զлط
    U7816_FFR->Bits.SFREN = 0;                              //Guard timeΪ2etu
    U7816_FFR->Bits.RFREN = 0;                              //Guard timeΪ2etu
    U7816_FFR->Bits.ERSGD = 1;                              //ERROR SIGNALGUARDTIMEΪ1~1.5ETU
    U7816_EGTR->Bits.TXEGT = 0;                             //ʱĶⱣʱΪ0
    U7816_FFR->Bits.RREPEN = 1;                             //żУԶط
    U7816_FFR->Bits.ERSW = 1;                               //ERROR SIGNALΪ2etu
    U7816_FFR->Bits.DICONV = 0;                             //,շLSB
    U7816_PSC->Bits.CLKDIV = APB_FREQUENCY / 4000000 - 1;   //U7816ʱ
    U7816_BGR->Bits.PDIV = (372-1);                         //372ETUͨŲ
    U7816_CR->Bits.HPUEN = 1;                               //ͨǿʹ
    U7816_FFR->Bits.BGTEN = 0;                              //պͷ֮䲻BGT
    U7816_CR->Bits.CKOEN = 1;                               //ʹU7816ʱ
}



void Delay_Netu(uint8_t Num)                                //Num*1etu
{
    DelayUs(93 * Num);                                      //1etu=93us(4M),1etu=186us(2M)
}



//λӦʱΪ400/f~40000/f100us~10ms
//ֵ: 1Ϊ½; 0Ϊޱ仯
uint8_t Judge_Edge(void)
{
    uint32_t i;

    Delay_Netu(1);
    for(i=0x00; i<100; i++ )                                //Լ10ms(4M),20ms(2M)
    {
        if(U7816_ISR->Bits.RXBUSY == 1)                     //ڽ
        {
            return 1;
        }
        Delay_Netu(1);
    }
    return 0;
}



//ʱӦΪ9600etu,ĿǰΪ9600etu,1etu=93us
uint8_t Get_7816_Char(uint8_t *Data)
{
    uint32_t i;

    for(i=0; i<10000; i++)                                  //Լ900ms(4M),1800ms(2M)
    {
        Delay_Netu(1);
        if(U7816_ISR->Bits.RXIF == 1)                       //RX_FLAGѾλ
        {
            *Data = U7816_RXBUF->Bits.RXBUF;
            return 1;                                       //ɹ
        }
        if(U7816_ISR->Bits.ERRIF == 1)                      //ERROR_FLAGѾλ
        {
            U7816_ISR->Bits.TPARERR = 1;
            U7816_ISR->Bits.RPARERR = 1;
            U7816_ISR->Bits.FRERR = 1;
            U7816_ISR->Bits.OVERR = 1;
            return 0;                                       //error
        }
    }
    return 0;
}



uint8_t Snd_7816_Byte(uint8_t Data)
{
    uint32_t i;

    Delay_Netu(2);                                          //ʱ1etu,֤豸ȶ
    U7816_TXBUF->Bits.TXBUF = Data;
    for(i=0; i<400; i++)                                    //Լ39ms(4M),78ms(2M)
    {
        Delay_Netu(1);
        if(U7816_ISR->Bits.TXIF == 1)                       //TX_FLAGλ
        {
            return 1;                                       //ɹ
        }
        if(U7816_ISR->Bits.ERRIF == 1)                      //ERROR_FLAGѾλ
        {
            U7816_ISR->Bits.TPARERR = 1;
            U7816_ISR->Bits.RPARERR = 1;
            U7816_ISR->Bits.FRERR = 1;
            U7816_ISR->Bits.OVERR = 1;
            return 0;                                       //error
        }
    }
    return 0;
}



//㼤&临λ
//⵽, RSTõ͵ƽ, VCCϵ, ʱһʱ, IOΪ̬, CLKʱź(T0ʱ)
//T040000~45000CLK, RSTΪߵƽ(T1ʱ), T1400~40000CLK, λӦӦÿʼ, 
//ICĸλӦûڴʱڿʼ, ն˽ͷʱ.յλӦ, Э淶, Ҫȸλ
uint8_t ColdReset(void)
{
    uint8_t n, Result, Temp_ATR;                            // T0, TD1, TD2;
    uint8_t CardRst8B[13];                                  //CARDλϢк13ֽ

    DelayMs(100);                                           //ʱ100ms
    U7816_CR->Bits.TXEN = 1;
    U7816_CR->Bits.RXEN = 1;
    U7816_CR->Bits.CKOEN = 1;
/*--------------------------------------------------------------*/
    Result = U7816_RXBUF->Bits.RXBUF;                       //RX, rx_flag=1, ͨȡRXBUF˱־.
    U7816_ISR->Bits.TPARERR = 1;
    U7816_ISR->Bits.RPARERR = 1;
    U7816_ISR->Bits.FRERR = 1;
    U7816_ISR->Bits.OVERR = 1;
    E_RST_ON;                                               //RST͵ƽ
    //RSTʱ䱣40000~45000CLK;4MƵӦñֲ10ms;
    DelayMs(11);//ȴRSTʱ,400,100us
    //-------- T1ʱ, RSTߵƽ --------
    E_RST_OFF;
    //λɺ,֮ǰIOƽȶ,
    //λ400~40000CLKATR
    Result = Judge_Edge();                                  //40000CLKڲ鿴IOڵĵƽر仯
    if(Result == 0)                                         //IOûг½
    {
        return 2;                                           //쳣: 40000CLKûյʼλ
    }
    for(n=0; n<13; n++)
    {
        Result = Get_7816_Char(&Temp_ATR);                  //receive TS.
        if(Result != 1)
        { 
            return 3;
        }
        CardRst8B[n] = Temp_ATR;
    }
    if(CardRst8B[0] != 0x3B)
    {
        return 3;
    }
    return 0;
}

