/* Includes ------------------------------------------------------------------*/
#include "Uart.h"

/********************************************************************************
Name:OpenLPUART
Purpose:configure the usart baudrat,stopbit,wordlength,mode and so on
Paramenters:USART_strt: the USART struct contain such as bandrate stopbit check
Return:no
*********************************************************************************/
BOOL OpenUart(UART_FORMAT* USART_strt)
{
    BOOL status = FALSE;
    uint16_t MCTLVel, bandrate = 0;
    CMU_PCLKCR1->Bits.PAD_PCE = 1;                          //PAD(GPIO)ʱʹ
    /* LPUARTֵת */
    if(USART_strt->UARTID == LPUART_0 || USART_strt->UARTID == LPUART_1)
    {
        switch(USART_strt->BaudRate)
        {
            case 9600: bandrate = 0; MCTLVel = 0x0552; break;
            case 4800: bandrate = 1; MCTLVel = 0x1EFB; break;
            case 2400: bandrate = 2; MCTLVel = 0x16DB; break;
            case 1200: bandrate = 3; MCTLVel = 0x0492; break;
            case 600: bandrate = 4; MCTLVel = 0x16D6; break;
            case 300: bandrate = 5; MCTLVel = 0x0842; break;
            default: bandrate = 0; MCTLVel = 0x0552;
        }
    }
    switch(USART_strt->UARTID)
    {
        case LPUART_0:
            GPIOA_INEN->Bits.PIN13 = 0;                     //رʹ
            GPIOA_INEN->Bits.PIN14 = 0;
            GPIOA_ODEN->Bits.PIN13 = 0;                     //ģʽ  0: 1:©
            GPIOA_ODEN->Bits.PIN14 = 0;
            GPIOA_PUEN->Bits.PIN13 = 1;                     //RXʹ
            GPIOA_PUEN->Bits.PIN14 = 0;                     //TXر
            GPIOA_DFS->Bits.PIN13 = 1;                      //ֹѡ 0:UART 1:LPUART
            GPIOA_DFS->Bits.PIN14 = 1;
            GPIOA_FCR->Bits.P13FCR = 2;                     //Źѡ 2:Digital function
            GPIOA_FCR->Bits.P14FCR = 2;
            CMU_PCLKCR3->Bits.LPUART0_PCE = 1;              //LPUART0ʱ
            CMU_OPCCR3->Bits.LPU0CKE = 1;                   //LPUART0ʱ
            CMU_OPCCR1->Bits.LPUART0CKS = 0;                //ѡLPUART0ʱ 0:LSCLK
            LPUART0_BMR->Bits.MCTL_EN = 1;                  //ʹܲʵ
            LPUART0_BMR->Bits.MCTL = MCTLVel;               //ݲMCTLֵ
            LPUART0_CSR->Bits.TXEN = 1;                     //ʹܷ
            LPUART0_CSR->Bits.RXEN = 1;                     //ʹܽ
            LPUART0_BMR->Bits.BAUD = bandrate;              //ò
            LPUART0_CSR->Bits.STOPCFG = 0;                  //ֹͣλ 1λ
            LPUART0_CSR->Bits.PDSEL = 1;                    //λ 8λ
            LPUART0_CSR->Bits.PARITY = 0;                   //Уλ 
            if(USART_strt->RXNEIE)                          //ýж
            {
                LPUART0_ISR->Bits.RXBF = 1;                 //жϱ־
                LPUART0_IER->Bits.RXBF_IE = 1;              //ʹܽж
            }
            else
            {
                LPUART0_IER->Bits.RXBF_IE = 0;              //ֹж
            }
            /* ûж */
            LPUART0_CSR->Bits.RXEV = 3;                     //RXD½ػ
            LPUART0_ISR->Bits.RXEVF = 1;                    //ջ¼־
            LPUART0_IER->Bits.RXEV_IE = 1;                  //ʹܽջ¼ж
            status = TRUE;
            break;
        case LPUART_1:
            GPIOC_INEN->Bits.PIN2 = 0;                      //رʹ
            GPIOC_INEN->Bits.PIN3 = 0;
            GPIOC_ODEN->Bits.PIN2 = 0;                      //ģʽ  0: 1:©
            GPIOC_ODEN->Bits.PIN3 = 0;
            GPIOC_PUEN->Bits.PIN2 = 1;                      //RXʹ
            GPIOC_PUEN->Bits.PIN3 = 0;                      //TXر
            GPIOC_DFS->Bits.PIN2 = 1;                       //ֹѡ 0:UART 1:LPUART
            GPIOC_DFS->Bits.PIN3 = 1;
            GPIOC_FCR->Bits.P2FCR = 2;                      //Źѡ 2:Digital function
            GPIOC_FCR->Bits.P3FCR = 2;
            CMU_PCLKCR3->Bits.LPUART1_PCE = 1;              //LPUART1ʱ
            CMU_OPCCR3->Bits.LPU1CKE = 1;                   //LPUART1ʱ
            CMU_OPCCR1->Bits.LPUART1CKS = 0;                //ѡLPUART1ʱ 0:LSCLK
            LPUART1_BMR->Bits.MCTL_EN = 1;                  //ʹܲʵ
            LPUART1_BMR->Bits.MCTL = MCTLVel;               //ݲMCTLֵ
            LPUART1_CSR->Bits.TXEN = 1;                     //ʹܷ
            LPUART1_CSR->Bits.RXEN = 1;                     //ʹܽ
            LPUART1_BMR->Bits.BAUD = bandrate;              //ò
            LPUART1_CSR->Bits.STOPCFG = 0;                  //ֹͣλ 1λ
            LPUART1_CSR->Bits.PDSEL = 1;                    //λ 8λ
            LPUART1_CSR->Bits.PARITY = 0;                   //Уλ 
            if(USART_strt->RXNEIE)                          //ýж
            {
                LPUART1_ISR->Bits.RXBF = 1;                 //жϱ־
                LPUART1_IER->Bits.RXBF_IE = 1;              //ʹܽж
            }
            else
            {
                LPUART1_IER->Bits.RXBF_IE = 0;              //ֹж
            }
            /* ûж */
            LPUART1_CSR->Bits.RXEV = 3;                     //RXD½ػ
            LPUART1_ISR->Bits.RXEVF = 1;                    //ջ¼־
            LPUART1_IER->Bits.RXEV_IE = 1;                  //ʹܽջ¼ж
            status = TRUE;
            break;
        case UART_0:
            GPIOA_INEN->Bits.PIN13 = 0;                     //رʹ
            GPIOA_INEN->Bits.PIN14 = 0;
            GPIOA_ODEN->Bits.PIN13 = 0;                     //ģʽ  0: 1:©
            GPIOA_ODEN->Bits.PIN14 = 0;
            GPIOA_PUEN->Bits.PIN13 = 1;                     //RXʹ
            GPIOA_PUEN->Bits.PIN14 = 0;                     //TXر
            GPIOA_DFS->Bits.PIN13 = 0;                      //ֹѡ 0:UART 1:LPUART
            GPIOA_DFS->Bits.PIN14 = 0;
            GPIOA_FCR->Bits.P13FCR = 2;                     //Źѡ 2:Digital function
            GPIOA_FCR->Bits.P14FCR = 2;
            CMU_PCLKCR3->Bits.UART0_PCE = 1;                //UART0ʱ
            CMU_OPCCR3->Bits.UART0CKE = 1;                  //UART0ʱ
            CMU_OPCCR1->Bits.UART0CKS = 1;                  //ѡUART0ʱ 1:RCHF
            UART0_CSR->Bits.TXEN = 1;                       //ʹܷ
            UART0_CSR->Bits.RXEN = 1;                       //ʹܽ
            UART0_BGR->Bits.SPBRG = ((float)RCHF_FREQUENCY/USART_strt->BaudRate + 0.5) - 1;     //ò
            UART0_CSR->Bits.STOPCFG = 0;                    //ֹͣλ 1λ
            UART0_CSR->Bits.PDSEL = 1;                      //λ 8λ
            UART0_CSR->Bits.PARITY = 0;                     //Уλ 
            if(USART_strt->RXNEIE)                          //ýж
            {
                UART0_ISR->Bits.RXBF = 1;                   //жϱ־
                UART0_IER->Bits.RXBF_IE = 1;                //ʹܽж
            }
            else
            {
                UART0_IER->Bits.RXBF_IE = 0;                //ֹж
            }
            status = TRUE;
            break;
        case UART_1:
            GPIOC_INEN->Bits.PIN2 = 0;                      //رʹ
            GPIOC_INEN->Bits.PIN3 = 0;
            GPIOC_ODEN->Bits.PIN2 = 0;                      //ģʽ  0: 1:©
            GPIOC_ODEN->Bits.PIN3 = 0;
            GPIOC_PUEN->Bits.PIN2 = 1;                      //RXʹ
            GPIOC_PUEN->Bits.PIN3 = 0;                      //TXر
            GPIOC_DFS->Bits.PIN2 = 0;                       //ֹѡ 0:UART 1:LPUART
            GPIOC_DFS->Bits.PIN3 = 0;
            GPIOC_FCR->Bits.P2FCR = 2;                      //Źѡ 2:Digital function
            GPIOC_FCR->Bits.P3FCR = 2;
            CMU_PCLKCR3->Bits.UART1_PCE = 1;                //UART1ʱ
            CMU_OPCCR3->Bits.UART1CKE = 1;                  //UART1ʱ
            CMU_OPCCR1->Bits.UART1CKS = 1;                  //ѡUART1ʱ 1:RCHF
            UART1_CSR->Bits.TXEN = 1;                       //ʹܷ
            UART1_CSR->Bits.RXEN = 1;                       //ʹܽ
            UART1_BGR->Bits.SPBRG = ((float)RCHF_FREQUENCY/USART_strt->BaudRate + 0.5) - 1;     //ò
            UART1_CSR->Bits.STOPCFG = 0;                    //ֹͣλ 1λ
            UART1_CSR->Bits.PDSEL = 1;                      //λ 8λ
            UART1_CSR->Bits.PARITY = 0;                     //Уλ 
            if(USART_strt->RXNEIE)                          //ýж
            {
                UART1_ISR->Bits.RXBF = 1;                   //жϱ־
                UART1_IER->Bits.RXBF_IE = 1;                //ʹܽж
            }
            else
            {
                UART1_IER->Bits.RXBF_IE = 0;                //ֹж
            }
            status = TRUE;
            break;
        }
    return status;
}



//9600ʴ򿪴ڣжʹܣ
BOOL OpenDefaultUart(BYTE uartId)
{
    BOOL status = FALSE;
    CMU_PCLKCR1->Bits.PAD_PCE = 1;                          //PAD(GPIO)ʱʹ
    switch(uartId)
    {
        case LPUART_0:
            GPIOA_INEN->Bits.PIN13 = 0;                     //رʹ
            GPIOA_INEN->Bits.PIN14 = 0;
            GPIOA_ODEN->Bits.PIN13 = 0;                     //ģʽ  0: 1:©
            GPIOA_ODEN->Bits.PIN14 = 0;
            GPIOA_PUEN->Bits.PIN13 = 1;                     //ʹ
            GPIOA_PUEN->Bits.PIN14 = 1;
            GPIOA_DFS->Bits.PIN13 = 1;                      //ֹѡ 0:UART 1:LPUART
            GPIOA_DFS->Bits.PIN14 = 1;
            GPIOA_FCR->Bits.P13FCR = 2;                     //Źѡ 2:Digital function
            GPIOA_FCR->Bits.P14FCR = 2;
            CMU_PCLKCR3->Bits.LPUART0_PCE = 1;              //LPUART0ʱ
            CMU_OPCCR3->Bits.LPU0CKE = 1;                   //LPUART0ʱ
            CMU_OPCCR1->Bits.LPUART0CKS = 0;                //ѡLPUART0ʱ 0:LSCLK
            LPUART0_BMR->Bits.MCTL_EN = 1;                  //ʹܲʵ
            LPUART0_BMR->Bits.MCTL = 0x0552;                //ݲMCTLֵ
            do
            {
                LPUART0_CSR->Bits.TXEN = 1;                 //ʹܷ
            }while(LPUART0_CSR->Bits.TXEN == 0);
            do
            {
                LPUART0_CSR->Bits.RXEN = 1;                 //ʹܽ
            }while(LPUART0_CSR->Bits.RXEN == 0);
            LPUART0_BMR->Bits.BAUD = 0;                     //:9600
            LPUART0_CSR->Bits.STOPCFG = 0;                  //ֹͣλ 1λ
            LPUART0_CSR->Bits.PDSEL = 1;                    //λ 8λ
            LPUART0_CSR->Bits.PARITY = 0;                   //Уλ 
            LPUART0_ISR->Bits.RXBF = 1;                     //жϱ־
            LPUART0_IER->Bits.RXBF_IE = 1;                  //ʹܽж
            /* ж */
            LPUART0_CSR->Bits.RXEV = 3;                     //RXD½ػ
            LPUART0_ISR->Bits.RXEVF = 1;                    //ջ¼־
            LPUART0_IER->Bits.RXEV_IE = 1;                  //ʹܽջ¼ж
            status = TRUE;
            break;
        case LPUART_1:
            GPIOC_INEN->Bits.PIN2 = 0;                      //رʹ
            GPIOC_INEN->Bits.PIN3 = 0;
            GPIOC_ODEN->Bits.PIN2 = 0;                      //ģʽ  0: 1:©
            GPIOC_ODEN->Bits.PIN3 = 0;
            GPIOC_PUEN->Bits.PIN2 = 1;                      //ʹ
            GPIOC_PUEN->Bits.PIN3 = 1;
            GPIOC_DFS->Bits.PIN2 = 1;                       //ֹѡ 0:UART 1:LPUART
            GPIOC_DFS->Bits.PIN3 = 1;
            GPIOC_FCR->Bits.P2FCR = 2;                      //Źѡ 2:Digital function
            GPIOC_FCR->Bits.P3FCR = 2;
            CMU_PCLKCR3->Bits.LPUART1_PCE = 1;              //LPUART1ʱ
            CMU_OPCCR3->Bits.LPU1CKE = 1;                   //LPUART1ʱ
            CMU_OPCCR1->Bits.LPUART1CKS = 0;                //ѡLPUART1ʱ 0:LSCLK
            LPUART1_BMR->Bits.MCTL_EN = 1;                  //ʹܲʵ
            LPUART1_BMR->Bits.MCTL = 0x0552;                //ݲMCTLֵ
            do
            {
                LPUART1_CSR->Bits.TXEN = 1;                 //ʹܷ
            }while(LPUART1_CSR->Bits.TXEN == 0);
            do
            {
                LPUART1_CSR->Bits.RXEN = 1;                 //ʹܽ
            }while(LPUART1_CSR->Bits.RXEN == 0);
            LPUART1_BMR->Bits.BAUD = 0;                     //:9600
            LPUART1_CSR->Bits.STOPCFG = 0;                  //ֹͣλ 1λ
            LPUART1_CSR->Bits.PDSEL = 1;                    //λ 8λ
            LPUART1_CSR->Bits.PARITY = 0;                   //Уλ 
            LPUART1_ISR->Bits.RXBF = 1;                     //жϱ־
            LPUART1_IER->Bits.RXBF_IE = 1;                  //ʹܽж
            /* ж */
            LPUART1_CSR->Bits.RXEV = 3;                     //RXD½ػ
            LPUART1_ISR->Bits.RXEVF = 1;                    //ջ¼־
            LPUART1_IER->Bits.RXEV_IE = 1;                  //ʹܽջ¼ж
            status = TRUE;
            break;
        case UART_0:
            GPIOA_INEN->Bits.PIN13 = 0;                     //رʹ
            GPIOA_INEN->Bits.PIN14 = 0;
            GPIOA_ODEN->Bits.PIN13 = 0;                     //ģʽ  0: 1:©
            GPIOA_ODEN->Bits.PIN14 = 0;
            GPIOA_PUEN->Bits.PIN13 = 1;                     //ʹ
            GPIOA_PUEN->Bits.PIN14 = 1;
            GPIOA_DFS->Bits.PIN13 = 0;                      //ֹѡ 0:UART 1:LPUART
            GPIOA_DFS->Bits.PIN14 = 0;
            GPIOA_FCR->Bits.P13FCR = 2;                     //Źѡ 2:Digital function
            GPIOA_FCR->Bits.P14FCR = 2;
            CMU_PCLKCR3->Bits.UART0_PCE = 1;                //UART0ʱ
            CMU_OPCCR3->Bits.UART0CKE = 1;                  //UART0ʱ
            CMU_OPCCR1->Bits.UART0CKS = 1;                  //ѡUART0ʱ 1:RCHF
            UART0_CSR->Bits.TXEN = 1;                       //ʹܷ
            UART0_CSR->Bits.RXEN = 1;                       //ʹܽ
            UART0_BGR->Bits.SPBRG = ((float)RCHF_FREQUENCY/9600 + 0.5) - 1;//:9600
            UART0_CSR->Bits.STOPCFG = 0;                    //ֹͣλ 1λ
            UART0_CSR->Bits.PDSEL = 1;                      //λ 8λ
            UART0_CSR->Bits.PARITY = 0;                     //Уλ 
            UART0_ISR->Bits.RXBF = 1;                       //жϱ־
            UART0_IER->Bits.RXBF_IE = 1;                    //ʹܽж
            status = TRUE;
            break;
        case UART_1:
            GPIOC_INEN->Bits.PIN2 = 0;                      //رʹ
            GPIOC_INEN->Bits.PIN3 = 0;
            GPIOC_ODEN->Bits.PIN2 = 0;                      //ģʽ  0: 1:©
            GPIOC_ODEN->Bits.PIN3 = 0;
            GPIOC_PUEN->Bits.PIN2 = 1;                      //ʹ
            GPIOC_PUEN->Bits.PIN3 = 1;
            GPIOC_DFS->Bits.PIN2 = 0;                       //ֹѡ 0:UART 1:LPUART
            GPIOC_DFS->Bits.PIN3 = 0;
            GPIOC_FCR->Bits.P2FCR = 2;                      //Źѡ 2:Digital function
            GPIOC_FCR->Bits.P3FCR = 2;
            CMU_PCLKCR3->Bits.UART1_PCE = 1;                //UART1ʱ
            CMU_OPCCR3->Bits.UART1CKE = 1;                  //UART1ʱ
            CMU_OPCCR1->Bits.UART1CKS = 1;                  //ѡUART1ʱ 1:RCHF
            UART1_CSR->Bits.TXEN = 1;                       //ʹܷ
            UART1_CSR->Bits.RXEN = 1;                       //ʹܽ
            UART1_BGR->Bits.SPBRG = ((float)RCHF_FREQUENCY/9600 + 0.5) - 1;//:9600
            UART1_CSR->Bits.STOPCFG = 0;                    //ֹͣλ 1λ
            UART1_CSR->Bits.PDSEL = 1;                      //λ 8λ
            UART1_CSR->Bits.PARITY = 0;                     //Уλ 
            UART1_ISR->Bits.RXBF = 1;                       //жϱ־
            UART1_IER->Bits.RXBF_IE = 1;                    //ʹܽж
            status = TRUE;
            break;
        }
    return status;
}

#if STM32L07X

//͵
void K38SendData(INT8U data)
{
  
}
//Ͷ
void IR_TX(INT8U *data,INT16U len)
{
 
}

#endif




/* У׼RCHF */
uint16_t RCHF_Calibration(void)
{
    uint16_t pcount = 0;
    uint8_t trim = 0;
    CMU_CCFR->Bits.REFSEL = 0;                              //οʱ:XTLF
    CMU_CCFR->Bits.REFPSC = 2;                              //οʱԤƵ:32Ƶ
    CMU_CCFR->Bits.CALSEL = 1;                              //У׼ʱ:RCHF
    CMU_CCFR->Bits.CALPSC = 0;                              //У׼ʱԤƵ:Ƶ
    CMU_CCCR->Bits.EN = 1;                                  //У׼
    trim = CMU_RCHTR->Bits.RCHFTRIM;                        //ȡ16MHzУ׼ֵ
    while(CMU_CCISR->Bits.CCLIF == 0);                      //ȴ
    CMU_CCISR->Bits.CCLIF = 1;                              //жϱ־
    pcount = CMU_CCNR->Bits.CCNT;                           //ȡʱУ׼ֵ(׼ֵ:15625=16000000/1024)
    if(pcount * 1024 > 16040000)                            //Ƶƫ
    {
        trim -= (uint8_t)((float)(pcount - 15625) * 1024 / 40000 + 0.5);    //ȥ(16000000*0.25%=40000)
    }
    if(pcount *1024 < 15960000)                             //Ƶƫ
    {
        trim += (uint8_t)((float)(15625 - pcount) * 1024 / 40000 + 0.5);    //Ӳ
    }
    CMU_RCHTR->Bits.RCHFTRIM = trim;                        //У׼ֵ
    CMU_CCCR->Bits.EN = 0;
    return pcount;
}



/* 38K */
BOOL UART_IR38K_Init(BYTE uartId)
{
    BOOL status = FALSE;
    uint32_t tmpTZBRG = 0, tmpTH = 0;
    
    CMU_PCLKCR3->Bits.UARTIR_PCE = 1;                       //ʹUARTIRʱ
    UART_IRCR->Bits.IRFLAG = 0;                             // 0:PNP 1:NPN
    tmpTZBRG = (uint32_t)((APB_FREQUENCY * 1.0)/IR_FREQUENCY - 1);  //Ƶ
    /* ռձ */
    if((tmpTZBRG>>4) != 0)
    {
        tmpTH = (uint32_t)(((float)50/100.0)*((float)(tmpTZBRG + 1)/(float)(tmpTZBRG>>4)) + 0.5);
    }
    else
    {
        tmpTH = (uint32_t)(((float)50/100.0)*(float)(tmpTZBRG + 1) + 0.5);
    }
    /* ռձλС95% */
    tmpTH = ((float)((tmpTZBRG>>4) * tmpTH) / (float)(tmpTZBRG + 1)) < 0.95f ? tmpTH : tmpTH-1;
    /* ռձȺ͵Ƶ */
    UART_IRCR->Bits.TH = tmpTH;
    UART_IRCR->Bits.TZBRG = tmpTZBRG;
    switch(uartId)
    {
        case UART_0:
            UART0_CSR->Bits.TXIREN = 1;                     //ʹUART0ⷢ͵
            status = TRUE;
            break;
        case UART_1:
            UART0_CSR->Bits.TXIREN = 1;                     //ʹUART1ⷢ͵
            status = TRUE;
            break;
    }
    return status;
}

/******************************************************************************************
Name:UartSendData
Purpose:send data 
Paramenters:uart:UART1/UART2/UART3
Return:no
*******************************************************************************************/
BOOL UartSendData(BYTE uartId, INT8U data)
{
    BOOL status = FALSE;
    switch(uartId)
    {
        case UART_0:
            UART0_TXBUF->Bits.TXBUF = data;
            while(UART0_ISR->Bits.TXSE == 0);               //ȴ
            UART0_ISR->Bits.TXSE = 1;                       //жϱ־
            status = TRUE;
            break;
        case UART_1:
            UART1_TXBUF->Bits.TXBUF = data;
            while(UART1_ISR->Bits.TXSE == 0);               //ȴ
            UART1_ISR->Bits.TXSE = 1;                       //жϱ־
            status = TRUE;
            break;
    }
    return status;
}



/******************************************************************************************
Name:UART_Tx
Purpose:UART to transmit multi byte
Paramenters: uart:UART_0 UART_1
             data:data point
             len:data length
Return:no
*******************************************************************************************/
BOOL UART_Tx(INT8U uart, INT8U* data, INT16U len)
{
    BOOL status = FALSE;
    INT16U i;
    switch(uart)
    {
        case UART_0:
            for(i=0; i<len; i++)
            {
                UART0_TXBUF->Bits.TXBUF = data[i];
                while(UART0_ISR->Bits.TXSE == 0);           //ȴ
//                UART0_ISR->Bits.TXSE = 1;                   //жϱ־(д)
            }
            UART0_ISR->Bits.TXSE = 1;
            status = TRUE;
            break;
        case UART_1:
            for(i=0; i<len; i++)
            {
                UART1_TXBUF->Bits.TXBUF = data[i];
                while(UART1_ISR->Bits.TXSE == 0);           //ȴ
//                UART1_ISR->Bits.TXSE = 1;                   //жϱ־(д)
            }
            UART1_ISR->Bits.TXSE = 1;
            status = TRUE;
            break;
    }
    return status;
}


/******************************************************************************************
Name:LPUART_Tx
Purpose:UART to transmit multi byte
Paramenters: uart:LPUART_0 LPUART_1
             data:data point
             len:data length
Return:no
*******************************************************************************************/
BOOL LPUART_Tx(INT8U uart, INT8U* data, INT16U len)
{
    BOOL status = FALSE;
    INT16U i;
    switch(uart)
    {
        case LPUART_0:
            for(i=0; i<len; i++)
            {
                LPUART0_TXBUF->Bits.TXBUF = data[i];
                while(LPUART0_ISR->Bits.TXSE == 0);         //ȴ
//                LPUART0_ISR->Bits.TXSE = 1;                 //жϱ־(д)
            }
            LPUART0_ISR->Bits.TXSE = 1;
            status = TRUE;
            break;
        case LPUART_1:
            for(i=0; i<len; i++)
            {
                LPUART1_TXBUF->Bits.TXBUF = data[i];
                while(LPUART1_ISR->Bits.TXSE == 0);         //ȴ
//                LPUART1_ISR->Bits.TXSE = 1;                 //жϱ־(д)
            }
            LPUART1_ISR->Bits.TXSE = 1;
            status = TRUE;
            break;
    }
    return status;
}

/******************************************************************************************
Name:CloseLPUART
Purpose:close the uart
Paramenters:USARTx:USART1/USART2/USART3
Return:no
********************************************************************************************/
INT16 CloseUart(INT8U UartId)
{
    INT16 status = TRUE;
    RMU_PRSTEN->Bits.PERHRSTEN = PERHRSTEN_KEY;             //踴λʹ
    switch(UartId)
    {
        case LPUART_0:
            RMU_APBRSTCR1->Bits.LPUART0RST = 1;             //λLPUART0
            RMU_APBRSTCR1->Bits.LPUART0RST = 0;             //λLPUART0
            CMU_PCLKCR3->Bits.LPUART0_PCE = 0;              //رLPUART0ʱ
            CMU_OPCCR3->Bits.LPU0CKE = 0;                   //رLPUART0ʱ
            break;
        case LPUART_1:
            RMU_APBRSTCR1->Bits.LPUART1RST = 1;             //λLPUART1
            RMU_APBRSTCR1->Bits.LPUART1RST = 0;             //λLPUART1
            CMU_PCLKCR3->Bits.LPUART1_PCE = 0;              //رLPUART1ʱ
            CMU_OPCCR3->Bits.LPU1CKE = 0;                   //رLPUART1ʱ
            break;
        case UART_0:
            RMU_APBRSTCR1->Bits.UART0RST = 1;               //λUART0
            RMU_APBRSTCR1->Bits.UART0RST = 0;               //λUART0
            CMU_PCLKCR3->Bits.UART0_PCE = 0;                //رUART0ʱ
            CMU_OPCCR3->Bits.UART0CKE = 0;                  //رUART0ʱ
            break;
        case UART_1:
            RMU_APBRSTCR1->Bits.UART1RST = 1;               //λUART1
            RMU_APBRSTCR1->Bits.UART1RST = 0;               //λUART1
            CMU_PCLKCR3->Bits.UART1_PCE = 0;                //رUART1ʱ
            CMU_OPCCR3->Bits.UART1CKE = 0;                  //رUART1ʱ
            break;
        default: status = FALSE;
    }
    RMU_PRSTEN->Bits.PERHRSTEN = ~PERHRSTEN_KEY;            //ֹ踴λ
    return status;
}



/**********************************************************************************
Name:UARTRX_ISR
Purpose:the UART RX interrupt ISR
Paramenters:  uart:UART1/UART2/UART3
Return:no
***********************************************************************************/
BOOL UartRXISR(INT8U uart)
{
    
}

INT16 releaseUart(INT8U UartId)
{
    
}



/*********************************************************************************
Name:UART_read_buff
Purpose:read the UART RX buff
Paramenters:uart:UART1/UART2/UART3
            read_buff:read data buff point
            len: the read data length
Return:return the read data nunber
**********************************************************************************/
BOOL UartReadBuffer(INT8U uart,INT8U *read_buff, INT16U len)
{
    BOOL status = FALSE;
    uint16_t i;
    switch(uart)
    {
        case UART_0:
            for(i=0; i<len; i++)
            {
                while(UART0_ISR->Bits.RXBF == 0);           //ѯջжϱ־
                read_buff[i] = UART0_RXBUF->Bits.RXBUF;
                UART0_ISR->Bits.RXBF = 1;                   //жϱ־
            }
            status = TRUE;
            break;
        case UART_1:
            for(i=0; i<len; i++)
            {
                while(UART1_ISR->Bits.RXBF == 0);           //ѯջжϱ־
                read_buff[i] = UART1_RXBUF->Bits.RXBUF;
                UART1_ISR->Bits.RXBF = 1;                   //жϱ־
            }
            status = TRUE;
            break;
    }
    return status;
}



void LPUARTDisableIT(void)
{
    NVIC_DisableIRQ(LPUARTx_IRQn);
}

void LPUARTENableIT(void)
{
    NVIC_EnableIRQ(LPUARTx_IRQn);
}



