#ifndef _UART_H
#define _UART_H

#include "fm33xx.h"
//#include "DataType.h"
#include "HAL_LIB.h"

#define LPUART_0    1
#define LPUART_1    2
#define UART_0      3
#define UART_1      4



/* UARTӳѡ */
//#define LPUART0PINREMAP    //ndef:LPUART0_RX=PA2 LPUART0_TX=PA3(DFS=1)  def:LPUART0_RX=PA13 LPUART0_TX=PA14(DFS=1)
//#define LPUART1PINREMAP    //ndef:LPUART1_RX=PC2 LPUART1_TX=PC3(DFS=1)  def:LPUART1_RX=PB13 LPUART1_TX=PB14(DFS=1)
//#define LPUART2PINREMAP    //ndef:LPUART2_RX=PA11 LPUART2_TX=PA12(DFS=1)  def:LPUART2_RX=PB4 LPUART2_TX=PB5
#define UART0PINREMAP      //ndef:UART0_RX=PA2 UART0_TX=PA3  def:UART0_RX=PA13 UART0_TX=PA14
//#define UART1PINREMAP      //ndef:UART1_RX=PC2 UART1_TX=PC3  def:UART1_RX=PB13 UART1_TX=PB14
//#define UART3PINREMAP      //ndef:UART3_RX=PB0 UART3_TX=PB1(DFS=1)  def:UART3_RX=PD7 UART3_TX=PD8(DFS=1)
//#define UART4PINREMAP      //ndef:UART4_RX=PA0 UART4_TX=PA1  def:UART4_RX=PB2 UART4_TX=PB3
//#define UART5PINREMAP      //ndef:UART5_RX=PC4 UART5_TX=PC5  def:UART5_RX=PD0 UART5_TX=PD1


#define UART_RX_BYTE_LEN  500     //ݳ
#define UART_BUFF_SIZE   128

typedef struct
{
  INT8U  UARTID;
  uint32_t BaudRate;
  uint16_t RXNEIE;   /*1:enable the RX interrupt, 0:disable the RX interrupt*/
}UART_FORMAT;


#define NB_UART_TX_EN  {RCC_IOPENR->Bits.IOPCEN = 1;GPIOC_AFRL->Bits.AFSEL4 = 2;GPIOC_MODER->Bits.MODER4 = 2;LPUART1_CR1->Bits.TE = 1;GPIOC_PUPDR->Bits.PUPDR4 = 0;}
#define NB_UART_TX_DIS {LPUART1_CR1->Bits.TE = 0;GPIOC_PUPDR->Bits.PUPDR4 = 2;}


#define UART_TIMEOUT      30 
#define UART_TIMER SYN_TIMER22

#define IR_UART_TIMER SYN_TIMER2//մڶʱ
#define IR_UART_TIMEOUT   30

typedef struct
{
    INT16U RxByteLen;        //ֽڼ
    BOOL    RxEn;     //ʹܱ־
    BOOL     TxEn;     //ʹܱ־
    INT8U   RxBuff[UART_RX_BYTE_LEN];  //ݻ
    INT8U TimeOutCnt; //ݰʱ
}UART_MODULE;

#if(LPUART1_EN)
    extern volatile UART_MODULE gLPUart1;  //UART1Դ
#endif

        extern volatile UART_MODULE gUSART1;
        extern volatile UART_MODULE gUSART2;
        
#if STM32L07X
        extern volatile UART_MODULE gUSART4;
        extern volatile UART_MODULE gUSART5;
        extern INT8U  tx38data;
        extern volatile INT8U  tx38step;
void K38SendData(INT8U data);
void IR_TX(INT8U *data,INT16U len);
#endif
        
BOOL OpenUart(UART_FORMAT* USART_strt);
BOOL OpenDefaultUart(BYTE uartId);
BOOL UartTx(INT8U uart,INT8U* data,INT16U len);
INT16 CloseUart(INT8U UartId);
BOOL UartRXISR(INT8U uart);
BOOL UartReadBuffer(INT8U uart,INT8U *read_buff,INT16U len);

INT16 releaseUart(INT8U UartId);
BOOL Uart4_Send(INT16U bound,INT8U* data,INT16U len);


BOOL UartSendData(BYTE uartId, INT8U data);
BOOL UART_Tx(INT8U uart, INT8U* data, INT16U len);
BOOL LPUART_Tx(INT8U uart, INT8U* data, INT16U len);

uint16_t RCHF_Calibration(void);
BOOL UART_IR38K_Init(BYTE uartId);

void LPUARTDisableIT(void);

void LPUARTENableIT(void);
#endif
