/**************************************************************************************************** * @file     FM33LG0XX.h
 *
 * @brief    CMSIS CORTEX-M0 Peripheral Access Layer Header File for
 *           FM33LG0XX from Keil.
 *
 * @version  V0.0.1
 * @date     14 july 2020
 *
 * @note     Generated with SVDConv V2.87e 
 *           from CMSIS SVD File 'FM33LG0XX.SVD' Version 1.0,
 *
 * @par      ARM Limited (ARM) is supplying this software for use with Cortex-M
 *           processor based microcontroller, but can be equally used for other
 *           suitable processor architectures. This file can be freely distributed.
 *           Modifications to this file shall be clearly marked.
 *
 *           THIS SOFTWARE IS PROVIDED “AS IS”. NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 *           OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 *           MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 *           ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 *           CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *******************************************************************************************************/


/** @addtogroup Keil
  * @{
  */

/** @addtogroup FM33LG0XX
  * @{
  */

#ifndef __FM33LG0XX_H
#define __FM33LG0XX_H

#ifdef __cplusplus
extern "C" {
#endif


#define __RCHF_INITIAL_CLOCK        (8000000)        /* Value of the Internal RC HIGH oscillator in Hz */
#define __RCLP_CLOCK                (32000)          /* Value of the Internal RC LOW oscillator in Hz */
#define __XTHF_CLOCK                (8000000)        /* Value of the EXTERNAL oscillator in Hz */
#define __XTLF_CLOCK                (32768)          /* Value of the EXTERNAL oscillator in Hz */

/**
  * @brief Configuration of the Cortex-M0 Processor and Core Peripherals 
  */
#define __CM0_REV                    0x0100U /*!< Cortex-M0 Core Revision                                               */
#define __MPU_PRESENT                1U      /*!< MPU present or not                                                    */
#define __VTOR_PRESENT               1U      /*!< VTOR present or not                                                   */
#define __NVIC_PRIO_BITS             2U      /*!< Number of Bits used for Priority Levels                               */
#define __Vendor_SysTickConfig       0U      /*!< Set to 1 if different SysTick Config is used                          */
/* -------------------------  Interrupt Number Definition  ------------------------ */

/**
 * @brief FM33LG0XX Interrupt Number Definition, according to the selected device 
 *        in @ref Library_configuration_section 
 */
 
typedef enum {
/******  Cortex-M0 Processor Exceptions Numbers ****************************************************************/
  Reset_IRQn                    = -15,              /*!<   1  复位向量 */
  NMI_IRQn                      = -14,              /*!<   2  WKUPx中断、低功耗模式错误中断 */
  HardFault_IRQn                = -13,              /*!<   3  HardFault中断向量 */
  SVC_IRQn                      = -5,               /*!<  11  SVCall系统服务请求 */
  PendSV_IRQn                   = -2,               /*!<  14  可挂起系统服务请求 */
  SysTick_IRQn                  = -1,               /*!<  15  内部定时器中断向量 */

/* --------------------  FM33LG0XX specific Interrupt Numbers  --------------------*/
  WWDT_IRQn                     = 0,                /*!<   0  窗口看门狗或独立看门狗中断 */
  SVD_IRQn                      = 1,                /*!<   1  电源监测报警中断 */
  RTCx_IRQn                     = 2,                /*!<   2  实时时钟中断 */
  FLASH_IRQn                    = 3,                /*!<   3  NVMIF中断 */
  FDET_IRQn                     = 4,                /*!<   4  XTLF或XTHF停振检测中断、系统时钟选择错误中断 */
  ADC_IRQn                      = 5,                /*!<   5  ADC转换完成中断 */
  DAC_IRQn                      = 6,                /*!<   6  DAC中断 */
  SPI0_IRQn                     = 7,                /*!<   7  SPI0中断 */
  SPI1_IRQn                     = 8,                /*!<   8  SPI1中断 */
  SPI2_IRQn                     = 9,                /*!<   9  SPI2中断 */
  UART0_IRQn                    = 10,               /*!<  10  UART0中断 */
  UART1_IRQn                    = 11,               /*!<  11  UART1中断 */
  UART3_IRQn                    = 12,               /*!<  12  UART3中断 */
  UART4_IRQn                    = 13,               /*!<  13  UART4中断 */
  UART5_IRQn                    = 14,               /*!<  14  UART5中断 */
  U7816_IRQn                    = 15,               /*!<  15  U7816中断 */
  LPUARTx_IRQn                  = 16,               /*!<  16  LPUART0/1/2中断 */
  I2C_IRQn                      = 17,               /*!<  17  I2C中断 */
  CCL_IRQn                      = 18,               /*!<  18  时钟校准中断 */
  AES_IRQn                      = 19,               /*!<  19  AES中断 */
  LPTIMx_IRQn                   = 20,               /*!<  20  LPTIM16或LPTIM32中断 */
  DMA_IRQn                      = 21,               /*!<  21  DMA中断 */
  WKUPx_IRQn                    = 22,               /*!<  22  WKUP引脚中断 */
  LUT_IRQn                      = 23,               /*!<  23  LUT中断 */
  BSTIM_IRQn                    = 24,               /*!<  24  BSTIM16或BSTIM32中断 */
  COMPx_IRQn                    = 25,               /*!<  25  COMPx中断 */
  GPTIM01_IRQn                  = 26,               /*!<  26  通用定时器0,1中断 */
  GPTIM2_IRQn                   = 27,               /*!<  27  通用定时器2中断 */
  ATIM_IRQn                     = 28,               /*!<  28  高级定时器中断 */
  VREF_IRQn                     = 29,               /*!<  29  1.2V内部基准电压建立中断、VREF_VREG中断 */
  GPIO_IRQn                     = 30,               /*!<  30  外部引脚中断 */
  CAN_IRQn                      = 31,               /*!<  31  CAN2.0中断 */

} IRQn_Type;


/** @addtogroup Configuration_of_CMSIS
  * @{
  */

/* ================================================================================ */
/* ================      Processor and Core Peripheral Section     ================ */
/* ================================================================================ */

#include "core_cm0plus.h"                            /*!< Cortex-M0 processor and core peripherals */
#include "system_fm33lg0xx.h"                        /*!< FM33LG0XX System */

/* ================================================================================ */
/* ================       Device Specific Peripheral Section       ================ */
/* ================================================================================ */

/** @addtogroup Device_Peripheral_Registers
  * @{
  */

/* -------------------  Start of section using anonymous unions  ------------------ */
#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
//#elif defined(__GNUC__)
///* anonymous unions are enabled by default */
//#elif defined(__TMS470__)
///* anonymous unions are enabled by default */
//#elif defined(__TASKING__)
//  #pragma warning 586
#else
#warning Not supported compiler type
#endif



/********************************************************************************
some of the register can be accessed by bit 
they are:

*********************************************************************************/
//PMU registers define
typedef union
{
    struct
    {
        __IO uint32_t PMOD:2;
        __IO uint32_t RFUI0:2;
        uint32_t reserved0:4;
        __IO uint32_t CVS:1;
        __IO uint32_t SLPDP:1;
        __IO uint32_t WKFSEL:2;
        uint32_t reserved1:4;
        __IO uint32_t LDO15EN_B:1;
        __IO uint32_t LDO15EN:1;
        __IO uint32_t LDO_LPM:2;
        uint32_t reserved2:11;
        __IO uint32_t RFUI1:1;
    }Bits;
    __IO uint32_t All;
}_PMU_CR;
#define PMU_CR ((volatile _PMU_CR *)(PMU_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t T1a:2;
        __IO uint32_t STPCLR:1;
        __IO uint32_t VREFDLY:1;
        uint32_t reserved:28;
    }Bits;
    __IO uint32_t All;
}_PMU_WKTR;
#define PMU_WKTR ((volatile _PMU_WKTR *)(PMU_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t WKPxF:10;
        __IO uint32_t DBGWKF:1;
        __IO uint32_t BST16WKF:1;
        __IO uint32_t BST32WKF:1;
        __IO uint32_t LPT16WKF:1;
        __IO uint32_t LPT32WKF:1;
        uint32_t reserved0:1;
        __IO uint32_t COMP1WKF:1;
        __IO uint32_t COMP2WKF:1;
        __IO uint32_t COMP3WKF:1;
        uint32_t reserved1:1;
        __IO uint32_t LPU0WKF:1;
        __IO uint32_t LPU1WKF:1;
        __IO uint32_t LPU2WKF:1;
        __IO uint32_t I2CWKF:1;
        __IO uint32_t IOWKF:1;
        __IO uint32_t VREFWKF:1;
        __IO uint32_t LFDETWKF:1;
        __IO uint32_t SVDWKF:1;
        __IO uint32_t RTCWKF:1;
        __IO uint32_t UART0WKF:1;
        __IO uint32_t UART1WKF:1;
        __IO uint32_t ADCWKF:1;
    }Bits;
    __IO uint32_t All;
}_PMU_WKFR;
#define PMU_WKFR ((volatile _PMU_WKFR *)(PMU_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t LPREIE:1;
        __IO uint32_t SLPEIE:1;
        __IO uint32_t LPACTIE:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_PMU_IER;
#define PMU_IER ((volatile _PMU_IER *)(PMU_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t LPREIF:1;
        __IO uint32_t SLPEIF:1;
        __IO uint32_t LPACTIF:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_PMU_ISR;
#define PMU_ISR ((volatile _PMU_ISR *)(PMU_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t _ULPBG_TRIM:5;    //重定义 临时改名加_
        uint32_t reserved:27;
    }Bits;
    __IO uint32_t All;
}_PMU_ULPB_TR;
#define PMU_ULPB_TR ((volatile _PMU_ULPB_TR *)(PMU_BASE + 0x38))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        __IO uint32_t POV_IE:1;
        __IO uint32_t DEND_IE:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_PMU_VREFP_CR;
#define PMU_VREFP_CR ((volatile _PMU_VREFP_CR *)(PMU_BASE + 0x3C))

typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t LPM:1;
        __IO uint32_t TDRV:3;
        __IO uint32_t TPERIOD:3;
        __IO uint32_t VRS:3;
        uint32_t reserved1:21;
    }Bits;
    __IO uint32_t All;
}_PMU_VREFP_CFGR;
#define PMU_VREFP_CFGR ((volatile _PMU_VREFP_CFGR *)(PMU_BASE + 0x40))

typedef union
{
    struct
    {
        __IO uint32_t POV:1;
        __IO uint32_t DEND:1;
        __IO uint32_t BUSY:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_PMU_VREFP_ISR;
#define PMU_VREFP_ISR ((volatile _PMU_VREFP_ISR *)(PMU_BASE + 0x44))

typedef union
{
    struct
    {
        __IO uint32_t TRIM:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_PMU_VREFP_TR;
#define PMU_VREFP_TR ((volatile _PMU_VREFP_TR *)(PMU_BASE + 0x48))



//VREF1p2 registers define
typedef union
{
    struct
    {
        __IO uint32_t VREF_EN:1;
        __IO uint32_t PTAT_EN:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_VREF_CR;
#define VREF_CR ((volatile _VREF_CR *)(VREF_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t ST_DELAY:2;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_VREF_CFGR;
#define VREF_CFGR ((volatile _VREF_CFGR *)(VREF_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t IF:1;
        __IO uint32_t RDY:1;
        uint32_t reserved0:6;
        __IO uint32_t FLAG_B:1;
        uint32_t reserved1:23;
    }Bits;
    __IO uint32_t All;
}_VREF_ISR;
#define VREF_ISR ((volatile _VREF_ISR *)(VREF_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t IE:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_VREF_IER;
#define VREF_IER ((volatile _VREF_IER *)(VREF_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t VREFBUFFER_EN:1;
        __IO uint32_t VREFBUFFER_OUTEN:1;
        __IO uint32_t VPTATBUFFER_EN:1;
        __IO uint32_t VPTATBUFFER_OUTEN:1;
        __IO uint32_t AVREFBUF_EN:1;
        __IO uint32_t AVREFBUF_OUTEN:1;
        uint32_t reserved:26;
    }Bits;
    __IO uint32_t All;
}_VREF_BUFCR;
#define VREF_BUFCR ((volatile _VREF_BUFCR *)(VREF_BASE + 0x10))


/* 重定义 临时注销
//VREFP registers define
typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        __IO uint32_t POV_IE:1;
        __IO uint32_t DEND_IE:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_VREFP_CR;
#define VREFP_CR ((volatile _VREFP_CR *)(VREFP_BASE + 0x00))

typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t LPM:1;
        __IO uint32_t TDRV:3;
        __IO uint32_t TPERIOD:3;
        __IO uint32_t VRS:3;
        uint32_t reserved1:21;
    }Bits;
    __IO uint32_t All;
}_VREFP_CFGR;
#define VREFP_CFGR ((volatile _VREFP_CFGR *)(VREFP_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t POV:1;
        __IO uint32_t DEND:1;
        __IO uint32_t BUSY:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_VREFP_ISR;
#define VREFP_ISR ((volatile _VREFP_ISR *)(VREFP_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t TRIM:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_VREFP_TR;
#define VREFP_TR ((volatile _VREFP_TR *)(VREFP_BASE + 0x0C))
*/


//RMU registers define
typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        __IO uint32_t CFG:2;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_RMU_PDRCR;
#define RMU_PDRCR ((volatile _RMU_PDRCR *)(RMU_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t BOR_ENB:1;
        uint32_t reserved0:1;
        __IO uint32_t BOR_PDRCFG:2;
        uint32_t reserved1:28;
    }Bits;
    __IO uint32_t All;
}_RMU_BORCR;
#define RMU_BORCR ((volatile _RMU_BORCR *)(RMU_BASE + 0x04))

typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t EN:1;
        uint32_t reserved1:30;
    }Bits;
    __IO uint32_t All;
}_RMU_LKPCR;
#define RMU_LKPCR ((volatile _RMU_LKPCR *)(RMU_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t SOFTRST:32;
    }Bits;
    __IO uint32_t All;
}_RMU_SOFTRST;
#define RMU_SOFTRST ((volatile _RMU_SOFTRST *)(RMU_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t NVICN_FLAG:1;
        __IO uint32_t LKUPN_FLAG:1;
        __IO uint32_t WWDTN_FLAG:1;
        uint32_t reserved0:1;
        __IO uint32_t IWDTN_FLAG:1;
        __IO uint32_t SOFTN_FLAG:1;
        uint32_t reserved1:1;
        __IO uint32_t PDRN_FLAG:1;
        __IO uint32_t PORN_FLAG:1;
        __IO uint32_t PRCN_FLAG:1;
        __IO uint32_t NRSTN_FLAG:1;
        __IO uint32_t MDF_FLAG:1;
        uint32_t reserved2:20;
    }Bits;
    __IO uint32_t All;
}_RMU_RSTFR;
#define RMU_RSTFR ((volatile _RMU_RSTFR *)(RMU_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t PERHRSTEN:32;
    }Bits;
    __IO uint32_t All;
}_RMU_PRSTEN;
#define RMU_PRSTEN ((volatile _RMU_PRSTEN *)(RMU_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t DMARST:1;
        uint32_t reserved2:31;
    }Bits;
    __IO uint32_t All;
}_RMU_AHBRSTCR;
#define RMU_AHBRSTCR ((volatile _RMU_AHBRSTCR *)(RMU_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t LPT32RST:1;
        __IO uint32_t LPT16RST:1;
        __IO uint32_t OPARST:1;
        __IO uint32_t DACRST:1;
        __IO uint32_t LCDRST:1;
        __IO uint32_t PGLRST:1;
        __IO uint32_t VREFRST:1;
        uint32_t reserved0:1;
        __IO uint32_t LPUART0RST:1;
        __IO uint32_t LPUART1RST:1;
        __IO uint32_t LPUART2RST:1;
        __IO uint32_t I2CRST:1;
        uint32_t reserved1:1;
        __IO uint32_t SPI0RST:1;
        __IO uint32_t SPI1RST:1;
        __IO uint32_t SPI2RST:1;
        uint32_t reserved2:2;
        __IO uint32_t BT16RST:1;
        __IO uint32_t BT32RST:1;
        __IO uint32_t ATIMRST:1;
        __IO uint32_t GPT0RST:1;
        __IO uint32_t GPT1RST:1;
        __IO uint32_t GPT2RST:1;
        __IO uint32_t U7816RST:1;
        __IO uint32_t UARTIRRST:1;
        __IO uint32_t UART0RST:1;
        __IO uint32_t UART1RST:1;
        uint32_t reserved3:1;
        __IO uint32_t UART3RST:1;
        __IO uint32_t UART4RST:1;
        __IO uint32_t UART5RST:1;
    }Bits;
    __IO uint32_t All;
}_RMU_APBRSTCR1;
#define RMU_APBRSTCR1 ((volatile _RMU_APBRSTCR1 *)(RMU_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t COMPRST:1;
        __IO uint32_t SVDRST:1;
        __IO uint32_t CANRST:1;
        __IO uint32_t DIVASRST:1;
        uint32_t reserved0:12;
        __IO uint32_t RNGRST:1;
        __IO uint32_t CRCRST:1;
        __IO uint32_t AESRST:1;
        uint32_t reserved1:4;
        __IO uint32_t ADCRST:1;
        __IO uint32_t ADCCRST:1;
        uint32_t reserved2:7;
    }Bits;
    __IO uint32_t All;
}_RMU_APBRSTCR2;
#define RMU_APBRSTCR2 ((volatile _RMU_APBRSTCR2 *)(RMU_BASE + 0x20))



//IWDT registers define
typedef union
{
    struct
    {
        __IO uint32_t SERV:32;
    }Bits;
    __IO uint32_t All;
}_IWDT_SERV;
#define IWDT_SERV ((volatile _IWDT_SERV *)(IWDT_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t OVP:3;
        uint32_t reserved0:8;
        __IO uint32_t FREEZE:1;
        uint32_t reserved1:20;
    }Bits;
    __IO uint32_t All;
}_IWDT_CR;
#define IWDT_CR ((volatile _IWDT_CR *)(IWDT_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t CNT:12;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_IWDT_CNT;
#define IWDT_CNT ((volatile _IWDT_CNT *)(IWDT_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t CNT:12;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_IWDT_WIN;
#define IWDT_WIN ((volatile _IWDT_WIN *)(IWDT_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t IE:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_IWDT_IER;
#define IWDT_IER ((volatile _IWDT_IER *)(IWDT_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t WINF:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_IWDT_ISR;
#define IWDT_ISR ((volatile _IWDT_ISR *)(IWDT_BASE + 0x14))



//CMU registers define
typedef union
{
    struct
    {
        __IO uint32_t SYSCLKSEL:3;
        uint32_t reserved0:3;
        __IO uint32_t STCLKSEL:2;
        __IO uint32_t AHBPRES:3;
        uint32_t reserved1:5;
        __IO uint32_t APBPRES:3;
        uint32_t reserved2:6;
        __IO uint32_t SLP_ENEXTI:1;
        uint32_t reserved3:1;
        __IO uint32_t LSCATS:1;
        uint32_t reserved4:4;
    }Bits;
    __IO uint32_t All;
}_CMU_SYSCLKCR;
#define CMU_SYSCLKCR ((volatile _CMU_SYSCLKCR *)(CMU_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t RCHFEN:1;
        uint32_t reserved0:15;
        __IO uint32_t FSEL:4;
        uint32_t reserved1:12;
    }Bits;
    __IO uint32_t All;
}_CMU_RCHCR;
#define CMU_RCHCR ((volatile _CMU_RCHCR *)(CMU_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t RCHFTRIM:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_CMU_RCHTR;
#define CMU_RCHTR ((volatile _CMU_RCHTR *)(CMU_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t PLLEN:1;
        __IO uint32_t PLLINSEL:1;
        uint32_t reserved0:1;
        __IO uint32_t PLLOSEL:1;
        __IO uint32_t REFPRSC:3;
        __IO uint32_t LOCKED:1;
        uint32_t reserved1:8;
        __IO uint32_t PLLDB:7;
        uint32_t reserved2:9;
    }Bits;
    __IO uint32_t All;
}_CMU_PLLCR;
#define CMU_PLLCR ((volatile _CMU_PLLCR *)(CMU_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t ENB:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_CMU_RCLPCR;
#define CMU_RCLPCR ((volatile _CMU_RCLPCR *)(CMU_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t _RCLP_TRIM:8;    //重定义 临时改名加_
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_CMU_RCLPTR;
#define CMU_RCLPTR ((volatile _CMU_RCLPTR *)(CMU_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t LSCLKSEL:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_CMU_LSCLKSEL;
#define CMU_LSCLKSEL ((volatile _CMU_LSCLKSEL *)(CMU_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t XTHFEN:1;
        uint32_t reserved0:7;
        __IO uint32_t HF_CFG:5;
        uint32_t reserved1:19;
    }Bits;
    __IO uint32_t All;
}_CMU_XTHCR;
#define CMU_XTHCR ((volatile _CMU_XTHCR *)(CMU_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t RCLF_EN:1;
        uint32_t reserved0:15;
        __IO uint32_t RCLF_PSC:2;
        uint32_t reserved1:14;
    }Bits;
    __IO uint32_t All;
}_CMU_RCLFCR;
#define CMU_RCLFCR ((volatile _CMU_RCLFCR *)(CMU_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t _RCLF_TRIM:8;    //重定义 临时改名加_
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_CMU_RCLFTR;
#define CMU_RCLFTR ((volatile _CMU_RCLFTR *)(CMU_BASE + 0x28))

typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t HFDET_IE:1;
        __IO uint32_t SYSCKE_IE:1;
        uint32_t reserved1:29;
    }Bits;
    __IO uint32_t All;
}_CMU_IER;
#define CMU_IER ((volatile _CMU_IER *)(CMU_BASE + 0x2C))

typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t HFDET_IF:1;
        __IO uint32_t SYSCSE_IF:1;
        uint32_t reserved1:6;
        __IO uint32_t HFDETO:1;
        uint32_t reserved2:22;
    }Bits;
    __IO uint32_t All;
}_CMU_ISR;
#define CMU_ISR ((volatile _CMU_ISR *)(CMU_BASE + 0x30))

typedef union
{
    struct
    {
        __IO uint32_t LPT32_PCE:1;
        __IO uint32_t LPT16_PCE:1;
        __IO uint32_t RTCA_PCE:1;
        __IO uint32_t PMU_PCE:1;
        __IO uint32_t SCU_PCE:1;
        __IO uint32_t IWDT_PCE:1;
        __IO uint32_t ANAC_PCE:1;
        __IO uint32_t PAD_PCE:1;
        __IO uint32_t SVD_PCE:1;
        __IO uint32_t COMP_PCE:1;
        __IO uint32_t ATT_PCE:1;
        __IO uint32_t OPA_PCE:1;
        __IO uint32_t VREF1P2_PCE:1;
        uint32_t reserved:19;
    }Bits;
    __IO uint32_t All;
}_CMU_PCLKCR1;
#define CMU_PCLKCR1 ((volatile _CMU_PCLKCR1 *)(CMU_BASE + 0x34))

typedef union
{
    struct
    {
        __IO uint32_t CRC_PCE:1;
        __IO uint32_t TRNG_PCE:1;
        __IO uint32_t AES_PCE:1;
        __IO uint32_t LCD_PCE:1;
        __IO uint32_t DMA_PCE:1;
        __IO uint32_t FLASH_PCE:1;
        __IO uint32_t RAMBIST_PCE:1;
        __IO uint32_t WWDT_PCE:1;
        __IO uint32_t ADC_PCE:1;
        __IO uint32_t DIVAS_PCE:1;
        __IO uint32_t DAC_PCE:1;
        __IO uint32_t PGL_PCE:1;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_CMU_PCLKCR2;
#define CMU_PCLKCR2 ((volatile _CMU_PCLKCR2 *)(CMU_BASE + 0x38))

typedef union
{
    struct
    {
        __IO uint32_t SPI0_PCE:1;
        __IO uint32_t SPI1_PCE:1;
        __IO uint32_t SPI2_PCE:1;
        uint32_t reserved0:5;
        __IO uint32_t UART0_PCE:1;
        __IO uint32_t UART1_PCE:1;
        uint32_t reserved1:1;
        __IO uint32_t UART3_PCE:1;
        __IO uint32_t UART4_PCE:1;
        __IO uint32_t UART5_PCE:1;
        __IO uint32_t UARTIR_PCE:1;
        __IO uint32_t U7816_PCE:1;
        __IO uint32_t LPUART0_PCE:1;
        __IO uint32_t LPUART1_PCE:1;
        __IO uint32_t LPUART2_PCE:1;
        __IO uint32_t CAN_PCE:1;
        uint32_t reserved2:4;
        __IO uint32_t I2C_PCE:1;
        uint32_t reserved3:7;
    }Bits;
    __IO uint32_t All;
}_CMU_PCLKCR3;
#define CMU_PCLKCR3 ((volatile _CMU_PCLKCR3 *)(CMU_BASE + 0x3C))

typedef union
{
    struct
    {
        __IO uint32_t BT32_PCE:1;
        __IO uint32_t GT0_PCE:1;
        __IO uint32_t GT1_PCE:1;
        __IO uint32_t GT2_PCE:1;
        __IO uint32_t AT_PCE:1;
        uint32_t reserved0:3;
        __IO uint32_t BT16_PCE:1;
        uint32_t reserved1:23;
    }Bits;
    __IO uint32_t All;
}_CMU_PCLKCR4;
#define CMU_PCLKCR4 ((volatile _CMU_PCLKCR4 *)(CMU_BASE + 0x40))

typedef union
{
    struct
    {
        __IO uint32_t UART0CKS:2;
        __IO uint32_t UART1CKS:2;
        __IO uint32_t CANCKS:2;
        uint32_t reserved0:1;
        __IO uint32_t ATCKS:1;
        __IO uint32_t LPT32CKS:2;
        __IO uint32_t LPT16CKS:2;
        __IO uint32_t BT32CKS:2;
        __IO uint32_t BT16CKS:2;
        __IO uint32_t I2CCKS:2;
        uint32_t reserved1:4;
        __IO uint32_t LPUART2CKS:2;
        __IO uint32_t LPUART0CKS:2;
        __IO uint32_t LPUART1CKS:2;
        uint32_t reserved2:2;
        __IO uint32_t EXTICKS:1;
        uint32_t reserved4:1;
    }Bits;
    __IO uint32_t All;
}_CMU_OPCCR1;
#define CMU_OPCCR1 ((volatile _CMU_OPCCR1 *)(CMU_BASE + 0x44))

typedef union
{
    struct
    {
        __IO uint32_t ADCCKS:2;
        __IO uint32_t ADCPSC:3;
        uint32_t reserved0:5;
        __IO uint32_t RNGPSC:3;
        uint32_t reserved1:19;
    }Bits;
    __IO uint32_t All;
}_CMU_OPCCR2;
#define CMU_OPCCR2 ((volatile _CMU_OPCCR2 *)(CMU_BASE + 0x48))

typedef union
{
    struct
    {
        __IO uint32_t LPT32CKE:1;
        __IO uint32_t LPT16CKE:1;
        __IO uint32_t BT32CKE:1;
        __IO uint32_t BT16CKE:1;
        uint32_t reserved0:4;
        __IO uint32_t UART0CKE:1;
        __IO uint32_t UART1CKE:1;
        uint32_t reserved1:4;
        __IO uint32_t CANCKE:1;
        __IO uint32_t ATCKE:1;
        __IO uint32_t ADCCKE:1;
        uint32_t reserved2:3;
        __IO uint32_t I2CCKE:1;
        __IO uint32_t LPU2CKE:1;
        uint32_t reserved3:2;
        __IO uint32_t RNGCKE:1;
        uint32_t reserved4:3;
        __IO uint32_t LPU0CKE:1;
        __IO uint32_t LPU1CKE:1;
        __IO uint32_t FLASHCKE:1;
        __IO uint32_t EXTICKE:1;
    }Bits;
    __IO uint32_t All;
}_CMU_OPCCR3;
#define CMU_OPCCR3 ((volatile _CMU_OPCCR3 *)(CMU_BASE + 0x4C))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        __IO uint32_t CCLIE:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_CMU_CCCR;
#define CMU_CCCR ((volatile _CMU_CCCR *)(CMU_BASE + 0x54))

typedef union
{
    struct
    {
        __IO uint32_t REFSEL:1;
        __IO uint32_t CALSEL:2;
        uint32_t reserved0:5;
        __IO uint32_t REFPSC:2;
        __IO uint32_t CALPSC:2;
        uint32_t reserved1:20;
    }Bits;
    __IO uint32_t All;
}_CMU_CCFR;
#define CMU_CCFR ((volatile _CMU_CCFR *)(CMU_BASE + 0x58))

typedef union
{
    struct
    {
        __IO uint32_t CCNT:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_CMU_CCNR;
#define CMU_CCNR ((volatile _CMU_CCNR *)(CMU_BASE + 0x5C))

typedef union
{
    struct
    {
        __IO uint32_t CCLIF:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_CMU_CCISR;
#define CMU_CCISR ((volatile _CMU_CCISR *)(CMU_BASE + 0x60))



//SVD registers define
typedef union
{
    struct
    {
        __IO uint32_t ITVL:2;
        __IO uint32_t MOD:1;
        __IO uint32_t DFEN:1;
        __IO uint32_t LVL:4;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_SVD_CFGR;
#define SVD_CFGR ((volatile _SVD_CFGR *)(SVD_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        __IO uint32_t SVS0EN:1;
        uint32_t reserved0:6;
        __IO uint32_t TE:1;
        __IO uint32_t LVL:4;
        uint32_t reserved1:23;
    }Bits;
    __IO uint32_t All;
}_SVD_CR;
#define SVD_CR ((volatile _SVD_CR *)(SVD_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t PRIE:1;
        __IO uint32_t PFIE:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_SVD_IER;
#define SVD_IER ((volatile _SVD_IER *)(SVD_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t PRF:1;
        __IO uint32_t PFF:1;
        uint32_t reserved0:5;
        __IO uint32_t SVDR:1;
        __IO uint32_t SVDO:1;
        uint32_t reserved1:23;
    }Bits;
    __IO uint32_t All;
}_SVD_ISR;
#define SVD_ISR ((volatile _SVD_ISR *)(SVD_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t V0P9EN:1;
        __IO uint32_t V0P95EN:1;
        __IO uint32_t V1P0EN:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_SVD_VSR;
#define SVD_VSR ((volatile _SVD_VSR *)(SVD_BASE + 0x10))



//I2C registers define
typedef union
{
    struct
    {
        __IO uint32_t MSPEN:1;
        __IO uint32_t TOEN:1;
        uint32_t reserved0:14;
        __IO uint32_t DMAEN:1;
        __IO uint32_t AUTOEND:1;
        uint32_t reserved1:14;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPCFGR;
#define I2C_MSPCFGR ((volatile _I2C_MSPCFGR *)(I2C_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t SEN:1;
        __IO uint32_t RSEN:1;
        __IO uint32_t PEN:1;
        __IO uint32_t RCEN:1;
        uint32_t reserved:28;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPCR;
#define I2C_MSPCR ((volatile _I2C_MSPCR *)(I2C_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t RXIE:1;
        __IO uint32_t TXIE:1;
        __IO uint32_t NACKIE:1;
        __IO uint32_t PIE:1;
        __IO uint32_t SIE:1;
        __IO uint32_t TOIE:1;
        __IO uint32_t WCOLIE:1;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPIER;
#define I2C_MSPIER ((volatile _I2C_MSPIER *)(I2C_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t RXIF:1;
        __IO uint32_t TXIF:1;
        __IO uint32_t ACKSTA:1;
        __IO uint32_t P:1;
        __IO uint32_t S:1;
        __IO uint32_t OVT:1;
        __IO uint32_t WCOL:1;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPISR;
#define I2C_MSPISR ((volatile _I2C_MSPISR *)(I2C_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t ACKMO:1;
        uint32_t reserved0:1;
        __IO uint32_t BF:1;
        uint32_t reserved1:1;
        __IO uint32_t RW:1;
        __IO uint32_t BUSY:1;
        uint32_t reserved2:26;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPSR;
#define I2C_MSPSR ((volatile _I2C_MSPSR *)(I2C_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t MSPBRGL:9;
        uint32_t reserved0:7;
        __IO uint32_t MSPBRGH:9;
        uint32_t reserved1:7;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPBGR;
#define I2C_MSPBGR ((volatile _I2C_MSPBGR *)(I2C_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t MSPBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPBUF;
#define I2C_MSPBUF ((volatile _I2C_MSPBUF *)(I2C_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t SDAHD:9;
        uint32_t reserved:23;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPTCR;
#define I2C_MSPTCR ((volatile _I2C_MSPTCR *)(I2C_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t TIMEOUT:12;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_I2C_MSPTOR;
#define I2C_MSPTOR ((volatile _I2C_MSPTOR *)(I2C_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t SSPEN:1;
        __IO uint32_t A10EN:1;
        __IO uint32_t SCLI_ANFEN:1;
        __IO uint32_t SDAO_DLYEN:1;
        __IO uint32_t ACKEN:1;
        uint32_t reserved0:3;
        __IO uint32_t DMAEN:1;
        __IO uint32_t SCLSEN:1;
        uint32_t reserved1:22;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPCR;
#define I2C_SSPCR ((volatile _I2C_SSPCR *)(I2C_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t RXIE:1;
        __IO uint32_t TXIE:1;
        __IO uint32_t ADMIE:1;
        __IO uint32_t SSPOVIE:1;
        __IO uint32_t WCOLIE:1;
        __IO uint32_t PIE:1;
        __IO uint32_t SIE:1;
        __IO uint32_t ADEIE:1;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPIER;
#define I2C_SSPIER ((volatile _I2C_SSPIER *)(I2C_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t RXIF:1;
        __IO uint32_t TXIF:1;
        __IO uint32_t ADM:1;
        __IO uint32_t SSPOV:1;
        __IO uint32_t WCOL:1;
        __IO uint32_t P:1;
        __IO uint32_t S:1;
        __IO uint32_t ADE:1;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPISR;
#define I2C_SSPISR ((volatile _I2C_SSPISR *)(I2C_BASE + 0x2C))

typedef union
{
    struct
    {
        __IO uint32_t BF:1;
        __IO uint32_t DA:1;
        __IO uint32_t RW:1;
        __IO uint32_t BUSY:1;
        uint32_t reserved:28;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPSR;
#define I2C_SSPSR ((volatile _I2C_SSPSR *)(I2C_BASE + 0x30))

typedef union
{
    struct
    {
        __IO uint32_t SSPBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPBUF;
#define I2C_SSPBUF ((volatile _I2C_SSPBUF *)(I2C_BASE + 0x34))

typedef union
{
    struct
    {
        __IO uint32_t SSPADDR:10;
        uint32_t reserved:22;
    }Bits;
    __IO uint32_t All;
}_I2C_SSPADR;
#define I2C_SSPADR ((volatile _I2C_SSPADR *)(I2C_BASE + 0x38))



//UART common registers define
typedef union
{
    struct
    {
        __IO uint32_t TZBRG:11;
        __IO uint32_t TH:4;
        __IO uint32_t IRFLAG:1;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_UART_IRCR;
#define UART_IRCR ((volatile _UART_IRCR *)(UART_COMMON_BASE + 0x00))



//UART registers define
typedef union
{
    struct
    {
        __IO uint32_t TXEN:1;
        __IO uint32_t RXEN:1;
        __IO uint32_t TXPOL:1;
        __IO uint32_t RXPOL:1;
        __IO uint32_t PARITY:2;
        __IO uint32_t PDSEL:2;
        __IO uint32_t STOPCFG:1;
        __IO uint32_t BITORD:1;
        __IO uint32_t DMATXIFCFG:1;
        __IO uint32_t NEWUP:1;
        __IO uint32_t IOSWAP:1;
        __IO uint32_t OVSM:1;
        uint32_t reserved0:2;
        __IO uint32_t RXTOEN:1;
        __IO uint32_t TXIREN:1;
        uint32_t reserved1:6;
        __IO uint32_t BUSY:1;
        uint32_t reserved2:7;
    }Bits;
    __IO uint32_t All;
}_UART_CSR;
#define UART0_CSR ((volatile _UART_CSR *)(UART0_BASE + 0x00))
#define UART1_CSR ((volatile _UART_CSR *)(UART1_BASE + 0x00))
#define UART3_CSR ((volatile _UART_CSR *)(UART3_BASE + 0x00))
#define UART4_CSR ((volatile _UART_CSR *)(UART4_BASE + 0x00))
#define UART5_CSR ((volatile _UART_CSR *)(UART5_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t TXSE_IE:1;
        __IO uint32_t TXBE_IE:1;
        uint32_t reserved0:5;
        __IO uint32_t NEWUP_IE:1;
        __IO uint32_t RXBF_IE:1;
        uint32_t reserved1:1;
        __IO uint32_t RXERR_IE:1;
        __IO uint32_t RXTO_IE:1;
        uint32_t reserved2:20;
    }Bits;
    __IO uint32_t All;
}_UART_IER;
#define UART0_IER ((volatile _UART_IER *)(UART0_BASE + 0x04))
#define UART1_IER ((volatile _UART_IER *)(UART1_BASE + 0x04))
#define UART3_IER ((volatile _UART_IER *)(UART3_BASE + 0x04))
#define UART4_IER ((volatile _UART_IER *)(UART4_BASE + 0x04))
#define UART5_IER ((volatile _UART_IER *)(UART5_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t TXSE:1;
        __IO uint32_t TXBE:1;
        __IO uint32_t TX_OERR:1;
        uint32_t reserved0:4;
        __IO uint32_t NEWKF:1;
        __IO uint32_t RXBF:1;
        uint32_t reserved1:2;
        __IO uint32_t RXTO:1;
        uint32_t reserved2:4;
        __IO uint32_t OERR:1;
        __IO uint32_t FERR:1;
        __IO uint32_t PERR:1;
        uint32_t reserved3:13;
    }Bits;
    __IO uint32_t All;
}_UART_ISR;
#define UART0_ISR ((volatile _UART_ISR *)(UART0_BASE + 0x08))
#define UART1_ISR ((volatile _UART_ISR *)(UART1_BASE + 0x08))
#define UART3_ISR ((volatile _UART_ISR *)(UART3_BASE + 0x08))
#define UART4_ISR ((volatile _UART_ISR *)(UART4_BASE + 0x08))
#define UART5_ISR ((volatile _UART_ISR *)(UART5_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t RXTO_LEN:8;
        __IO uint32_t TXDLY_LEN:8;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_UART_TODR;
#define UART0_TODR ((volatile _UART_TODR *)(UART0_BASE + 0x0C))
#define UART1_TODR ((volatile _UART_TODR *)(UART1_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t RXBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_UART_RXBUF;
#define UART0_RXBUF ((volatile _UART_RXBUF *)(UART0_BASE + 0x10))
#define UART1_RXBUF ((volatile _UART_RXBUF *)(UART1_BASE + 0x10))
#define UART3_RXBUF ((volatile _UART_RXBUF *)(UART3_BASE + 0x10))
#define UART4_RXBUF ((volatile _UART_RXBUF *)(UART4_BASE + 0x10))
#define UART5_RXBUF ((volatile _UART_RXBUF *)(UART5_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t TXBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_UART_TXBUF;
#define UART0_TXBUF ((volatile _UART_TXBUF *)(UART0_BASE + 0x14))
#define UART1_TXBUF ((volatile _UART_TXBUF *)(UART1_BASE + 0x14))
#define UART3_TXBUF ((volatile _UART_TXBUF *)(UART3_BASE + 0x14))
#define UART4_TXBUF ((volatile _UART_TXBUF *)(UART4_BASE + 0x14))
#define UART5_TXBUF ((volatile _UART_TXBUF *)(UART5_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t SPBRG:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_UART_BGR;
#define UART0_BGR ((volatile _UART_BGR *)(UART0_BASE + 0x18))
#define UART1_BGR ((volatile _UART_BGR *)(UART1_BASE + 0x18))
#define UART3_BGR ((volatile _UART_BGR *)(UART3_BASE + 0x18))
#define UART4_BGR ((volatile _UART_BGR *)(UART4_BASE + 0x18))
#define UART5_BGR ((volatile _UART_BGR *)(UART5_BASE + 0x18))



//LPUART registers define
typedef union
{
    struct
    {
        __IO uint32_t TXEN:1;
        __IO uint32_t RXEN:1;
        __IO uint32_t TXPOL:1;
        __IO uint32_t RXPOL:1;
        __IO uint32_t PARITY:2;
        __IO uint32_t PDSEL:2;
        __IO uint32_t STOPCFG:1;
        __IO uint32_t BITORD:1;
        __IO uint32_t DMATXIFCFG:1;
        __IO uint32_t IOSWAP:1;
        uint32_t reserved0:4;
        __IO uint32_t RXEV:2;
        uint32_t reserved1:1;
        __IO uint32_t WKBYTE_CFG:1;
        uint32_t reserved2:4;
        __IO uint32_t BUSY:1;
        uint32_t reserved3:7;
    }Bits;
    __IO uint32_t All;
}_LPUART_CSR;
#define LPUART0_CSR ((volatile _LPUART_CSR *)(LPUART0_BASE + 0x00))
#define LPUART1_CSR ((volatile _LPUART_CSR *)(LPUART1_BASE + 0x00))
#define LPUART2_CSR ((volatile _LPUART_CSR *)(LPUART2_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t TXSE_IE:1;
        __IO uint32_t TXBE_IE:1;
        uint32_t reserved0:6;
        __IO uint32_t RXBF_IE:1;
        uint32_t reserved1:1;
        __IO uint32_t RXERR_IE:1;
        uint32_t reserved2:1;
        __IO uint32_t RXEV_IE:1;
        uint32_t reserved3:19;
    }Bits;
    __IO uint32_t All;
}_LPUART_IER;
#define LPUART0_IER ((volatile _LPUART_IER *)(LPUART0_BASE + 0x04))
#define LPUART1_IER ((volatile _LPUART_IER *)(LPUART1_BASE + 0x04))
#define LPUART2_IER ((volatile _LPUART_IER *)(LPUART2_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t TXSE:1;
        __IO uint32_t TXBE:1;
        uint32_t reserved0:6;
        __IO uint32_t RXBF:1;
        uint32_t reserved1:7;
        __IO uint32_t OERR:1;
        __IO uint32_t FERR:1;
        __IO uint32_t PERR:1;
        __IO uint32_t TXOV:1;
        uint32_t reserved2:4;
        __IO uint32_t RXEVF:1;
        uint32_t reserved3:7;
    }Bits;
    __IO uint32_t All;
}_LPUART_ISR;
#define LPUART0_ISR ((volatile _LPUART_ISR *)(LPUART0_BASE + 0x08))
#define LPUART1_ISR ((volatile _LPUART_ISR *)(LPUART1_BASE + 0x08))
#define LPUART2_ISR ((volatile _LPUART_ISR *)(LPUART2_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t BAUD:3;
        uint32_t reserved0:13;
        __IO uint32_t MCTL:12;
        uint32_t reserved1:3;
        __IO uint32_t MCTL_EN:1;
    }Bits;
    __IO uint32_t All;
}_LPUART_BMR;
#define LPUART0_BMR ((volatile _LPUART_BMR *)(LPUART0_BASE + 0x0C))
#define LPUART1_BMR ((volatile _LPUART_BMR *)(LPUART1_BASE + 0x0C))
#define LPUART2_BMR ((volatile _LPUART_BMR *)(LPUART2_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t RXBUF:9;
        uint32_t reserved:23;
    }Bits;
    __IO uint32_t All;
}_LPUART_RXBUF;
#define LPUART0_RXBUF ((volatile _LPUART_RXBUF *)(LPUART0_BASE + 0x10))
#define LPUART1_RXBUF ((volatile _LPUART_RXBUF *)(LPUART1_BASE + 0x10))
#define LPUART2_RXBUF ((volatile _LPUART_RXBUF *)(LPUART2_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t TXBUF:9;
        uint32_t reserved:23;
    }Bits;
    __IO uint32_t All;
}_LPUART_TXBUF;
#define LPUART0_TXBUF ((volatile _LPUART_TXBUF *)(LPUART0_BASE + 0x14))
#define LPUART1_TXBUF ((volatile _LPUART_TXBUF *)(LPUART1_BASE + 0x14))
#define LPUART2_TXBUF ((volatile _LPUART_TXBUF *)(LPUART2_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t MATD:9;
        uint32_t reserved:23;
    }Bits;
    __IO uint32_t All;
}_LPUART_DMR;
#define LPUART0_DMR ((volatile _LPUART_DMR *)(LPUART0_BASE + 0x18))
#define LPUART1_DMR ((volatile _LPUART_DMR *)(LPUART1_BASE + 0x18))
#define LPUART2_DMR ((volatile _LPUART_DMR *)(LPUART2_BASE + 0x18))



//U7816 registers define
typedef union
{
    struct
    {
        uint32_t reserved0:1;
        __IO uint32_t HPUEN:1;
        __IO uint32_t HPUAT:1;
        __IO uint32_t CKOEN:1;
        __IO uint32_t RXEN:1;
        __IO uint32_t TXEN:1;
        uint32_t reserved1:26;
    }Bits;
    __IO uint32_t All;
}_U7816_CR;
#define U7816_CR ((volatile _U7816_CR *)(U7816_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t DICONV:1;
        __IO uint32_t RREPEN:1;
        __IO uint32_t TREPEN:1;
        __IO uint32_t RFREN:1;
        __IO uint32_t PAR:2;
        __IO uint32_t REP_T:1;
        __IO uint32_t BGTEN:1;
        __IO uint32_t ERSGD:1;
        __IO uint32_t ERSW:2;
        __IO uint32_t SFREN:1;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_U7816_FFR;
#define U7816_FFR ((volatile _U7816_FFR *)(U7816_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t TXEGT:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_U7816_EGTR;
#define U7816_EGTR ((volatile _U7816_EGTR *)(U7816_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t CLKDIV:5;
        uint32_t reserved:27;
    }Bits;
    __IO uint32_t All;
}_U7816_PSC;
#define U7816_PSC ((volatile _U7816_PSC *)(U7816_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t PDIV:12;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_U7816_BGR;
#define U7816_BGR ((volatile _U7816_BGR *)(U7816_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t RXBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_U7816_RXBUF;
#define U7816_RXBUF ((volatile _U7816_RXBUF *)(U7816_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t TXBUF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_U7816_TXBUF;
#define U7816_TXBUF ((volatile _U7816_TXBUF *)(U7816_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t LSIE:1;
        __IO uint32_t TXIE:1;
        __IO uint32_t RXIE:1;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_U7816_IER;
#define U7816_IER ((volatile _U7816_IER *)(U7816_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t ERRIF:1;
        __IO uint32_t TXIF:1;
        __IO uint32_t RXIF:1;
        uint32_t reserved0:5;
        __IO uint32_t OVERR:1;
        __IO uint32_t FRERR:1;
        __IO uint32_t RPARERR:1;
        __IO uint32_t TPARERR:1;
        uint32_t reserved1:4;
        __IO uint32_t RXBUSY:1;
        __IO uint32_t TXBUSY:1;
        __IO uint32_t WAIT_RPT:1;
        uint32_t reserved2:13;
    }Bits;
    __IO uint32_t All;
}_U7816_ISR;
#define U7816_ISR ((volatile _U7816_ISR *)(U7816_BASE + 0x20))



//RTCA registers define
typedef union
{
    struct
    {
        __IO uint32_t WE:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_RTCA_WER;
#define RTCA_WER ((volatile _RTCA_WER *)(RTCA_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t DAY_IE:1;
        __IO uint32_t HOUR_IE:1;
        __IO uint32_t MIN_IE:1;
        __IO uint32_t SEC_IE:1;
        __IO uint32_t _2HZ_IE:1;
        __IO uint32_t _4HZ_IE:1;
        __IO uint32_t _8HZ_IE:1;
        __IO uint32_t _16HZ_IE:1;
        __IO uint32_t _64HZ_IE:1;
        __IO uint32_t _256HZ_IE:1;
        __IO uint32_t _1KHZ_IE:1;
        __IO uint32_t ALARM_IE:1;
        __IO uint32_t ADJ_IE:1;
        uint32_t reserved:19;
    }Bits;
    __IO uint32_t All;
}_RTCA_IER;
#define RTCA_IER ((volatile _RTCA_IER *)(RTCA_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t DAY_IF:1;
        __IO uint32_t HOUR_IF:1;
        __IO uint32_t MIN_IF:1;
        __IO uint32_t SEC_IF:1;
        __IO uint32_t _2HZ_IF:1;
        __IO uint32_t _4HZ_IF:1;
        __IO uint32_t _8HZ_IF:1;
        __IO uint32_t _16HZ_IF:1;
        __IO uint32_t _64HZ_IF:1;
        __IO uint32_t _256HZ_IF:1;
        __IO uint32_t _1KHZ_IF:1;
        __IO uint32_t ALARM_IF:1;
        __IO uint32_t ADJ_IF:1;
        uint32_t reserved:19;
    }Bits;
    __IO uint32_t All;
}_RTCA_ISR;
#define RTCA_ISR ((volatile _RTCA_ISR *)(RTCA_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t SEC:7;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDSEC;
#define RTCA_BCDSEC ((volatile _RTCA_BCDSEC *)(RTCA_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t MIN:7;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDMIN;
#define RTCA_BCDMIN ((volatile _RTCA_BCDMIN *)(RTCA_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t HOUR:6;
        uint32_t reserved:26;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDHOUR;
#define RTCA_BCDHOUR ((volatile _RTCA_BCDHOUR *)(RTCA_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t DAY:6;
        uint32_t reserved:26;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDDAY;
#define RTCA_BCDDAY ((volatile _RTCA_BCDDAY *)(RTCA_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t WEEK:3;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDWEEK;
#define RTCA_BCDWEEK ((volatile _RTCA_BCDWEEK *)(RTCA_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t MONTH:5;
        uint32_t reserved:27;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDMONTH;
#define RTCA_BCDMONTH ((volatile _RTCA_BCDMONTH *)(RTCA_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t YEAR:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_RTCA_BCDYEAR;
#define RTCA_BCDYEAR ((volatile _RTCA_BCDYEAR *)(RTCA_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t SEC:7;
        uint32_t reserved0:1;
        __IO uint32_t MIN:7;
        uint32_t reserved1:1;
        __IO uint32_t HOUR:6;
        uint32_t reserved2:10;
    }Bits;
    __IO uint32_t All;
}_RTCA_ALARM;
#define RTCA_ALARM ((volatile _RTCA_ALARM *)(RTCA_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t TMSEL:4;
        uint32_t reserved:28;
    }Bits;
    __IO uint32_t All;
}_RTCA_TMSEL;
#define RTCA_TMSEL ((volatile _RTCA_TMSEL *)(RTCA_BASE + 0x2C))

typedef union
{
    struct
    {
        __IO uint32_t ADJUST:9;
        __IO uint32_t ADSIGN:1;
        uint32_t reserved:22;
    }Bits;
    __IO uint32_t All;
}_RTCA_ADJUST;
#define RTCA_ADJUST ((volatile _RTCA_ADJUST *)(RTCA_BASE + 0x30))

typedef union
{
    struct
    {
        __IO uint32_t MSCNT:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_RTCA_SBSCNT;
#define RTCA_SBSCNT ((volatile _RTCA_SBSCNT *)(RTCA_BASE + 0x3C))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_RTCA_CR;
#define RTCA_CR ((volatile _RTCA_CR *)(RTCA_BASE + 0x40))



//ADC registers define
typedef union
{
    struct
    {
        __IO uint32_t EOC:1;
        __IO uint32_t EOS:1;
        __IO uint32_t OVR:1;
        __IO uint32_t BUSY:1;
        __IO uint32_t EOCAL:1;
        __IO uint32_t AWD_UL:1;
        __IO uint32_t AWD_AH:1;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_ADC_ISR;
#define ADC_ISR ((volatile _ADC_ISR *)(ADC_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t EOCIE:1;
        __IO uint32_t EOSIE:1;
        __IO uint32_t OVRIE:1;
        uint32_t reserved0:1;
        __IO uint32_t EOCALIE:1;
        __IO uint32_t AWD_ULIE:1;
        __IO uint32_t AWD_AHIE:1;
        uint32_t reserved1:25;
    }Bits;
    __IO uint32_t All;
}_ADC_IER;
#define ADC_IER ((volatile _ADC_IER *)(ADC_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t ADEN:1;
        __IO uint32_t SWTRIG:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_ADC_CR1;
#define ADC_CR1 ((volatile _ADC_CR1 *)(ADC_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t TRGCFG:2;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_ADC_CR2;
#define ADC_CR2 ((volatile _ADC_CR2 *)(ADC_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t CALEN:1;
        uint32_t reserved0:3;
        __IO uint32_t CMPRDY_DELAY:2;
        __IO uint32_t VCM_MODE:1;
        __IO uint32_t VCM_CTRL:1;
        uint32_t reserved1:4;
        __IO uint32_t OFFL_EN:1;
        uint32_t reserved2:3;
        __IO uint32_t OSCAL_CYCLE:8;
        uint32_t reserved3:8;
    }Bits;
    __IO uint32_t All;
}_ADC_CALR;
#define ADC_CALR ((volatile _ADC_CALR *)(ADC_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t REFSEL:2;
        __IO uint32_t CLKSEL:1;
        __IO uint32_t BITSEL:2;
        __IO uint32_t EXSOC:1;
        __IO uint32_t APBCLK_PSC:2;
        __IO uint32_t BUFEN:1;
        __IO uint32_t BUFMOD:1;
        __IO uint32_t BUFLPF:1;
        __IO uint32_t BUFCHP_EN:1;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_ADC_CFGR1;
#define ADC_CFGR1 ((volatile _ADC_CFGR1 *)(ADC_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t DMAEN:1;
        uint32_t reserved0:1;
        __IO uint32_t SCANDIR:1;
        uint32_t reserved1:1;
        __IO uint32_t EXTS:4;
        __IO uint32_t OVRM:1;
        __IO uint32_t CONT:1;
        __IO uint32_t WAIT:1;
        __IO uint32_t SEMI:1;
        uint32_t reserved2:2;
        __IO uint32_t IOTRFEN:1;
        uint32_t reserved3:1;
        __IO uint32_t OVSEN:1;
        __IO uint32_t OVSR:3;
        __IO uint32_t OVSS:4;
        __IO uint32_t AWDEN:1;
        __IO uint32_t AWDSC:1;
        __IO uint32_t AWDCH:5;
        uint32_t reserved4:1;
    }Bits;
    __IO uint32_t All;
}_ADC_CFGR2;
#define ADC_CFGR2 ((volatile _ADC_CFGR2 *)(ADC_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t SMTS1:4;
        __IO uint32_t SMTS2:4;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_ADC_SMTR;
#define ADC_SMTR ((volatile _ADC_SMTR *)(ADC_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t ECH0:1;
        __IO uint32_t ECH1:1;
        __IO uint32_t ECH2:1;
        __IO uint32_t ECH3:1;
        __IO uint32_t ECH4:1;
        __IO uint32_t ECH5:1;
        __IO uint32_t ECH6:1;
        __IO uint32_t ECH7:1;
        __IO uint32_t ECH8:1;
        __IO uint32_t ECH9:1;
        __IO uint32_t ECH10:1;
        __IO uint32_t ECH11:1;
        __IO uint32_t ECH12:1;
        __IO uint32_t ECH13:1;
        __IO uint32_t ECH14:1;
        __IO uint32_t ECH15:1;
        __IO uint32_t ECH16:1;
        __IO uint32_t ECH17:1;
        __IO uint32_t ECH18:1;
        __IO uint32_t ECH19:1;
        uint32_t reserved0:4;
        __IO uint32_t VREF1P2:1;
        __IO uint32_t TS:1;
        __IO uint32_t AVREF:1;
        __IO uint32_t VBAT_DIV3:1;
        __IO uint32_t VDD_DIV3:1;
        __IO uint32_t DAC:1;
        __IO uint32_t OPA:1;
        uint32_t reserved1:1;
    }Bits;
    __IO uint32_t All;
}_ADC_CHER;
#define ADC_CHER ((volatile _ADC_CHER *)(ADC_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t AINS:7;
        uint32_t reserved:25;
    }Bits;
    __IO uint32_t All;
}_ADC_DCR;
#define ADC_DCR ((volatile _ADC_DCR *)(ADC_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t DATA:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_ADC_DR;
#define ADC_DR ((volatile _ADC_DR *)(ADC_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t AWD_LT:16;
        __IO uint32_t AWD_HT:16;
    }Bits;
    __IO uint32_t All;
}_ADC_HLTR;
#define ADC_HLTR ((volatile _ADC_HLTR *)(ADC_BASE + 0x2C))



//GPTIM registers define
typedef union
{
    struct
    {
        __IO uint32_t CEN:1;
        __IO uint32_t UDIS:1;
        __IO uint32_t URS:1;
        __IO uint32_t OPM:1;
        __IO uint32_t DIR:1;
        __IO uint32_t CMS:2;
        __IO uint32_t ARPE:1;
        __IO uint32_t CKD:2;
        uint32_t reserved:22;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CR1;
#define GPTIM0_CR1 ((volatile _GPTIM_CR1 *)(GPTIM0_BASE + 0x00))
#define GPTIM1_CR1 ((volatile _GPTIM_CR1 *)(GPTIM1_BASE + 0x00))
#define GPTIM2_CR1 ((volatile _GPTIM_CR1 *)(GPTIM2_BASE + 0x00))

typedef union
{
    struct
    {
        uint32_t reserved0:3;
        __IO uint32_t CCDS:1;
        __IO uint32_t MMS:3;
        __IO uint32_t TI1S:1;
        uint32_t reserved1:24;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CR2;
#define GPTIM0_CR2 ((volatile _GPTIM_CR2 *)(GPTIM0_BASE + 0x04))
#define GPTIM1_CR2 ((volatile _GPTIM_CR2 *)(GPTIM1_BASE + 0x04))
#define GPTIM2_CR2 ((volatile _GPTIM_CR2 *)(GPTIM2_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t SMS:3;
        uint32_t reserved0:1;
        __IO uint32_t TS:3;
        __IO uint32_t MSM:1;
        __IO uint32_t ETF:4;
        __IO uint32_t ETPS:2;
        __IO uint32_t ECE:1;
        __IO uint32_t ETP:1;
        uint32_t reserved1:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_SMCR;
#define GPTIM0_SMCR ((volatile _GPTIM_SMCR *)(GPTIM0_BASE + 0x08))
#define GPTIM1_SMCR ((volatile _GPTIM_SMCR *)(GPTIM1_BASE + 0x08))
#define GPTIM2_SMCR ((volatile _GPTIM_SMCR *)(GPTIM2_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t UIE:1;
        __IO uint32_t CC1IE:1;
        __IO uint32_t CC2IE:1;
        __IO uint32_t CC3IE:1;
        __IO uint32_t CC4IE:1;
        uint32_t reserved0:1;
        __IO uint32_t TIE:1;
        uint32_t reserved1:1;
        __IO uint32_t UDE:1;
        __IO uint32_t CC1DE:1;
        __IO uint32_t CC2DE:1;
        __IO uint32_t CC3DE:1;
        __IO uint32_t CC4DE:1;
        uint32_t reserved2:1;
        __IO uint32_t TDE:1;
        uint32_t reserved3:1;
        __IO uint32_t CC1BURSTEN:1;
        __IO uint32_t CC2BURSTEN:1;
        __IO uint32_t CC3BURSTEN:1;
        __IO uint32_t CC4BURSTEN:1;
        uint32_t reserved4:12;
    }Bits;
    __IO uint32_t All;
}_GPTIM_DIER;
#define GPTIM0_DIER ((volatile _GPTIM_DIER *)(GPTIM0_BASE + 0x0C))
#define GPTIM1_DIER ((volatile _GPTIM_DIER *)(GPTIM1_BASE + 0x0C))
#define GPTIM2_DIER ((volatile _GPTIM_DIER *)(GPTIM2_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t UIF:1;
        __IO uint32_t CC1IF:1;
        __IO uint32_t CC2IF:1;
        __IO uint32_t CC3IF:1;
        __IO uint32_t CC4IF:1;
        uint32_t reserved0:1;
        __IO uint32_t TIF:1;
        uint32_t reserved1:2;
        __IO uint32_t CC1OF:1;
        __IO uint32_t CC2OF:1;
        __IO uint32_t CC3OF:1;
        __IO uint32_t CC4OF:1;
        uint32_t reserved2:19;
    }Bits;
    __IO uint32_t All;
}_GPTIM_ISR;
#define GPTIM0_ISR ((volatile _GPTIM_ISR *)(GPTIM0_BASE + 0x10))
#define GPTIM1_ISR ((volatile _GPTIM_ISR *)(GPTIM1_BASE + 0x10))
#define GPTIM2_ISR ((volatile _GPTIM_ISR *)(GPTIM2_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t UG:1;
        __IO uint32_t CC1G:1;
        __IO uint32_t CC2G:1;
        uint32_t reserved0:3;
        __IO uint32_t TG:1;
        uint32_t reserved1:25;
    }Bits;
    __IO uint32_t All;
}_GPTIM_EGR;
#define GPTIM0_EGR ((volatile _GPTIM_EGR *)(GPTIM0_BASE + 0x14))
#define GPTIM1_EGR ((volatile _GPTIM_EGR *)(GPTIM1_BASE + 0x14))
#define GPTIM2_EGR ((volatile _GPTIM_EGR *)(GPTIM2_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t CC1S:2;
        __IO uint32_t IC1PSC:2;
        __IO uint32_t IC1F:4;
        __IO uint32_t CC2S:2;
        __IO uint32_t IC2PSC:2;
        __IO uint32_t IC2F:4;
        uint32_t reserved:16;
    }INBits;
    struct
    {
        __IO uint32_t CC1S:2;
        __IO uint32_t OC1FE:1;
        __IO uint32_t OC1PE:1;
        __IO uint32_t OC1M:3;
        __IO uint32_t OC1CE:1;
        __IO uint32_t CC2S:2;
        __IO uint32_t OC2FE:1;
        __IO uint32_t OC2PE:1;
        __IO uint32_t OC2M:2;
        __IO uint32_t OC2CE:1;
        uint32_t reserved:16;
    }OUTBits;
    __IO uint32_t All;
}_GPTIM_CCMR1;
#define GPTIM0_CCMR1 ((volatile _GPTIM_CCMR1 *)(GPTIM0_BASE + 0x18))
#define GPTIM1_CCMR1 ((volatile _GPTIM_CCMR1 *)(GPTIM1_BASE + 0x18))
#define GPTIM2_CCMR1 ((volatile _GPTIM_CCMR1 *)(GPTIM2_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t CC3S:2;
        __IO uint32_t IC3PSC:2;
        __IO uint32_t IC3F:4;
        __IO uint32_t CC4S:2;
        __IO uint32_t IC4PSC:2;
        __IO uint32_t IC4F:4;
        uint32_t reserved:16;
    }INBits;
    struct
    {
        __IO uint32_t CC3S:2;
        __IO uint32_t OC3FE:1;
        __IO uint32_t OC3PE:1;
        __IO uint32_t OC3M:3;
        __IO uint32_t OC3CE:1;
        __IO uint32_t CC4S:2;
        __IO uint32_t OC4FE:1;
        __IO uint32_t OC4PE:1;
        __IO uint32_t OC4M:2;
        __IO uint32_t OC4CE:1;
        uint32_t reserved:16;
    }OUTBits;
    __IO uint32_t All;
}_GPTIM_CCMR2;
#define GPTIM0_CCMR2 ((volatile _GPTIM_CCMR2 *)(GPTIM0_BASE + 0x1C))
#define GPTIM1_CCMR2 ((volatile _GPTIM_CCMR2 *)(GPTIM1_BASE + 0x1C))
#define GPTIM2_CCMR2 ((volatile _GPTIM_CCMR2 *)(GPTIM2_BASE + 0x1C))

typedef union
{
    struct
    {
        __IO uint32_t CC1E:1;
        __IO uint32_t CC1P:1;
        uint32_t reserved0:2;
        __IO uint32_t CC2E:1;
        __IO uint32_t CC2P:1;
        uint32_t reserved1:2;
        __IO uint32_t CC3E:1;
        __IO uint32_t CC3P:1;
        uint32_t reserved2:2;
        __IO uint32_t CC4E:1;
        __IO uint32_t CC4P:1;
        uint32_t reserved3:18;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CCER;
#define GPTIM0_CCER ((volatile _GPTIM_CCER *)(GPTIM0_BASE + 0x20))
#define GPTIM1_CCER ((volatile _GPTIM_CCER *)(GPTIM1_BASE + 0x20))
#define GPTIM2_CCER ((volatile _GPTIM_CCER *)(GPTIM2_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t CNT:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CNT;
#define GPTIM0_CNT ((volatile _GPTIM_CNT *)(GPTIM0_BASE + 0x24))
#define GPTIM1_CNT ((volatile _GPTIM_CNT *)(GPTIM1_BASE + 0x24))
#define GPTIM2_CNT ((volatile _GPTIM_CNT *)(GPTIM2_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t PSC:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_PCS;
#define GPTIM0_PCS ((volatile _GPTIM_PCS *)(GPTIM0_BASE + 0x28))
#define GPTIM1_PCS ((volatile _GPTIM_PCS *)(GPTIM1_BASE + 0x28))
#define GPTIM2_PCS ((volatile _GPTIM_PCS *)(GPTIM2_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t ARR:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_ARR;
#define GPTIM0_ARR ((volatile _GPTIM_ARR *)(GPTIM0_BASE + 0x2C))
#define GPTIM1_ARR ((volatile _GPTIM_ARR *)(GPTIM1_BASE + 0x2C))
#define GPTIM2_ARR ((volatile _GPTIM_ARR *)(GPTIM2_BASE + 0x2C))

typedef union
{
    struct
    {
        __IO uint32_t CCR1:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CCR1;
#define GPTIM0_CCR1 ((volatile _GPTIM_CCR1 *)(GPTIM0_BASE + 0x34))
#define GPTIM1_CCR1 ((volatile _GPTIM_CCR1 *)(GPTIM1_BASE + 0x34))
#define GPTIM2_CCR1 ((volatile _GPTIM_CCR1 *)(GPTIM2_BASE + 0x34))

typedef union
{
    struct
    {
        __IO uint32_t CCR2:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CCR2;
#define GPTIM0_CCR2 ((volatile _GPTIM_CCR2 *)(GPTIM0_BASE + 0x38))
#define GPTIM1_CCR2 ((volatile _GPTIM_CCR2 *)(GPTIM1_BASE + 0x38))
#define GPTIM2_CCR2 ((volatile _GPTIM_CCR2 *)(GPTIM2_BASE + 0x38))

typedef union
{
    struct
    {
        __IO uint32_t CCR3:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CCR3;
#define GPTIM0_CCR3 ((volatile _GPTIM_CCR3 *)(GPTIM0_BASE + 0x3C))
#define GPTIM1_CCR3 ((volatile _GPTIM_CCR3 *)(GPTIM1_BASE + 0x3C))
#define GPTIM2_CCR3 ((volatile _GPTIM_CCR3 *)(GPTIM2_BASE + 0x3C))

typedef union
{
    struct
    {
        __IO uint32_t CCR4:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_CCR4;
#define GPTIM0_CCR4 ((volatile _GPTIM_CCR4 *)(GPTIM0_BASE + 0x40))
#define GPTIM1_CCR4 ((volatile _GPTIM_CCR4 *)(GPTIM1_BASE + 0x40))
#define GPTIM2_CCR4 ((volatile _GPTIM_CCR4 *)(GPTIM2_BASE + 0x40))

typedef union
{
    struct
    {
        __IO uint32_t DBA:5;
        uint32_t reserved0:3;
        __IO uint32_t DBL:5;
        uint32_t reserved1:19;
    }Bits;
    __IO uint32_t All;
}_GPTIM_DCR;
#define GPTIM0_DCR ((volatile _GPTIM_DCR *)(GPTIM0_BASE + 0x48))
#define GPTIM1_DCR ((volatile _GPTIM_DCR *)(GPTIM1_BASE + 0x48))
#define GPTIM2_DCR ((volatile _GPTIM_DCR *)(GPTIM2_BASE + 0x48))

typedef union
{
    struct
    {
        __IO uint32_t DMAR:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_GPTIM_DMAR;
#define GPTIM0_DMAR ((volatile _GPTIM_DMAR *)(GPTIM0_BASE + 0x4C))
#define GPTIM1_DMAR ((volatile _GPTIM_DMAR *)(GPTIM1_BASE + 0x4C))
#define GPTIM2_DMAR ((volatile _GPTIM_DMAR *)(GPTIM2_BASE + 0x4C))

typedef union
{
    struct
    {
        __IO uint32_t ITR0SEL:2;
        __IO uint32_t ITR1SEL:2;
        __IO uint32_t ITR2SEL:2;
        __IO uint32_t ITR3SEL:2;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_GPTIM_ITRSEL;
#define GPTIM0_ITRSEL ((volatile _GPTIM_ITRSEL *)(GPTIM0_BASE + 0x60))
#define GPTIM1_ITRSEL ((volatile _GPTIM_ITRSEL *)(GPTIM1_BASE + 0x60))
#define GPTIM2_ITRSEL ((volatile _GPTIM_ITRSEL *)(GPTIM2_BASE + 0x60))



//BSTIM32 registers define
typedef union
{
    struct
    {
        __IO uint32_t CEN:1;
        __IO uint32_t UDIS:1;
        __IO uint32_t URS:1;
        __IO uint32_t OPM:1;
        uint32_t reserved0:3;
        __IO uint32_t ARPE:1;
        uint32_t reserved1:24;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_CR1;
#define BSTIM32_CR1 ((volatile _BSTIM32_CR1 *)(BSTIM32_BASE + 0x00))

typedef union
{
    struct
    {
        uint32_t reserved0:4;
        __IO uint32_t MMS:3;
        uint32_t reserved1:25;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_CR2;
#define BSTIM32_CR2 ((volatile _BSTIM32_CR2 *)(BSTIM32_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t UIE:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_IER;
#define BSTIM32_IER ((volatile _BSTIM32_IER *)(BSTIM32_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t UIF:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_ISR;
#define BSTIM32_ISR ((volatile _BSTIM32_ISR *)(BSTIM32_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t UG:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_EGR;
#define BSTIM32_EGR ((volatile _BSTIM32_EGR *)(BSTIM32_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t CNT:32;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_CNT;
#define BSTIM32_CNT ((volatile _BSTIM32_CNT *)(BSTIM32_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t PSC:32;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_PSC;
#define BSTIM32_PSC ((volatile _BSTIM32_PSC *)(BSTIM32_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t ARR:32;
    }Bits;
    __IO uint32_t All;
}_BSTIM32_ARR;
#define BSTIM32_ARR ((volatile _BSTIM32_ARR *)(BSTIM32_BASE + 0x2C))



//BSTIM16 registers define
typedef union
{
    struct
    {
        __IO uint32_t CEN:1;
        __IO uint32_t UDIS:1;
        __IO uint32_t URS:1;
        __IO uint32_t OPM:1;
        uint32_t reserved0:3;
        __IO uint32_t ARPE:1;
        uint32_t reserved1:24;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_CR1;
#define BSTIM16_CR1 ((volatile _BSTIM16_CR1 *)(BSTIM16_BASE + 0x00))

typedef union
{
    struct
    {
        uint32_t reserved0:4;
        __IO uint32_t MMS:3;
        uint32_t reserved1:25;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_CR2;
#define BSTIM16_CR2 ((volatile _BSTIM16_CR2 *)(BSTIM16_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t UIE:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_IER;
#define BSTIM16_IER ((volatile _BSTIM16_IER *)(BSTIM16_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t UIF:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_ISR;
#define BSTIM16_ISR ((volatile _BSTIM16_ISR *)(BSTIM16_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t UG:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_EGR;
#define BSTIM16_EGR ((volatile _BSTIM16_EGR *)(BSTIM16_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t CNT:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_CNT;
#define BSTIM16_CNT ((volatile _BSTIM16_CNT *)(BSTIM16_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t PSC:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_PSC;
#define BSTIM16_PSC ((volatile _BSTIM16_PSC *)(BSTIM16_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t ARR:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_BSTIM16_ARR;
#define BSTIM16_ARR ((volatile _BSTIM16_ARR *)(BSTIM16_BASE + 0x2C))



//LPTIM32 registers define
typedef union
{
    struct
    {
        __IO uint32_t TMODE:2;
        __IO uint32_t ONST:1;
        uint32_t reserved0:2;
        __IO uint32_t TRIGCFG:2;
        __IO uint32_t EDGESEL:1;
        uint32_t reserved1:2;
        __IO uint32_t DIVSEL:3;
        uint32_t reserved2:1;
        __IO uint32_t PSCSEL:1;
        uint32_t reserved3:1;
        __IO uint32_t MMS:3;
        uint32_t reserved4:5;
        __IO uint32_t ETR_AFEN:1;
        uint32_t reserved5:7;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CFGR;
#define LPTIM32_CFGR ((volatile _LPTIM32_CFGR *)(LPTIM32_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t CNT32:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CNT;
#define LPTIM32_CNT ((volatile _LPTIM32_CNT *)(LPTIM32_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t CC1S:2;
        __IO uint32_t CC2S:2;
        __IO uint32_t CC3S:2;
        __IO uint32_t CC4S:2;
        __IO uint32_t CAPCFG1:2;
        __IO uint32_t CAPCFG2:2;
        __IO uint32_t CAPCFG3:2;
        __IO uint32_t CAPCFG4:2;
        __IO uint32_t POLAR1:1;
        __IO uint32_t POLAR2:1;
        __IO uint32_t POLAR3:1;
        __IO uint32_t POLAR4:1;
        __IO uint32_t CAP1EDGE:1;
        __IO uint32_t CAP2EDGE:1;
        __IO uint32_t CAP3EDGE:1;
        __IO uint32_t CAP4EDGE:1;
        __IO uint32_t CAP1SSEL:2;
        uint32_t reserved:6;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CCSR;
#define LPTIM32_CCSR ((volatile _LPTIM32_CCSR *)(LPTIM32_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t ARR:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_ARR;
#define LPTIM32_ARR ((volatile _LPTIM32_ARR *)(LPTIM32_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t CC1IE:1;
        __IO uint32_t CC2IE:1;
        __IO uint32_t CC3IE:1;
        __IO uint32_t CC4IE:1;
        uint32_t reserved0:2;
        __IO uint32_t OVIE:1;
        __IO uint32_t TRIGIE:1;
        __IO uint32_t OVR1IE:1;
        __IO uint32_t OVR2IE:1;
        __IO uint32_t OVR3IE:1;
        __IO uint32_t OVR4IE:1;
        uint32_t reserved1:20;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_IER;
#define LPTIM32_IER ((volatile _LPTIM32_IER *)(LPTIM32_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t CC1IF:1;
        __IO uint32_t CC2IF:1;
        __IO uint32_t CC3IF:1;
        __IO uint32_t CC4IF:1;
        uint32_t reserved0:2;
        __IO uint32_t OVIF:1;
        __IO uint32_t TRIGIF:1;
        __IO uint32_t CAP1OVR:1;
        __IO uint32_t CAP2OVR:1;
        __IO uint32_t CAP3OVR:1;
        __IO uint32_t CAP4OVR:1;
        uint32_t reserved1:20;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_ISR;
#define LPTIM32_ISR ((volatile _LPTIM32_ISR *)(LPTIM32_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CR;
#define LPTIM32_CR ((volatile _LPTIM32_CR *)(LPTIM32_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t CCR1:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CCR1;
#define LPTIM32_CCR1 ((volatile _LPTIM32_CCR1 *)(LPTIM32_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t CCR2:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CCR2;
#define LPTIM32_CCR2 ((volatile _LPTIM32_CCR2 *)(LPTIM32_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t CCR3:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CCR3;
#define LPTIM32_CCR3 ((volatile _LPTIM32_CCR3 *)(LPTIM32_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t CCR4:32;
    }Bits;
    __IO uint32_t All;
}_LPTIM32_CCR4;
#define LPTIM32_CCR4 ((volatile _LPTIM_CCR4 *)(LPTIM32_BASE + 0x2C))



//LPTIM16 registers define
typedef union
{
    struct
    {
        __IO uint32_t TMODE:2;
        __IO uint32_t ONST:1;
        __IO uint32_t QEMD:2;
        __IO uint32_t TRIGCFG:2;
        __IO uint32_t EDGESEL:1;
        uint32_t reserved0:2;
        __IO uint32_t DIVSEL:3;
        uint32_t reserved1:1;
        __IO uint32_t PSCSEL:1;
        uint32_t reserved2:1;
        __IO uint32_t MMS:3;
        uint32_t reserved3:5;
        __IO uint32_t ETR_AFEN:1;
        uint32_t reserved4:7;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CFGR;
#define LPTIM16_CFGR ((volatile _LPTIM16_CFGR *)(LPTIM16_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t CNT16:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CNT;
#define LPTIM16_CNT ((volatile _LPTIM16_CNT *)(LPTIM16_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t CC1S:2;
        __IO uint32_t CC2S:2;
        uint32_t reserved0:4;
        __IO uint32_t CAPCFG1:2;
        __IO uint32_t CAPCFG2:2;
        __IO uint32_t CC1DF:1;
        __IO uint32_t CC2DF:1;
        uint32_t reserved1:2;
        __IO uint32_t CC1P:1;
        __IO uint32_t CC2P:1;
        uint32_t reserved2:2;
        __IO uint32_t CAP1EDGE:1;
        __IO uint32_t CAP2EDGE:1;
        uint32_t reserved3:2;
        __IO uint32_t CAP1SSEL:2;
        __IO uint32_t CAP1PSC:6;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CCSR;
#define LPTIM16_CCSR ((volatile _LPTIM16_CCSR *)(LPTIM16_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t ARR:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_ARR;
#define LPTIM16_ARR ((volatile _LPTIM16_ARR *)(LPTIM16_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t CC1IE:1;
        __IO uint32_t CC2IE:1;
        uint32_t reserved0:4;
        __IO uint32_t OVIE:1;
        __IO uint32_t TRIGIE:1;
        __IO uint32_t OVR1IE:1;
        __IO uint32_t OVR2IE:1;
        uint32_t reserved1:22;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_IER;
#define LPTIM16_IER ((volatile _LPTIM16_IER *)(LPTIM16_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t CC1IF:1;
        __IO uint32_t CC2IF:1;
        uint32_t reserved0:4;
        __IO uint32_t OVIF:1;
        __IO uint32_t TRIGIF:1;
        __IO uint32_t CAP1OVR:1;
        __IO uint32_t CAP2OVR:1;
        uint32_t reserved1:22;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_ISR;
#define LPTIM16_ISR ((volatile _LPTIM16_ISR *)(LPTIM16_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t EN:1;
        uint32_t reserved:31;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CR;
#define LPTIM16_CR ((volatile _LPTIM16_CR *)(LPTIM16_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t CCR1:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CCR1;
#define LPTIM16_CCR1 ((volatile _LPTIM16_CCR1 *)(LPTIM16_BASE + 0x20))

typedef union
{
    struct
    {
        __IO uint32_t CCR2:16;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_LPTIM16_CCR2;
#define LPTIM16_CCR2 ((volatile _LPTIM16_CCR2 *)(LPTIM16_BASE + 0x24))



//LCD registers define
typedef union
{
    struct
    {
        __IO uint32_t LCDEN:1;
        __IO uint32_t LMUX:2;
        __IO uint32_t WFT:1;
        __IO uint32_t ANTIPOLAR:1;
        __IO uint32_t BIASMD:1;
        uint32_t reserved0:2;
        __IO uint32_t LCDBIAS:4;
        uint32_t reserved1:2;
        __IO uint32_t FLICK:1;
        __IO uint32_t ENMODE:1;
        __IO uint32_t IC_CTRL:2;
        __IO uint32_t SC_CTRL:2;
        __IO uint32_t SCFSEL:3;
        uint32_t reserved2:9;
    }Bits;
    __IO uint32_t All;
}_LCD_CR;
#define LCD_CR ((volatile _LCD_CR *)(LCD_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t TESTEN:1;
        uint32_t reserved0:6;
        __IO uint32_t LCCTRL:1;
        uint32_t reserved1:24;
    }Bits;
    __IO uint32_t All;
}_LCD_TEST;
#define LCD_TEST ((volatile _LCD_TEST *)(LCD_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t DF:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_LCD_FCR;
#define LCD_FCR ((volatile _LCD_FCR *)(LCD_BASE + 0x08))

typedef union
{
    struct
    {
        __IO uint32_t TON:8;
        __IO uint32_t TOFF:8;
        uint32_t reserved:16;
    }Bits;
    __IO uint32_t All;
}_LCD_FLKT;
#define LCD_FLKT ((volatile _LCD_FLKT *)(LCD_BASE + 0x0C))

typedef union
{
    struct
    {
        __IO uint32_t DOFFIE:1;
        __IO uint32_t DONIE:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_LCD_IER;
#define LCD_IER ((volatile _LCD_IER *)(LCD_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t DOFFIF:1;
        __IO uint32_t DONIF:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_LCD_ISR;
#define LCD_ISR ((volatile _LCD_ISR *)(LCD_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA0;
#define LCD_DATA0 ((volatile _LCD_DATA0 *)(LCD_BASE + 0x24))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA1;
#define LCD_DATA1 ((volatile _LCD_DATA1 *)(LCD_BASE + 0x28))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA2;
#define LCD_DATA2 ((volatile _LCD_DATA2 *)(LCD_BASE + 0x2C))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA3;
#define LCD_DATA3 ((volatile _LCD_DATA3 *)(LCD_BASE + 0x30))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA4;
#define LCD_DATA4 ((volatile _LCD_DATA4 *)(LCD_BASE + 0x34))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA5;
#define LCD_DATA5 ((volatile _LCD_DATA5 *)(LCD_BASE + 0x38))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA6;
#define LCD_DATA6 ((volatile _LCD_DATA6 *)(LCD_BASE + 0x3C))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA7;
#define LCD_DATA7 ((volatile _LCD_DATA7 *)(LCD_BASE + 0x40))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA8;
#define LCD_DATA8 ((volatile _LCD_DATA8 *)(LCD_BASE + 0x44))

typedef union
{
    struct
    {
        __IO uint32_t DSDA:32;
    }Bits;
    __IO uint32_t All;
}_LCD_DATA9;
#define LCD_DATA9 ((volatile _LCD_DATA9 *)(LCD_BASE + 0x48))

typedef union
{
    struct
    {
        __IO uint32_t COM0:1;
        __IO uint32_t COM1:1;
        __IO uint32_t COM2:1;
        __IO uint32_t COM3:1;
        uint32_t reserved:28;
    }Bits;
    __IO uint32_t All;
}_LCD_COMEN;
#define LCD_COMEN ((volatile _LCD_COMEN *)(LCD_BASE + 0x50))

typedef union
{
    struct
    {
        __IO uint32_t SEG0:1;
        __IO uint32_t SEG1:1;
        __IO uint32_t SEG2:1;
        __IO uint32_t SEG3:1;
        __IO uint32_t SEG4:1;
        __IO uint32_t SEG5:1;
        __IO uint32_t SEG6:1;
        __IO uint32_t SEG7:1;
        __IO uint32_t SEG8:1;
        __IO uint32_t SEG9:1;
        __IO uint32_t SEG10:1;
        __IO uint32_t SEG11:1;
        __IO uint32_t SEG12:1;
        __IO uint32_t SEG13:1;
        __IO uint32_t SEG14:1;
        __IO uint32_t SEG15:1;
        __IO uint32_t SEG16:1;
        __IO uint32_t SEG17:1;
        __IO uint32_t SEG18:1;
        __IO uint32_t SEG19:1;
        __IO uint32_t SEG20:1;
        __IO uint32_t SEG21:1;
        __IO uint32_t SEG22:1;
        __IO uint32_t SEG23:1;
        __IO uint32_t SEG24:1;
        __IO uint32_t SEG25:1;
        __IO uint32_t SEG26:1;
        __IO uint32_t SEG27:1;
        __IO uint32_t SEG28_COM4:1;
        __IO uint32_t SEG29_COM5:1;
        __IO uint32_t SEG30_COM6:1;
        __IO uint32_t SEG31_COM7:1;
    }Bits;
    __IO uint32_t All;
}_LCD_SEGEN0;
#define LCD_SEGEN0 ((volatile _LCD_SEGEN0 *)(LCD_BASE + 0x54))

typedef union
{
    struct
    {
        __IO uint32_t SEG32:1;
        __IO uint32_t SEG33:1;
        __IO uint32_t SEG34:1;
        __IO uint32_t SEG35:1;
        __IO uint32_t SEG36:1;
        __IO uint32_t SEG37:1;
        __IO uint32_t SEG38:1;
        __IO uint32_t SEG39:1;
        __IO uint32_t SEG40:1;
        __IO uint32_t SEG41:1;
        __IO uint32_t SEG42:1;
        __IO uint32_t SEG43:1;
        uint32_t reserved:20;
    }Bits;
    __IO uint32_t All;
}_LCD_SEGEN1;
#define LCD_SEGEN1 ((volatile _LCD_SEGEN1 *)(LCD_BASE + 0x58))



// GPIO register define
typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_INEN;
#define GPIOA_INEN ((volatile _GPIO_INEN *) (GPIOA_BASE + 0x00))
#define GPIOB_INEN ((volatile _GPIO_INEN *) (GPIOB_BASE + 0x00))
#define GPIOC_INEN ((volatile _GPIO_INEN *) (GPIOC_BASE + 0x00))
#define GPIOD_INEN ((volatile _GPIO_INEN *) (GPIOD_BASE + 0x00))
#define GPIOE_INEN ((volatile _GPIO_INEN *) (GPIOE_BASE + 0x00))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_PUEN;
#define GPIOA_PUEN ((volatile _GPIO_PUEN *) (GPIOA_BASE + 0x04))
#define GPIOB_PUEN ((volatile _GPIO_PUEN *) (GPIOB_BASE + 0x04))
#define GPIOC_PUEN ((volatile _GPIO_PUEN *) (GPIOC_BASE + 0x04))
#define GPIOD_PUEN ((volatile _GPIO_PUEN *) (GPIOD_BASE + 0x04))
#define GPIOE_PUEN ((volatile _GPIO_PUEN *) (GPIOE_BASE + 0x04))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_ODEN;
#define GPIOA_ODEN ((volatile _GPIO_ODEN *) (GPIOA_BASE + 0x08))
#define GPIOB_ODEN ((volatile _GPIO_ODEN *) (GPIOB_BASE + 0x08))
#define GPIOC_ODEN ((volatile _GPIO_ODEN *) (GPIOC_BASE + 0x08))
#define GPIOD_ODEN ((volatile _GPIO_ODEN *) (GPIOD_BASE + 0x08))
#define GPIOE_ODEN ((volatile _GPIO_ODEN *) (GPIOE_BASE + 0x08))

typedef union
{
    struct
        {
            __IO uint32_t P0FCR:2;
            __IO uint32_t P1FCR:2;
            __IO uint32_t P2FCR:2;
            __IO uint32_t P3FCR:2;
            __IO uint32_t P4FCR:2;
            __IO uint32_t P5FCR:2;
            __IO uint32_t P6FCR:2;
            __IO uint32_t P7FCR:2;
            __IO uint32_t P8FCR:2;
            __IO uint32_t P9FCR:2;
            __IO uint32_t P10FCR:2;
            __IO uint32_t P11FCR:2;
            __IO uint32_t P12FCR:2;
            __IO uint32_t P13FCR:2;
            __IO uint32_t P14FCR:2;
            __IO uint32_t P15FCR:2;
        }Bits;
        __IO uint32_t All;
}_GPIO_FCR;
#define GPIOA_FCR ((volatile _GPIO_FCR *) (GPIOA_BASE + 0x0C))
#define GPIOB_FCR ((volatile _GPIO_FCR *) (GPIOB_BASE + 0x0C))
#define GPIOC_FCR ((volatile _GPIO_FCR *) (GPIOC_BASE + 0x0C))
#define GPIOD_FCR ((volatile _GPIO_FCR *) (GPIOD_BASE + 0x0C))
#define GPIOE_FCR ((volatile _GPIO_FCR *) (GPIOE_BASE + 0x0C))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_DO;
#define GPIOA_DO ((volatile _GPIO_DO *) (GPIOA_BASE + 0x10))
#define GPIOB_DO ((volatile _GPIO_DO *) (GPIOB_BASE + 0x10))
#define GPIOC_DO ((volatile _GPIO_DO *) (GPIOC_BASE + 0x10))
#define GPIOD_DO ((volatile _GPIO_DO *) (GPIOD_BASE + 0x10))
#define GPIOE_DO ((volatile _GPIO_DO *) (GPIOE_BASE + 0x10))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_DSET;
#define GPIOA_DSET ((volatile _GPIO_DSET *) (GPIOA_BASE + 0x14))
#define GPIOB_DSET ((volatile _GPIO_DSET *) (GPIOB_BASE + 0x14))
#define GPIOC_DSET ((volatile _GPIO_DSET *) (GPIOC_BASE + 0x14))
#define GPIOD_DSET ((volatile _GPIO_DSET *) (GPIOD_BASE + 0x14))
#define GPIOE_DSET ((volatile _GPIO_DSET *) (GPIOE_BASE + 0x14))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_DRST;
#define GPIOA_DRST ((volatile _GPIO_DRST *) (GPIOA_BASE + 0x18))
#define GPIOB_DRST ((volatile _GPIO_DRST *) (GPIOB_BASE + 0x18))
#define GPIOC_DRST ((volatile _GPIO_DRST *) (GPIOC_BASE + 0x18))
#define GPIOD_DRST ((volatile _GPIO_DRST *) (GPIOD_BASE + 0x18))
#define GPIOE_DRST ((volatile _GPIO_DRST *) (GPIOE_BASE + 0x18))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_DIN;
#define GPIOA_DIN ((volatile _GPIO_DIN *) (GPIOA_BASE + 0x1C))
#define GPIOB_DIN ((volatile _GPIO_DIN *) (GPIOB_BASE + 0x1C))
#define GPIOC_DIN ((volatile _GPIO_DIN *) (GPIOC_BASE + 0x1C))
#define GPIOD_DIN ((volatile _GPIO_DIN *) (GPIOD_BASE + 0x1C))
#define GPIOE_DIN ((volatile _GPIO_DIN *) (GPIOE_BASE + 0x1C))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_DFS;
#define GPIOA_DFS ((volatile _GPIO_DFS *) (GPIOA_BASE + 0x20))
#define GPIOB_DFS ((volatile _GPIO_DFS *) (GPIOB_BASE + 0x20))
#define GPIOC_DFS ((volatile _GPIO_DFS *) (GPIOC_BASE + 0x20))
#define GPIOD_DFS ((volatile _GPIO_DFS *) (GPIOD_BASE + 0x20))
#define GPIOE_DFS ((volatile _GPIO_DFS *) (GPIOE_BASE + 0x20))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_ANEN;
#define GPIOA_ANEN ((volatile _GPIO_ANEN *) (GPIOA_BASE + 0x28))
#define GPIOB_ANEN ((volatile _GPIO_ANEN *) (GPIOB_BASE + 0x28))
#define GPIOC_ANEN ((volatile _GPIO_ANEN *) (GPIOC_BASE + 0x28))
#define GPIOD_ANEN ((volatile _GPIO_ANEN *) (GPIOD_BASE + 0x28))
#define GPIOE_ANEN ((volatile _GPIO_ANEN *) (GPIOE_BASE + 0x28))

typedef union
{
    struct
        {
            __IO uint32_t PIN0:1;
            __IO uint32_t PIN1:1;
            __IO uint32_t PIN2:1;
            __IO uint32_t PIN3:1;
            __IO uint32_t PIN4:1;
            __IO uint32_t PIN5:1;
            __IO uint32_t PIN6:1;
            __IO uint32_t PIN7:1;
            __IO uint32_t PIN8:1;
            __IO uint32_t PIN9:1;
            __IO uint32_t PIN10:1;
            __IO uint32_t PIN11:1;
            __IO uint32_t PIN12:1;
            __IO uint32_t PIN13:1;
            __IO uint32_t PIN14:1;
            __IO uint32_t PIN15:1;
            uint32_t reserved:16;
        }Bits;
        __IO uint32_t All;
}_GPIO_VILR;
#define GPIOA_VILR ((volatile _GPIO_VILR *) (GPIOA_BASE + 0x2C))
#define GPIOB_VILR ((volatile _GPIO_VILR *) (GPIOB_BASE + 0x2C))
#define GPIOC_VILR ((volatile _GPIO_VILR *) (GPIOC_BASE + 0x2C))
#define GPIOD_VILR ((volatile _GPIO_VILR *) (GPIOD_BASE + 0x2C))
#define GPIOE_VILR ((volatile _GPIO_VILR *) (GPIOE_BASE + 0x2C))



//GPIO common registers define
typedef union
{
    struct
    {
        __IO uint32_t ASEL:8;
        __IO uint32_t BSEL:8;
        __IO uint32_t CSEL:6;
        uint32_t reserved0:2;
        __IO uint32_t DSEL:6;
        uint32_t reserved1:2;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTISEL0;
#define GPIO_EXTISEL0 ((volatile _GPIO_EXTISEL0 *)(GPIO_COMMON_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t ESEL:8;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTISEL1;
#define GPIO_EXTISEL1 ((volatile _GPIO_EXTISEL1 *)(GPIO_COMMON_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t EXTI0_EDS:2;
        __IO uint32_t EXTI1_EDS:2;
        __IO uint32_t EXTI2_EDS:2;
        __IO uint32_t EXTI3_EDS:2;
        __IO uint32_t EXTI4_EDS:2;
        __IO uint32_t EXTI5_EDS:2;
        __IO uint32_t EXTI6_EDS:2;
        __IO uint32_t EXTI7_EDS:2;
        __IO uint32_t EXTI8_EDS:2;
        __IO uint32_t EXTI9_EDS:2;
        __IO uint32_t EXTI10_EDS:2;
        __IO uint32_t EXTI11_EDS:2;
        __IO uint32_t EXTI12_EDS:2;
        __IO uint32_t EXTI13_EDS:2;
        __IO uint32_t EXTI14_EDS:2;
        __IO uint32_t EXTI15_EDS:2;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTIEDS0;
#define GPIO_COMM_EXTIEDS0 ((volatile _GPIO_EXTIEDS0 *)(GPIO_COMMON_BASE + 0x08))    //重定义 临时改名插入_COMM

typedef union
{
    struct
    {
        __IO uint32_t EXTI16_EDS:2;
        __IO uint32_t EXTI17_EDS:2;
        __IO uint32_t EXTI18_EDS:2;
        uint32_t reserved:26;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTIEDS1;
#define GPIO_COMM_EXTIEDS1 ((volatile _GPIO_EXTIEDS1 *)(GPIO_COMMON_BASE + 0x0C))    //重定义 临时改名插入_COMM

typedef union
{
    struct
    {
        __IO uint32_t EXTI0_DF:1;
        __IO uint32_t EXTI1_DF:1;
        __IO uint32_t EXTI2_DF:1;
        __IO uint32_t EXTI3_DF:1;
        __IO uint32_t EXTI4_DF:1;
        __IO uint32_t EXTI5_DF:1;
        __IO uint32_t EXTI6_DF:1;
        __IO uint32_t EXTI7_DF:1;
        __IO uint32_t EXTI8_DF:1;
        __IO uint32_t EXTI9_DF:1;
        __IO uint32_t EXTI10_DF:1;
        __IO uint32_t EXTI11_DF:1;
        __IO uint32_t EXTI12_DF:1;
        __IO uint32_t EXTI13_DF:1;
        __IO uint32_t EXTI14_DF:1;
        __IO uint32_t EXTI15_DF:1;
        __IO uint32_t EXTI16_DF:1;
        __IO uint32_t EXTI17_DF:1;
        __IO uint32_t EXTI18_DF:1;
        uint32_t reserved:13;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTIDF;
#define GPIO_EXTIDF ((volatile _GPIO_EXTIDF *)(GPIO_COMMON_BASE + 0x10))

typedef union
{
    struct
    {
        __IO uint32_t EXTI0:1;
        __IO uint32_t EXTI1:1;
        __IO uint32_t EXTI2:1;
        __IO uint32_t EXTI3:1;
        __IO uint32_t EXTI4:1;
        __IO uint32_t EXTI5:1;
        __IO uint32_t EXTI6:1;
        __IO uint32_t EXTI7:1;
        __IO uint32_t EXTI8:1;
        __IO uint32_t EXTI9:1;
        __IO uint32_t EXTI10:1;
        __IO uint32_t EXTI11:1;
        __IO uint32_t EXTI12:1;
        __IO uint32_t EXTI13:1;
        __IO uint32_t EXTI14:1;
        __IO uint32_t EXTI15:1;
        __IO uint32_t EXTI16:1;
        __IO uint32_t EXTI17:1;
        __IO uint32_t EXTI18:1;
        uint32_t reserved:13;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTIISR;
#define GPIO_EXTIISR ((volatile _GPIO_EXTIISR *)(GPIO_COMMON_BASE + 0x14))

typedef union
{
    struct
    {
        __IO uint32_t EXTI0_DI:1;
        __IO uint32_t EXTI1_DI:1;
        __IO uint32_t EXTI2_DI:1;
        __IO uint32_t EXTI3_DI:1;
        __IO uint32_t EXTI4_DI:1;
        __IO uint32_t EXTI5_DI:1;
        __IO uint32_t EXTI6_DI:1;
        __IO uint32_t EXTI7_DI:1;
        __IO uint32_t EXTI8_DI:1;
        __IO uint32_t EXTI9_DI:1;
        __IO uint32_t EXTI10_DI:1;
        __IO uint32_t EXTI11_DI:1;
        __IO uint32_t EXTI12_DI:1;
        __IO uint32_t EXTI13_DI:1;
        __IO uint32_t EXTI14_DI:1;
        __IO uint32_t EXTI15_DI:1;
        __IO uint32_t EXTI16_DI:1;
        __IO uint32_t EXTI17_DI:1;
        __IO uint32_t EXTI18_DI:1;
        uint32_t reserved:13;
    }Bits;
    __IO uint32_t All;
}_GPIO_EXTIDI;
#define GPIO_EXTIDI ((volatile _GPIO_EXTIDI *)(GPIO_COMMON_BASE + 0x18))

typedef union
{
    struct
    {
        __IO uint32_t FOUT0SEL:4;
        __IO uint32_t FOUT1SEL:4;
        uint32_t reserved:24;
    }Bits;
    __IO uint32_t All;
}_GPIO_FOUTSEL;
#define GPIO_FOUTSEL ((volatile _GPIO_FOUTSEL *)(GPIO_COMMON_BASE + 0x40))

typedef union
{
    struct
    {
        __IO uint32_t PINWKEN0:1;
        __IO uint32_t PINWKEN1:1;
        __IO uint32_t PINWKEN2:1;
        __IO uint32_t PINWKEN3:1;
        __IO uint32_t PINWKEN4:1;
        __IO uint32_t PINWKEN5:1;
        __IO uint32_t PINWKEN6:1;
        __IO uint32_t PINWKEN7:1;
        __IO uint32_t PINWKEN8:1;
        __IO uint32_t PINWKEN9:1;
        __IO uint32_t PINWKSEL0:2;
        __IO uint32_t PINWKSEL1:2;
        __IO uint32_t PINWKSEL2:2;
        __IO uint32_t PINWKSEL3:2;
        __IO uint32_t PINWKSEL4:2;
        __IO uint32_t PINWKSEL5:2;
        __IO uint32_t PINWKSEL6:2;
        __IO uint32_t PINWKSEL7:2;
        __IO uint32_t PINWKSEL8:2;
        __IO uint32_t PINWKSEL9:2;
        uint32_t reserved:1;
        __IO uint32_t WKSEL:1;
    }Bits;
    __IO uint32_t All;
}_GPIO_PINWKEN;
#define GPIO_PINWKEN ((volatile _GPIO_PINWKEN *)(GPIO_COMMON_BASE + 0x140))



//DEBUG registers define
typedef union
{
    struct
    {
        __IO uint32_t MODE:2;
        __IO uint32_t FLSCFG:2;
        __IO uint32_t RAMCFG:1;
        uint32_t reserved0:3;
        __IO uint32_t RED_INFO:8;
        uint32_t reserved1:13;
        __IO uint32_t DCTFAIL:1;
        __IO uint32_t LDT1FAIL:1;
        __IO uint32_t LDT0FAIL:1;
    }Bits;
    __IO uint32_t All;
}_DBG_SYSCFG;
#define DBG_SYSCFG ((volatile _DBG_SYSCFG *)(DBG_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t DBG_IWDT_STOP:1;
        __IO uint32_t DBG_WWDT_STOP:1;
        uint32_t reserved0:6;
        __IO uint32_t DBG_BT32_STOP:1;
        __IO uint32_t DBG_GT0_STOP:1;
        __IO uint32_t DBG_GT1_STOP:1;
        __IO uint32_t DBG_GT2_STOP:1;
        __IO uint32_t DBG_LPT32_STOP:1;
        __IO uint32_t DBG_AT_STOP:1;
        __IO uint32_t DBG_BT16_STOP:1;
        __IO uint32_t DBG_LPT16_STOP:1;
        __IO uint32_t DBG_SLEEP:1;
        uint32_t reserved1:15;
    }Bits;
    __IO uint32_t All;
}_DBG_CR;
#define DBG_CR ((volatile _DBG_CR *)(DBG_BASE + 0x04))

typedef union
{
    struct
    {
        __IO uint32_t HDF_REQUEST_FLAG:1;
        __IO uint32_t SPECIAL_OP_FLAG:1;
        __IO uint32_t TBIT_FLAG:1;
        __IO uint32_t BKPT_FLAG:1;
        __IO uint32_t SVCUNDEF_FLAG:1;
        __IO uint32_t DABORT_RESP_FLAG:1;
        __IO uint32_t DABORT_ADDR_FLAG:1;
        uint32_t reserved:15;
    }Bits;
    __IO uint32_t All;
}_DBG_HDFR;
#define DBG_HDFR ((volatile _DBG_HDFR *)(DBG_BASE + 0x08))



//CDIF registers define
typedef union
{
    struct
    {
        __IO uint32_t INTF_OEN:1;
        __IO uint32_t INTF_IEN:1;
        uint32_t reserved:30;
    }Bits;
    __IO uint32_t All;
}_CDIF_CR;
#define CDIF_CR ((volatile _CDIF_CR *)(CDIF_BASE + 0x00))

typedef union
{
    struct
    {
        __IO uint32_t PRSC:3;
        uint32_t reserved:29;
    }Bits;
    __IO uint32_t All;
}_CDIF_PRSC;
#define CDIF_PRSC ((volatile _CDIF_PRSC *)(CDIF_BASE + 0x04))



/* -------------------------------------------------------------------------------- */



/* ================================================================================ */
/* ================                       FLS                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t RDCR;                   /*!<  Flash Read Control Register,                          Address offset: 0x00 */
  __IO uint32_t PFCR;                   /*!<  Flash Prefetch Control Register,                      Address offset: 0x04 */
  __I  uint32_t OPTBR;                  /*!<  Flash Option Bytes Register,                          Address offset: 0x08 */
  __IO uint32_t ACLOCK1;                /*!<  Flash Application Code Lock Register1,                Address offset: 0x0C */
  __IO uint32_t ACLOCK2;                /*!<  Flash Application Code Lock Register2,                Address offset: 0x10 */
  __IO uint32_t EPCR;                   /*!<  Flash Erase/Program Control Register,                 Address offset: 0x14 */
  __O  uint32_t KEY;                    /*!<  Flash Key Register,                                   Address offset: 0x18 */
  __IO uint32_t IER;                    /*!<  Flash Interrupt Enable Register,                      Address offset: 0x1C */
  __IO uint32_t ISR;                    /*!<  Flash Interrupt Status Register,                      Address offset: 0x20 */
}FLASH_Type;


/* ================================================================================ */
/* ================                       PMU                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  Power Management Control Register,                    Address offset: 0x00 */
  __IO uint32_t WKTR;                   /*!<  Wakeup Time Register,                                 Address offset: 0x04 */
  __IO uint32_t WKFR;                   /*!<  Wakeup Source Flags Register,                         Address offset: 0x08 */
  __IO uint32_t IER;                    /*!<  PMU Interrupt Enable Register,                        Address offset: 0x0C */
  __IO uint32_t ISR;                    /*!<  PMU Interrupt and Status Register,                    Address offset: 0x10 */
  __IO uint32_t RSV1[9];                /*!<  RESERVED REGISTER,                                    Address offset: 0x14 */
  __IO uint32_t ULPB_TR;                /*!<  ULPBG trim Register,                                  Address offset: 0x38 */
  __IO uint32_t VREFP_CR;               /*!<  VREFP Control Register,                               Address offset: 0x3C */
  __IO uint32_t VREFP_CFGR;             /*!<  VREFP Config Register,                                Address offset: 0x40 */
  __IO uint32_t VREFP_ISR;              /*!<  VREFP Interrupt Status Register,                      Address offset: 0x44 */
  __IO uint32_t VREFP_TR;               /*!<  VREFP Trim Register,                                  Address offset: 0x48 */
}PMU_Type;

/* ================================================================================ */
/* ================                       VREFP                     ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;               /*!<  VREFP Control Register,                               Address offset: 0x00 */
  __IO uint32_t CFGR;             /*!<  VREFP Config Register,                                Address offset: 0x04 */
  __IO uint32_t ISR;              /*!<  VREFP Interrupt Status Register,                      Address offset: 0x08 */
  __IO uint32_t TR;               /*!<  VREFP Trim Register,                                  Address offset: 0x0C */
}VREFP_Type;

/* ================================================================================ */
/* ================                      VREF                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  VREF Control Register,                                Address offset: 0x00 */
  __IO uint32_t CFGR;                   /*!<  VREF Config Register,                                 Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  VREF Status Register,                                 Address offset: 0x08 */
  __IO uint32_t IER;                    /*!<  VREF Interrupt Enable Register,                       Address offset: 0x0C */
  __IO uint32_t BUFCR;                  /*!<  Buffer Control Register,                              Address offset: 0x10 */
}VREF_Type;


/* ================================================================================ */
/* ================                       VAO                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t RSV1[512];              /*!<  RESERVED REGISTER,                                    Address offset: 0x00 */
  __IO uint32_t RSTCR;                 /*!<  VBAT Reset Control Register,                          Address offset: 0x800 */
  __IO uint32_t XTLFCR;                /*!<  XTLF Control Register,                                Address offset: 0x804 */
  __IO uint32_t XTLFPR;                /*!<  XTLF Power Register,                                  Address offset: 0x808 */
  __IO uint32_t FDIER;                 /*!<  XTLF Oscillation Fail Detection Interrupt Enable Register,Address offset: 0x80C */
  __IO uint32_t FDISR;                 /*!<  XTLF Oscillation Fail Detection Interrupt Status Register,Address offset: 0x810 */
  __IO uint32_t RSV2[251];              /*!<  RESERVED REGISTER,                                    Address offset: 0x814 */
  __IO uint32_t INEN;                   /*!<  VAO IO Input Enable Register,                         Address offset: 0xC00 */
  __IO uint32_t PUEN;                   /*!<  VAO IO Pull-up Enable Register,                       Address offset: 0xC04 */
  __IO uint32_t ODEN;                   /*!<  VAO IO Open Drain Enable Register,                    Address offset: 0xC08 */
  __IO uint32_t FCR;                    /*!<  VAO IO Function Control Register,                     Address offset: 0xC0C */
  __IO uint32_t DOR;                    /*!<  VAO IO Data Output Register,                          Address offset: 0xC10 */
  __I  uint32_t DIR;                    /*!<  VAO IO Data Input Register,                           Address offset: 0xC14 */
  __IO uint32_t VILR;                   /*!<  VAO IO Voltage Input Low Register,                    Address offset: 0xC18 */
}VAO_Type;


/* ================================================================================ */
/* ================                      CDIF                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  ,                                                     Address offset: 0x00 */
  __IO uint32_t PRSC;                   /*!<  ,                                                     Address offset: 0x04 */
}CDIF_Type;


/* ================================================================================ */
/* ================                       RMU                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t PDRCR;                  /*!<  PDR Control Register,                                 Address offset: 0x00 */
  __IO uint32_t BORCR;                  /*!<  BOR Control Register,                                 Address offset: 0x04 */
  __IO uint32_t LKPCR;                  /*!<  Reset Config Register,                                Address offset: 0x08 */
  __O  uint32_t SOFTRST;                /*!<  Software Reset Register,                              Address offset: 0x0C */
  __IO uint32_t RSTFR;                  /*!<  Reset Flag Register,                                  Address offset: 0x10 */
  __O  uint32_t PRSTEN;                 /*!<  Peripheral Reset Enable Register,                     Address offset: 0x14 */
  __IO uint32_t AHBRSTCR;               /*!<  AHB Peripherals Reset Register,                       Address offset: 0x18 */
  __IO uint32_t APBRSTCR1;              /*!<  APB Peripherals Reset Register1,                      Address offset: 0x1C */
  __IO uint32_t APBRSTCR2;              /*!<  APB Peripherals Reset Register2,                      Address offset: 0x20 */
}RMU_Type;


/* ================================================================================ */
/* ================                      IWDT                      ================ */
/* ================================================================================ */

typedef struct
{
  __O  uint32_t SERV;                   /*!<  IWDT Service Register,                                Address offset: 0x00 */
  __IO uint32_t CR;                     /*!<  IWDT Config Register,                                 Address offset: 0x04 */
  __I  uint32_t CNT;                    /*!<  IWDT Counter Register,                                Address offset: 0x08 */
  __IO uint32_t WIN;                    /*!<  IWDT Window Register,                                 Address offset: 0x0C */
  __IO uint32_t IER;                    /*!<  IWDT Interrupt Enable Register,                       Address offset: 0x10 */
  __IO uint32_t ISR;                    /*!<  IWDT Interrupt Status Register,                       Address offset: 0x14 */
}IWDT_Type;


/* ================================================================================ */
/* ================                      WWDT                      ================ */
/* ================================================================================ */

typedef struct
{
  __O  uint32_t CR;                     /*!<  WWDT Control Register,                                Address offset: 0x00 */
  __IO uint32_t CFGR;                   /*!<  WWDT Config Register,                                 Address offset: 0x04 */
  __I  uint32_t CNT;                    /*!<  WWDT Counter Register,                                Address offset: 0x08 */
  __IO uint32_t IER;                    /*!<  WWDT Interrupt Enable Register,                       Address offset: 0x0C */
  __IO uint32_t ISR;                    /*!<  WWDT Interrupt Status Register,                       Address offset: 0x10 */
  __I  uint32_t PSC;                    /*!<  WWDT Prescaler Register,                              Address offset: 0x14 */
}WWDT_Type;


/* ================================================================================ */
/* ================                       CMU                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t SYSCLKCR;               /*!<  System Clock Control Register,                        Address offset: 0x00 */
  __IO uint32_t RCHFCR;                 /*!<  RCHF Control Register,                                Address offset: 0x04 */
  __IO uint32_t RCHFTR;                 /*!<  RCHF Trim Register,                                   Address offset: 0x08 */
  __IO uint32_t PLLCR;                  /*!<  PLL Control Register,                                 Address offset: 0x0C */
  __IO uint32_t RCLPCR;                 /*!<  RCLP Control Register,                                Address offset: 0x10 */
  __IO uint32_t RCLPTR;                 /*!<  RCLP Trim Register,                                   Address offset: 0x14 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x18 */
  __IO uint32_t LSCLKSEL;               /*!<  LSCLK Select Register,                                Address offset: 0x1C */
  __IO uint32_t XTHFCR;                 /*!<  XTHF Control Register,                                Address offset: 0x20 */
  __IO uint32_t RCLFCR;                 /*!<  RCLF Control Register,                                Address offset: 0x24 */
  __IO uint32_t RCLFTR;                 /*!<  RCLF Trim Register,                                   Address offset: 0x28 */
  __IO uint32_t IER;                    /*!<  Interrupt Enable Register,                            Address offset: 0x2C */
  __IO uint32_t ISR;                    /*!<  Interrupt Status Register,                            Address offset: 0x30 */
  __IO uint32_t PCLKCR1;                /*!<  Peripheral bus Clock Control Register1,               Address offset: 0x34 */
  __IO uint32_t PCLKCR2;                /*!<  Peripheral bus Clock Control Register2,               Address offset: 0x38 */
  __IO uint32_t PCLKCR3;                /*!<  Peripheral bus Clock Control Register3,               Address offset: 0x3C */
  __IO uint32_t PCLKCR4;                /*!<  Peripheral bus Clock Control Register4,               Address offset: 0x40 */
  __IO uint32_t OPCCR1;                 /*!<  Peripheral Clock Config Register1,                    Address offset: 0x44 */
  __IO uint32_t OPCCR2;                 /*!<  Peripheral Clock Config Register 2,                   Address offset: 0x48 */
  __IO uint32_t OPCCR3;                 /*!<  Peripheral Clock Config Register 3,                   Address offset: 0x4C */
  __IO uint32_t AHBMCR;                 /*!<  AHB Master Control Register,                          Address offset: 0x50 */
  __IO uint32_t CCCR;                   /*!<  Clock Calibration Control Register,                   Address offset: 0x54 */
  __IO uint32_t CCFR;                   /*!<  Clock Calibration Config Register,                    Address offset: 0x58 */
  __I  uint32_t CCNR;                   /*!<  Clock Calibration Counter Register,                   Address offset: 0x5C */
  __IO uint32_t CCISR;                  /*!<  Clock Calibration Interrupt Status Register,          Address offset: 0x60 */
}CMU_Type;


/* ================================================================================ */
/* ================                       SVD                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CFGR;                   /*!<  SVD Config Register,                                  Address offset: 0x00 */
  __IO uint32_t CR;                     /*!<  SVD Control Register,                                 Address offset: 0x04 */
  __IO uint32_t IER;                    /*!<  SVD Interrupt Enable Register,                        Address offset: 0x08 */
  __IO uint32_t ISR;                    /*!<  SVD Interrupt Status Register,                        Address offset: 0x0C */
  __IO uint32_t VSR;                    /*!<  SVD reference Voltage Select Register,                Address offset: 0x10 */
}SVD_Type;


/* ================================================================================ */
/* ================                       AES                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  AES Control Register,                                 Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  AES Interrupt Enable Register,                        Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  AES Interrupt Status Register,                        Address offset: 0x08 */
  __IO uint32_t DIR;                    /*!<  AES Data Input Register,                              Address offset: 0x0C */
  __I  uint32_t DOR;                    /*!<  AES Data Output Register,                             Address offset: 0x10 */
  __IO uint32_t KEY0;                   /*!<  AES Key Register 0,                                   Address offset: 0x14 */
  __IO uint32_t KEY1;                   /*!<  AES Key Register 1,                                   Address offset: 0x18 */
  __IO uint32_t KEY2;                   /*!<  AES Key Register 2,                                   Address offset: 0x1C */
  __IO uint32_t KEY3;                   /*!<  AES Key Register 3,                                   Address offset: 0x20 */
  __IO uint32_t KEY4;                   /*!<  AES Key Register 4,                                   Address offset: 0x24 */
  __IO uint32_t KEY5;                   /*!<  AES Key Register 5,                                   Address offset: 0x28 */
  __IO uint32_t KEY6;                   /*!<  AES Key Register 6,                                   Address offset: 0x2C */
  __IO uint32_t KEY7;                   /*!<  AES Key Register 7,                                   Address offset: 0x30 */
  __IO uint32_t IVR0;                   /*!<  AES Initial Vector Register 0,                        Address offset: 0x34 */
  __IO uint32_t IVR1;                   /*!<  AES Initial Vector Register 1,                        Address offset: 0x38 */
  __IO uint32_t IVR2;                   /*!<  AES Initial Vector Register 2,                        Address offset: 0x3C */
  __IO uint32_t IVR3;                   /*!<  AES Initial Vector Register 3,                        Address offset: 0x40 */
  __IO uint32_t H0;                     /*!<  AES MultH parameter Register 0,                       Address offset: 0x44 */
  __IO uint32_t H1;                     /*!<  AES MultH parameter Register 1,                       Address offset: 0x48 */
  __IO uint32_t H2;                     /*!<  AES MultH parameter Register 2,                       Address offset: 0x4C */
  __IO uint32_t H3;                     /*!<  AES MultH parameter Register 3,                       Address offset: 0x50 */
}AES_Type;


/* ================================================================================ */
/* ================                       RNG                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  Random Number Generator Control Register,             Address offset: 0x00 */
  __I  uint32_t DOR;                    /*!<  Random Number Generator Data Output Register,         Address offset: 0x04 */
  __IO uint32_t RSV1[2];                /*!<  RESERVED REGISTER,                                    Address offset: 0x08 */
  __IO uint32_t SR;                     /*!<  Random Number Generator Status Register,              Address offset: 0x10 */
  __IO uint32_t CRCCR;                 /*!<  CRC Control Register,                                 Address offset: 0x14 */
  __IO uint32_t CRCDIR;                /*!<  CRC Data input Register,                              Address offset: 0x18 */
  __IO uint32_t CRCSR;                 /*!<  CRC Status Register,                                  Address offset: 0x1C */
}RNG_Type;


/* ================================================================================ */
/* ================                       OPA                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  OPA1 Control Register,                                Address offset: 0x00 */
  __IO uint32_t CALR;                   /*!<  OPA1 Calibration Register,                            Address offset: 0x04 */
  __I  uint32_t COR;                    /*!<  OPA1 Calibration Output Register,                     Address offset: 0x08 */
}OPA_Type;


/* ================================================================================ */
/* ================                      COMP                      ================ */
/* ================================================================================ */
typedef struct
{
  __IO uint32_t CR;              /*!< ComparatorControl Register 1,                        Address offset: 0x00 */

} COMP_Type;

typedef struct
{
  __IO uint32_t ICR;                    /*!<  Comparator Interrupt Config Register,                 Address offset: 0x0C */
  __IO uint32_t ISR;                    /*!<  Comparator Interrupt Status Register,                 Address offset: 0x10 */
  __IO uint32_t BUFCR;                  /*!<  Comparator Buffer Control Register,                   Address offset: 0x14 */
}COMP_COMMON_Type;


/* ================================================================================ */
/* ================                      CALC                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t OPRD;                   /*!<  Operand Register,                                     Address offset: 0x00 */
  __IO uint32_t DIVSOR;                 /*!<  Divisor Regsiter,                                     Address offset: 0x04 */
  __I  uint32_t QUOT;                   /*!<  Quotient Register,                                    Address offset: 0x08 */
  __I  uint32_t REMD;                   /*!<  Reminder Register,                                    Address offset: 0x0C */
  __I  uint32_t ROOT;                   /*!<  Root Register,                                        Address offset: 0x10 */
  __I  uint32_t SR;                     /*!<  Status Register,                                      Address offset: 0x14 */
  __IO uint32_t CR;                     /*!<  Control Register,                                     Address offset: 0x18 */
}DIVAS_Type;


/* ================================================================================ */
/* ================                       I2C                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t MSPCFGR;                /*!<  I2C Master Config Register,                           Address offset: 0x00 */
  __IO uint32_t MSPCR;                  /*!<  I2C Master Control Register,                          Address offset: 0x04 */
  __IO uint32_t MSPIER;                 /*!<  I2C Master Intterupt Enable Register,                 Address offset: 0x08 */
  __IO uint32_t MSPISR;                 /*!<  I2C Master Interrupt Status Register,                 Address offset: 0x0C */
  __IO uint32_t MSPSR;                  /*!<  I2C Master Status Register,                           Address offset: 0x10 */
  __IO uint32_t MSPBGR;                 /*!<  I2C Master Baud rate Generator Register,              Address offset: 0x14 */
  __IO uint32_t MSPBUF;                 /*!<  I2C Master transfer Buffer,                           Address offset: 0x18 */
  __IO uint32_t MSPTCR;                 /*!<  I2C Master Timing Control Register,                   Address offset: 0x1C */
  __IO uint32_t MSPTOR;                 /*!<  I2C Master Time-Out Register,                         Address offset: 0x20 */
  __IO uint32_t SSPCR;                  /*!<  I2C Slave Control Register,                           Address offset: 0x24 */
  __IO uint32_t SSPIER;                 /*!<  I2C Slave Interrupt Enable Register,                  Address offset: 0x28 */
  __IO uint32_t SSPISR;                 /*!<  I2C Slave Interrupt Status Register,                  Address offset: 0x2C */
  __I  uint32_t SSPSR;                  /*!<  I2C Slave Status Register,                            Address offset: 0x30 */
  __IO uint32_t SSPBUF;                 /*!<  I2C Slave transfer Buffer,                            Address offset: 0x34 */
  __IO uint32_t SSPADR;                 /*!<  I2C Slave Address Register,                           Address offset: 0x38 */
}I2C_Type;


/* ================================================================================ */
/* ================                     UART_COMMON                     ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t IRCR;                     /*!<  Infrared modulation Control Register,                 Address offset: 0x00 */
}UART_COMMON_Type;


/* ================================================================================ */
/* ================                      UARTx                     ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CSR;                    /*!<  UARTx Control Status Register,                        Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  UARTx Interrupt Enable Register,                      Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  UARTx Interrupt Status Register,                      Address offset: 0x08 */
  __IO uint32_t TODR;                   /*!<  UARTx Time-Out and Delay Register,                    Address offset: 0x0C */
  __I  uint32_t RXBUF;                  /*!<  UARTx Receive Buffer,                                 Address offset: 0x10 */
  __O  uint32_t TXBUF;                  /*!<  UARTx Transmit Buffer,                                Address offset: 0x14 */
  __IO uint32_t BGR;                    /*!<  UARTx Baud rate Generator Register,                   Address offset: 0x18 */
}UART_Type;


/* ================================================================================ */
/* ================                     LPUARTx                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CSR;                    /*!<  LPUARTx Control Status Register,                      Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  LPUARTx Interrupt Enable Register,                    Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  LPUARTx Interrupt Status Register,                    Address offset: 0x08 */
  __IO uint32_t BMR;                    /*!<  LPUARTx Baud rate Modulation Register,                Address offset: 0x0C */
  __I  uint32_t RXBUF;                  /*!<  LPUARTx Receive Buffer Register,                      Address offset: 0x10 */
  __IO uint32_t TXBUF;                  /*!<  LPUARTx Transmit Buffer Register,                     Address offset: 0x14 */
  __IO uint32_t DMR;                    /*!<  LPUARTx data Matching Register,                       Address offset: 0x18 */
}LPUART_Type;


/* ================================================================================ */
/* ================                      SPIx                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  SPIxControl Register1,                                Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  SPIxControl Register2,                                Address offset: 0x04 */
  __IO uint32_t CR3;                    /*!<  Control Register3,                                    Address offset: 0x08 */
  __IO uint32_t IER;                    /*!<  SPIxInterrupt Enable Register,                        Address offset: 0x0C */
  __IO uint32_t ISR;                    /*!<  SPIxStatus Register,                                  Address offset: 0x10 */
  __O  uint32_t TXBUF;                  /*!<  SPIxTransmit Buffer,                                  Address offset: 0x14 */
  __I  uint32_t RXBUF;                  /*!<  SPIxReceive Buffer,                                   Address offset: 0x18 */
}SPI_Type;


/* ================================================================================ */
/* ================                      U7816                     ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  7816 Control Register,                                Address offset: 0x00 */
  __IO uint32_t FFR;                   /*!<  7816 Frame Format Control Register,                   Address offset: 0x04 */
  __IO uint32_t EGTR;                   /*!<  7816 Extra Guard Time Register,                       Address offset: 0x08 */
  __IO uint32_t PSC;                   /*!<  7816 Clock Output Divider Register,                   Address offset: 0x0C */
  __IO uint32_t BGR;                   /*!<  7816 Prescaler Register,                              Address offset: 0x10 */
  __IO uint32_t RXBUF;                   /*!<  7816 data RX Buffer,                                  Address offset: 0x14 */
  __IO uint32_t TXBUF;                   /*!<  7816 data TX Buffer,                                  Address offset: 0x18 */
  __IO uint32_t IER;                    /*!<  7816 Interrupt Enable Register,                       Address offset: 0x1C */
  __IO uint32_t ISR;                    /*!<  7816 Interrupt Status Register,                       Address offset: 0x20 */
}U7816_Type;


/* ================================================================================ */
/* ================                       CAN                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  CAN Control Register,                                 Address offset: 0x00 */
  __IO uint32_t MSR;                    /*!<  CAN mode select register,                             Address offset: 0x04 */
  __IO uint32_t BRPR;                   /*!<  CAN Baud rate Prescaler Register,                     Address offset: 0x08 */
  __IO uint32_t BTR;                    /*!<  CAN Bit Timing Register,                              Address offset: 0x0C */
  __I  uint32_t ECR;                    /*!<  CAN Error Counter Register,                           Address offset: 0x10 */
  __IO uint32_t ESR;                    /*!<  CAN Error Status Register,                            Address offset: 0x14 */
  __I  uint32_t SR;                     /*!<  CAN Status Register,                                  Address offset: 0x18 */
  __I  uint32_t ISR;                    /*!<  CAN Interrupt Status Register,                        Address offset: 0x1C */
  __IO uint32_t IER;                    /*!<  CAN Interrupt Enable Register,                        Address offset: 0x20 */
  __IO uint32_t ICR;                    /*!<  CAN Interrupt Clear Register,                         Address offset: 0x24 */
  __IO uint32_t RSV1[2];                /*!<  RESERVED REGISTER,                                    Address offset: 0x28 */
  __O  uint32_t TXFIDR;                /*!<  CAN TX FIFO ID Register,                              Address offset: 0x30 */
  __O  uint32_t TXFDLCR;               /*!<  CAN TX FIFO DLC Register,                             Address offset: 0x34 */
  __O  uint32_t TXFDW1R;               /*!<  CAN TX FIFO Data Word1 Register,                      Address offset: 0x38 */
  __O  uint32_t TXFDW2R;               /*!<  CAN TX FIFO Data Word2 Register,                      Address offset: 0x3C */
  __O  uint32_t HPBIDR;                /*!<  CAN TX HPB ID Register,                               Address offset: 0x40 */
  __O  uint32_t HPBDLCR;               /*!<  CAN TX HPB DLC Register,                              Address offset: 0x44 */
  __O  uint32_t HPBDW1R;               /*!<  CAN TX HPB Data Word1 Register,                       Address offset: 0x48 */
  __O  uint32_t HPBDW2R;               /*!<  CAN TX HPB Data Word2 Register,                       Address offset: 0x4C */
  __O  uint32_t RXFIDR;                /*!<  CAN RX FIFO ID Register,                              Address offset: 0x50 */
  __O  uint32_t RXFDLCR;               /*!<  CAN RX FIFO DLC Register,                             Address offset: 0x54 */
  __O  uint32_t RXFDW1R;               /*!<  CAN RX FIFO Data Word1 Register,                      Address offset: 0x58 */
  __O  uint32_t RXFDW2R;               /*!<  CAN RX FIFO Data Word2 Register,                      Address offset: 0x5C */
  __IO uint32_t AFR;                    /*!<  Acceptance Filter Register,                           Address offset: 0x60 */
  __IO uint32_t AFMR0;                  /*!<  Acceptance Filter Mask Register0,                     Address offset: 0x64 */
  __IO uint32_t AFIR0;                  /*!<  Acceptance Filter ID Register0,                       Address offset: 0x68 */
  __IO uint32_t AFMR1;                  /*!<  Acceptance Filter Mask Register1,                     Address offset: 0x6C */
  __IO uint32_t AFIR1;                  /*!<  Acceptance Filter ID Register1,                       Address offset: 0x70 */
  __IO uint32_t AFMR2;                  /*!<  Acceptance Filter Mask Register2,                     Address offset: 0x74 */
  __IO uint32_t AFIR2;                  /*!<  Acceptance Filter ID Register2,                       Address offset: 0x78 */
  __IO uint32_t AFMR3;                  /*!<  Acceptance Filter Mask Register3,                     Address offset: 0x7C */
  __IO uint32_t AFIR3;                  /*!<  Acceptance Filter ID Register3,                       Address offset: 0x80 */
}CAN_Type;


/* ================================================================================ */
/* ================                       DMA                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t GCR;                    /*!<  DMA Global Control Register,                          Address offset: 0x00 */
  __IO uint32_t CH0CR;                  /*!<  Channel 0 Control Register,                           Address offset: 0x04 */
  __IO uint32_t CH0MAR;                 /*!<  Channel 0 Memory Address Register,                    Address offset: 0x08 */
  __IO uint32_t CH1CR;                  /*!<  Channel 1 Control Register,                           Address offset: 0x0C */
  __IO uint32_t CH1MAR;                 /*!<  Channel 1 Memory Address Register,                    Address offset: 0x10 */
  __IO uint32_t CH2CR;                  /*!<  Channel 2 Control Register,                           Address offset: 0x14 */
  __IO uint32_t CH2MAR;                 /*!<  Channel 2 Memory Address Register,                    Address offset: 0x18 */
  __IO uint32_t CH3CR;                  /*!<  Channel 3 Control Register,                           Address offset: 0x1C */
  __IO uint32_t CH3MAR;                 /*!<  Channel 3 Memory Address Register,                    Address offset: 0x20 */
  __IO uint32_t CH4CR;                  /*!<  Channel 4 Control Register,                           Address offset: 0x24 */
  __IO uint32_t CH4MAR;                 /*!<  Channel 4 Memory Address Register,                    Address offset: 0x28 */
  __IO uint32_t CH5CR;                  /*!<  Channel 5 Control Register,                           Address offset: 0x2C */
  __IO uint32_t CH5MAR;                 /*!<  Channel 5 Memory Address Register,                    Address offset: 0x30 */
  __IO uint32_t CH6CR;                  /*!<  Channel 6 Control Register,                           Address offset: 0x34 */
  __IO uint32_t CH6MAR;                 /*!<  Channel 6 Memory Address Register,                    Address offset: 0x38 */
  __IO uint32_t CH7CR;                  /*!<  Channel 11 Control Register,                          Address offset: 0x3C */
  __IO uint32_t CH7FLSAD;               /*!<  Channel 11 Flash Address Register,                    Address offset: 0x40 */
  __IO uint32_t CH7RAMAD;               /*!<  Channel 11 RAM Address Register,                      Address offset: 0x44 */
  __IO uint32_t ISR;                    /*!<  DMA Interrupt Status Register,                        Address offset: 0x48 */
}DMA_Type;


/* ================================================================================ */
/* ================                       CRC                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t DR;                     /*!<  CRC Data Register,                                    Address offset: 0x00 */
  __IO uint32_t CR;                     /*!<   Control Register,                                    Address offset: 0x04 */
  __IO uint32_t LFSR;                   /*!<  CRC Linear Feedback Shift Register,                   Address offset: 0x08 */
  __IO uint32_t XOR;                    /*!<  CRC output XOR Register,                              Address offset: 0x0C */
  __IO uint32_t RSV1[3];                /*!<  RESERVED REGISTER,                                    Address offset: 0x10 */
  __IO uint32_t POLY;                   /*!<  CRC Polynominal Register,                             Address offset: 0x1C */
}CRC_Type;


/* ================================================================================ */
/* ================                      ATIM                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  ATIM Control Register1,                               Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  ATIM Control Register2,                               Address offset: 0x04 */
  __IO uint32_t SMCR;                   /*!<  ATIM Slave Mode Control Register,                     Address offset: 0x08 */
  __IO uint32_t DIER;                   /*!<  ATIM DMA and Interrupt Enable Register,               Address offset: 0x0C */
  __IO uint32_t ISR;                    /*!<  ATIM Interrupt Status Register,                       Address offset: 0x10 */
  __O  uint32_t EGR;                    /*!<  ATIM Event Generation Register,                       Address offset: 0x14 */
  __IO uint32_t CCMR1;                  /*!<  ATIM Capture/Compare Mode Register1,                  Address offset: 0x18 */
  __IO uint32_t CCMR2;                  /*!<  ATIM Capture/Compare Mode Register2,                  Address offset: 0x1C */
  __IO uint32_t CCER;                   /*!<  ATIM Capture/Compare Enable Register,                 Address offset: 0x20 */
  __IO uint32_t CNT;                    /*!<  ATIM Counter Register,                                Address offset: 0x24 */
  __IO uint32_t PSC;                    /*!<  ATIM Prescaler Register,                              Address offset: 0x28 */
  __IO uint32_t ARR;                    /*!<  ATIM Auto-Reload Register,                            Address offset: 0x2C */
  __IO uint32_t RCR;                    /*!<  ATIM Repetition Counter Register,                     Address offset: 0x30 */
  __IO uint32_t CCR1;                   /*!<  ATIM Capture/Compare Register1,                       Address offset: 0x34 */
  __IO uint32_t CCR2;                   /*!<  ATIM Capture/Compare Register2,                       Address offset: 0x38 */
  __IO uint32_t CCR3;                   /*!<  ATIM Capture/Compare Register3,                       Address offset: 0x3C */
  __IO uint32_t CCR4;                   /*!<  ATIM Capture/Compare Register4,                       Address offset: 0x40 */
  __IO uint32_t BDTR;                   /*!<  ATIM Break and Deadtime Register,                     Address offset: 0x44 */
  __IO uint32_t DCR;                    /*!<  ATIM DMA Control Register,                            Address offset: 0x48 */
  __IO uint32_t DMAR;                   /*!<  ATIM DMA Access Register,                             Address offset: 0x4C */
  __IO uint32_t RSV1[4];                /*!<  RESERVED REGISTER,                                    Address offset: 0x50 */
  __IO uint32_t BKCR;                   /*!<  ATIM Break Control Register,                          Address offset: 0x60 */
}ATIM_Type;


/* ================================================================================ */
/* ================                     GPTIMx                     ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  GPTIMx Control Register1,                             Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  GPTIMx Control Register2,                             Address offset: 0x04 */
  __IO uint32_t SMCR;                   /*!<  GPTIMx Slave Mode Control Register,                   Address offset: 0x08 */
  __IO uint32_t DIER;                   /*!<  GPTIMx DMA and Interrupt Enable Register,             Address offset: 0x0C */
  __IO uint32_t ISR;                     /*!<   Interrupt Status Register,                           Address offset: 0x10 */
  __O  uint32_t EGR;                    /*!<  GPTIMx Event Generation Register,                     Address offset: 0x14 */
  __IO uint32_t CCMR1;                  /*!<  GPTIMx Capture/Compare Mode Register1,                Address offset: 0x18 */
  __IO uint32_t CCMR2;                  /*!<  GPTIMx Capture/Compare Mode Register2,                Address offset: 0x1C */
  __IO uint32_t CCER;                   /*!<  GPTIMx Capture/Compare Enable Register,               Address offset: 0x20 */
  __IO uint32_t CNT;                    /*!<  GPTIMx Counter Register,                              Address offset: 0x24 */
  __IO uint32_t PSC;                    /*!<  GPTIMx Prescaler Register,                            Address offset: 0x28 */
  __IO uint32_t ARR;                    /*!<  GPTIMx Auto-Reload Register,                          Address offset: 0x2C */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x30 */
  __IO uint32_t CCR1;                   /*!<  GPTIMx Capture/Compare Register1,                     Address offset: 0x34 */
  __IO uint32_t CCR2;                   /*!<  GPTIMx Capture/Compare Register2,                     Address offset: 0x38 */
  __IO uint32_t CCR3;                   /*!<  GPTIMx Capture/Compare Register3,                     Address offset: 0x3C */
  __IO uint32_t CCR4;                   /*!<  GPTIMx Capture/Compare Register4,                     Address offset: 0x40 */
  __IO uint32_t RSV2;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x44 */
  __IO uint32_t DCR;                    /*!<  GPTIMx DMA Control Register,                          Address offset: 0x48 */
  __IO uint32_t DMAR;                   /*!<  GPTIMx DMA access Register,                           Address offset: 0x4C */
  __IO uint32_t RSV3[4];                /*!<  RESERVED REGISTER,                                    Address offset: 0x50 */
  __IO uint32_t ITRSEL;                 /*!<  GPTIMx Internal Trigger Select Register,              Address offset: 0x60 */
}GPTIM_Type;


/* ================================================================================ */
/* ================                     BSTIM32                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  BSTIM Control Register1,                              Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  BSTIM Control Register2,                              Address offset: 0x04 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x08 */
  __IO uint32_t IER;                   /*!<  BSTIM Interrupt Enable Register,                      Address offset: 0x0C */
  __IO uint32_t ISR;                     /*!<  BSTIM Interrupt Status Register,                      Address offset: 0x10 */
  __O  uint32_t EGR;                    /*!<  BSTIM Event Generation Register,                      Address offset: 0x14 */
  __IO uint32_t RSV2[3];                /*!<  RESERVED REGISTER,                                    Address offset: 0x18 */
  __IO uint32_t CNT;                    /*!<  BSTIM Counter Register,                               Address offset: 0x24 */
  __IO uint32_t PSC;                    /*!<  BSTIM Prescaler Register,                             Address offset: 0x28 */
  __IO uint32_t ARR;                    /*!<  BSTIM Auto-Reload Register,                           Address offset: 0x2C */
}BSTIM32_Type;


/* ================================================================================ */
/* ================                     BSTIM16                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  BSTIM Control Register1,                              Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  BSTIM Control Register2,                              Address offset: 0x04 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x08 */
  __IO uint32_t IER;                   /*!<  BSTIM Interrupt Enable Register,                      Address offset: 0x0C */
  __IO uint32_t ISR;                     /*!<  BSTIM Interrupt Status Register,                      Address offset: 0x10 */
  __O  uint32_t EGR;                    /*!<  BSTIM Event Generation Register,                      Address offset: 0x14 */
  __IO uint32_t RSV2[3];                /*!<  RESERVED REGISTER,                                    Address offset: 0x18 */
  __IO uint32_t CNT;                    /*!<  BSTIM Counter Register,                               Address offset: 0x24 */
  __IO uint32_t PSC;                    /*!<  BSTIM Prescaler Register,                             Address offset: 0x28 */
  __IO uint32_t ARR;                    /*!<  BSTIM Auto-Reload Register,                           Address offset: 0x2C */
}BSTIM16_Type;


/* ================================================================================ */
/* ================                     LPTIM32                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CFGR;                   /*!<  LPTIM32 Config Register,                              Address offset: 0x00 */
  __I  uint32_t CNT;                    /*!<  LPTIM32 Counter Register,                             Address offset: 0x04 */
  __IO uint32_t CCSR;                   /*!<  LPTIM32 Capture/Compare Control and Status Register,  Address offset: 0x08 */
  __IO uint32_t ARR;                    /*!<  LPTIM32 Auto-Reload Register,                         Address offset: 0x0C */
  __IO uint32_t IER;                    /*!<  LPTIM32 Interrupt Enable Register,                    Address offset: 0x10 */
  __IO uint32_t ISR;                    /*!<  LPTIM32 Interrupt Status Register,                    Address offset: 0x14 */
  __IO uint32_t CR;                     /*!<  LPTIM32 Control Register,                             Address offset: 0x18 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x1C */
  __IO uint32_t CCR1;                   /*!<  LPTIM32 Capture/Compare Register1,                    Address offset: 0x20 */
  __IO uint32_t CCR2;                   /*!<  LPTIM32 Capture/Compare Register2,                    Address offset: 0x24 */
  __IO uint32_t CCR3;                   /*!<  LPTIM32 Capture/Compare Register3,                    Address offset: 0x28 */
  __IO uint32_t CCR4;                   /*!<  LPTIM32 Capture/Compare Register4,                    Address offset: 0x2C */
}LPTIM32_Type;


/* ================================================================================ */
/* ================                     LPTIM16                    ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CFGR;                   /*!<  LPTIM Config Register,                                Address offset: 0x00 */
  __I  uint32_t CNT;                    /*!<  LPTIM Counter Register,                               Address offset: 0x04 */
  __IO uint32_t CCSR;                   /*!<  LPTIM Capture/Compare Control and Status Register,    Address offset: 0x08 */
  __IO uint32_t ARR;                    /*!<  LPTIM Auto-Reload Register,                           Address offset: 0x0C */
  __IO uint32_t IER;                    /*!<  LPTIM Interrupt Enable Register,                      Address offset: 0x10 */
  __IO uint32_t ISR;                    /*!<  LPTIM Interrupt Status Register,                      Address offset: 0x14 */
  __IO uint32_t CR;                     /*!<  LPTIM Control Register,                               Address offset: 0x18 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x1C */
  __IO uint32_t CCR1;                   /*!<  LPTIM Capture/Compare Register1,                      Address offset: 0x20 */
  __IO uint32_t CCR2;                   /*!<  LPTIM Capture/Compare Register2,                      Address offset: 0x24 */
}LPTIM16_Type;


/* ================================================================================ */
/* ================                      RTCA                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t WER;                    /*!<  RTC Write Enable Register,                            Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  RTC Interrupt Enable Register,                        Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  RTC Interrupt Status Register,                        Address offset: 0x08 */
  __IO uint32_t BCDSEC;                 /*!<  BCD format time second registers,                     Address offset: 0x0C */
  __IO uint32_t BCDMIN;                 /*!<  BCD format time minute registers,                     Address offset: 0x10 */
  __IO uint32_t BCDHOUR;                /*!<  BCD format time hour registers,                       Address offset: 0x14 */
  __IO uint32_t BCDDAY;                 /*!<  BCD format time day registers,                        Address offset: 0x18 */
  __IO uint32_t BCDWEEK;                /*!<  BCD format time week registers,                       Address offset: 0x1C */
  __IO uint32_t BCDMONTH;               /*!<  BCD format time month registers,                      Address offset: 0x20 */
  __IO uint32_t BCDYEAR;                /*!<  BCD format time year registers,                       Address offset: 0x24 */
  __IO uint32_t ALARM;                  /*!<  RTCA Alarm Register,                                  Address offset: 0x28 */
  __IO uint32_t TMSEL;                  /*!<  RTCA Time Mark Select,                                Address offset: 0x2C */
  __IO uint32_t ADJUST;                 /*!<  RTCA time Adjust Register,                            Address offset: 0x30 */
  __IO uint32_t ADSIGN;                 /*!<  RTCA time Adjust Sign Register,                       Address offset: 0x34 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x38 */  
  __IO uint32_t SBSCNT;                 /*!<  RTCA Sub-Second Counter,                              Address offset: 0x3C */
  __IO uint32_t CR;                     /*!<  RTCA Control Register,                                Address offset: 0x40 */
}RTCA_Type;


/* ================================================================================ */
/* ================                      RTCB                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t WER;                    /*!<  RTCBWrite Enable Register,                            Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  RTCBInterrupt Enable Register,                        Address offset: 0x04 */
  __IO uint32_t ISR;                    /*!<  RTCBInterrupt Status Register,                        Address offset: 0x08 */
  __IO uint32_t BCDSEC;                 /*!<  BCD format time second registers,                     Address offset: 0x0C */
  __IO uint32_t BCDMIN;                 /*!<  BCD format time minute registers,                     Address offset: 0x10 */
  __IO uint32_t BCDHOUR;                /*!<  BCD format time hour registers,                       Address offset: 0x14 */
  __IO uint32_t BCDDAY;                 /*!<  BCD format time day registers,                        Address offset: 0x18 */
  __IO uint32_t BCDWEEK;                /*!<  BCD format time week registers,                       Address offset: 0x1C */
  __IO uint32_t BCDMONTH;               /*!<  BCD format time month registers,                      Address offset: 0x20 */
  __IO uint32_t BCDYEAR;                /*!<  BCD format time year registers,                       Address offset: 0x24 */
  __IO uint32_t ALARM;                  /*!<   Alarm Register,                                      Address offset: 0x28 */
  __IO uint32_t TMSEL;                  /*!<  RTCB Time Mark Select,                                Address offset: 0x2C */
  __IO uint32_t ADJR;                   /*!<  RTCB time Adjust Register,                            Address offset: 0x30 */
  __IO uint32_t RSV1[3];                /*!<  RESERVED REGISTER,                                    Address offset: 0x34 */
  __IO uint32_t CR;                     /*!<  RTCB Control Register,                                Address offset: 0x40 */
  __IO uint32_t RSV2;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x44 */
  __IO uint32_t STPCR;                  /*!<  RTCB Time Stamp Control Register,                     Address offset: 0x48 */
  __IO uint32_t STPCLKRR;               /*!<  RTC Time Stamp Clock Record Register,                 Address offset: 0x4C */
  __IO uint32_t STPCALRR;               /*!<  RTCB Time Stamp Calendar Record Register,             Address offset: 0x50 */
  __IO uint32_t RSV3[7];                /*!<  RESERVED REGISTER,                                    Address offset: 0x54 */
  __IO uint32_t BKR0;                   /*!<  RTCBBackup Register0,                                 Address offset: 0x70 */
  __IO uint32_t BKR1;                   /*!<  RTCB Backup Register1,                                Address offset: 0x74 */
  __IO uint32_t BKR2;                   /*!<  RTCB Backup Register2,                                Address offset: 0x78 */
  __IO uint32_t BKR3;                   /*!<  RTCB Backup Register3,                                Address offset: 0x7C */
  __IO uint32_t BKR4;                   /*!<  RTCB Backup Register4,                                Address offset: 0x80 */
}RTCB_Type;


/* ================================================================================ */
/* ================                       LCD                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  LCD Control Register,                                 Address offset: 0x00 */
  __IO uint32_t TEST;                   /*!<  LCD test Register,                                    Address offset: 0x04 */
  __IO uint32_t FCR;                    /*!<  LCD Frequency Control Register,                       Address offset: 0x08 */
  __IO uint32_t FLKT;                   /*!<  LCD Flick Time Register,                              Address offset: 0x0C */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x10 */
  __IO uint32_t IER;                    /*!<  LCD Interrupt Enable Register,                        Address offset: 0x14 */
  __IO uint32_t ISR;                    /*!<  LCD Interrupt Status Register,                        Address offset: 0x18 */
  __IO uint32_t RSV2[2];                /*!<  RESERVED REGISTER,                                    Address offset: 0x1C */
  __IO uint32_t DATA0;                  /*!<  LCD data buffer registers 0,                          Address offset: 0x24 */
  __IO uint32_t DATA1;                  /*!<  LCD data buffer registers 1,                          Address offset: 0x28 */
  __IO uint32_t DATA2;                  /*!<  LCD data buffer registers 2,                          Address offset: 0x2C */
  __IO uint32_t DATA3;                  /*!<  LCD data buffer registers 3,                          Address offset: 0x30 */
  __IO uint32_t DATA4;                  /*!<  LCD data buffer registers 4,                          Address offset: 0x34 */
  __IO uint32_t DATA5;                  /*!<  LCD data buffer registers 5,                          Address offset: 0x38 */
  __IO uint32_t DATA6;                  /*!<  LCD data buffer registers 6,                          Address offset: 0x3C */
  __IO uint32_t DATA7;                  /*!<  LCD data buffer registers 7,                          Address offset: 0x40 */
  __IO uint32_t DATA8;                  /*!<  LCD data buffer registers 8,                          Address offset: 0x44 */
  __IO uint32_t DATA9;                  /*!<  LCD data buffer registers 9,                          Address offset: 0x48 */
  __IO uint32_t RSV3;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x4C */
  __IO uint32_t COMEN;                  /*!<  LCD COM Enable Register,                              Address offset: 0x50 */
  __IO uint32_t SEGEN0;                 /*!<  LCD SEG Enable Register0,                             Address offset: 0x54 */
  __IO uint32_t SEGEN1;                 /*!<  LCD SEG Enable Register 1,                            Address offset: 0x58 */
}LCD_Type;


/* ================================================================================ */
/* ================                       ADC                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t ISR;                    /*!<  ADC Interrupt and Status Register,                    Address offset: 0x00 */
  __IO uint32_t IER;                    /*!<  ADC Interrupt Enable Register,                        Address offset: 0x04 */
  __IO uint32_t CR1;                    /*!<  ADC Control Register,                                 Address offset: 0x08 */
  __IO uint32_t CR2;                    /*!<  ADC Control Register,                                 Address offset: 0x0C */
  __IO uint32_t CALR;                   /*!<  ADC Calibration Register,                             Address offset: 0x10 */
  __IO uint32_t CFGR1;                  /*!<  ADC Config Register1,                                 Address offset: 0x14 */
  __IO uint32_t CFGR2;                  /*!<  ADC Config Register2,                                 Address offset: 0x18 */
  __IO uint32_t SMTR;                   /*!<  ADC Sampling Time Register,                           Address offset: 0x1C */
  __IO uint32_t CHER;                   /*!<  ADC Channel Enable Register,                          Address offset: 0x20 */
  __IO uint32_t DCR;                    /*!<  ADC Differential Channel Control Register,            Address offset: 0x24 */
  __I  uint32_t DR;                     /*!<  ADC Data Register,                                    Address offset: 0x28 */
  __IO uint32_t HLTR;                   /*!<  ADC analog watchdog Threshold Register,               Address offset: 0x2C */
}ADC_Type;


/* ================================================================================ */
/* ================                       DAC                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR1;                    /*!<  DAC Control Register,                                 Address offset: 0x00 */
  __IO uint32_t CR2;                    /*!<  DAC Control Register,                                 Address offset: 0x04 */
  __IO uint32_t CFGR;                   /*!<  DAC Config Register,                                  Address offset: 0x08 */
  __O  uint32_t SWTRGR;                 /*!<  DAC Software Trigger Register,                        Address offset: 0x0C */
  __IO uint32_t DHR;                    /*!<  DAC Data Holding Register,                            Address offset: 0x10 */
  __IO uint32_t ISR;                    /*!<  DAC Interrupt Status Register,                        Address offset: 0x14 */
  __IO uint32_t IER;                    /*!<  DAC Interrupt Enable Register,                        Address offset: 0x18 */
  __IO uint32_t SHTR;                   /*!<  DAC Sample Hold Time Register,                        Address offset: 0x1C */
}DAC_Type;


/* ================================================================================ */
/* ================                       PGL                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t CR;                     /*!<  PGL Control Register,                                 Address offset: 0x00 */
  __IO uint32_t CFGR0;                  /*!<  PGL Config Register0,                                 Address offset: 0x04 */
  __IO uint32_t CFGR1;                  /*!<  PGL Config Register1,                                 Address offset: 0x08 */
  __IO uint32_t CFGR2;                  /*!<  PGL Config Register2,                                 Address offset: 0x0C */
  __IO uint32_t CFGR3;                  /*!<  PGL Config Register3,                                 Address offset: 0x10 */
  __IO uint32_t IER;                    /*!<  PGL Interrupt Enable Register,                        Address offset: 0x14 */
  __IO uint32_t ISR;                    /*!<  PGL Interrupt Status Register,                        Address offset: 0x18 */
  __IO uint32_t LUT0;                   /*!<  Look Up Table0,                                       Address offset: 0x1C */
  __IO uint32_t LUT1;                   /*!<  Look Up Table1,                                       Address offset: 0x20 */
  __IO uint32_t LUT2;                   /*!<  Look Up Table2,                                       Address offset: 0x24 */
  __IO uint32_t LUT3;                   /*!<  Look Up Table3,                                       Address offset: 0x28 */
}PGL_Type;


/* ================================================================================ */
/* ================                      GPIO                      ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t INEN;                   /*!<  GPIOx Input Enable Register,                          Address offset: 0x00 */
  __IO uint32_t PUEN;                   /*!<  GPIOx Pull-Up Enable Register,                        Address offset: 0x04 */
  __IO uint32_t ODEN;                   /*!<  GPIOx Open-Drain Enable Register,                     Address offset: 0x08 */
  __IO uint32_t FCR;                    /*!<  GPIOx Function Control Register,                      Address offset: 0x0C */
  __IO uint32_t DO;                     /*!<  GPIOx Data Output Register,                           Address offset: 0x10 */
  __O  uint32_t DSET;                   /*!<  GPIOx Data Set Register,                              Address offset: 0x14 */
  __O  uint32_t DRST;                   /*!<  GPIOx Data Reset Register,                            Address offset: 0x18 */
  __I  uint32_t DIN;                    /*!<  GPIOx Data Input Register,                            Address offset: 0x1C */
  __IO uint32_t DFS;                    /*!<  GPIOx Digital Function Select,                        Address offset: 0x20 */
  __IO uint32_t RSV1;                   /*!<  RESERVED REGISTER,                                    Address offset: 0x24 */
  __IO uint32_t ANEN;                   /*!<  GPIOx Analog channel Enable Register,                 Address offset: 0x28 */
  __IO uint32_t VILR;                   /*!<  GPIOx Voltage Input Low Register,                     Address offset: 0x2C */
}GPIO_Type;


/* ================================================================================ */
/* ================                      GPIO_COMMON               ================ */
/* ================================================================================ */

typedef struct
{
  __IO uint32_t EXTISEL0;               /*!<  External Interrupt Input Select Register0,            Address offset: 0x00 */
  __IO uint32_t EXTISEL1;               /*!<  External Interrupt Input Select Register1,            Address offset: 0x04 */
  __IO uint32_t EXTIEDS0;               /*!<  External Interrupt Edge Select and Enable Register0,  Address offset: 0x08 */
  __IO uint32_t EXTIEDS1;               /*!<  External Interrupt Edge Select and Enable Register1,  Address offset: 0x0C */
  __IO uint32_t EXTIDF;                 /*!<  External Interrupt Digital Filter Register,           Address offset: 0x10 */
  __IO uint32_t EXTIISR;                /*!<  External Interrupt and Status Register,               Address offset: 0x14 */
  __I  uint32_t EXTIDI;                 /*!<  External Interrupt Data Input Register,               Address offset: 0x18 */
  __IO uint32_t RSV1[9];                /*!<  RESERVED REGISTER,                                    Address offset: 0x1C */
  __IO uint32_t FOUTSEL;                /*!<  Frequency Output Select Register,                     Address offset: 0x100 */
  __IO uint32_t RSV2[63];               /*!<  RESERVED REGISTER,                                    Address offset: 0x104 */
  __IO uint32_t PINWKEN;                /*!<  Wakeup Enable Register,                               Address offset: 0x200 */
}GPIO_COMMON_Type;


/* ================================================================================ */
/* ================                       DBG                      ================ */
/* ================================================================================ */

typedef struct
{
  __I  uint32_t SYSCFG;                 /*!<  ,                                                     Address offset: 0x00 */
  __IO uint32_t CR;               /*!<  ,                                                     Address offset: 0x04 */
  __IO uint32_t HDFR;                /*!<  ,                                                     Address offset: 0x08 */
}DBG_Type;



/* --------------------  End of section using anonymous unions  ------------------- */
#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__GNUC__)
/* anonymous unions are enabled by default */
#elif defined(__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler type
#endif


/* ================================================================================ */
/* ================              CPU memory map                    ================ */
/* ================================================================================ */


/* Peripheral and SRAM base address */

#define FLASH_BASE            ((     uint32_t)0x00000000)
#define SRAM_BASE             ((     uint32_t)0x20000000)
#define PERIPH_BASE           ((     uint32_t)0x40000000)


/* ================================================================================ */
/* ================              Peripheral memory map             ================ */
/* ================================================================================ */

/* Peripheral memory map */

#define FLASH_R_BASE                    (PERIPH_BASE        +0x00001000)
#define PMU_BASE                        (PERIPH_BASE        +0x00002000)
#define VREFP_BASE                      (PERIPH_BASE        +0x0000203C)
#define VREF_BASE                       (PERIPH_BASE        +0x0001A400)
#define VAO_BASE                        (PERIPH_BASE        +0x0001F000)
#define CDIF_BASE                       (PERIPH_BASE        +0x0001E000)
#define RMU_BASE                        (PERIPH_BASE        +0x00002800)
#define IWDT_BASE                       (PERIPH_BASE        +0x00011400)
#define WWDT_BASE                       (PERIPH_BASE        +0x00011800)
#define CMU_BASE                        (PERIPH_BASE        +0x00002400)
#define SVD_BASE                        (PERIPH_BASE        +0x00012800)
#define AES_BASE                        (PERIPH_BASE        +0x00013800)
#define RNG_BASE                        (PERIPH_BASE        +0x00013C00)
#define OPA_BASE                        (PERIPH_BASE        +0x0001A000)
#define COMP1_BASE                      (PERIPH_BASE        +0x00015400)
#define COMP2_BASE                      (PERIPH_BASE        +0x00015404)
#define COMP3_BASE                      (PERIPH_BASE        +0x00015408)
#define COMP_COMMON_BASE                (PERIPH_BASE        +0x0001540C)
#define DIVAS_BASE                      (PERIPH_BASE        +0x00019C00)
#define I2C_BASE                        (PERIPH_BASE        +0x00012400)
#define UART_COMMON_BASE                (PERIPH_BASE        +0x00017C00)
#define UART0_BASE                      (PERIPH_BASE        +0x00012000)
#define UART1_BASE                      (PERIPH_BASE        +0x00016800)
#define UART3_BASE                      (PERIPH_BASE        +0x00017000)
#define UART4_BASE                      (PERIPH_BASE        +0x00017400)
#define UART5_BASE                      (PERIPH_BASE        +0x00017800)
#define LPUART0_BASE                    (PERIPH_BASE        +0x00014000)
#define LPUART1_BASE                    (PERIPH_BASE        +0x00014400)
#define LPUART2_BASE                    (PERIPH_BASE        +0x00015000)
#define SPI0_BASE                       (PERIPH_BASE        +0x00010400)
#define SPI1_BASE                       (PERIPH_BASE        +0x00010800)
#define SPI2_BASE                       (PERIPH_BASE        +0x00014800)
#define U7816_BASE                      (PERIPH_BASE        +0x00011C00)
#define CAN_BASE                        (PERIPH_BASE        +0x00019400)
#define DMA_BASE                        (PERIPH_BASE        +0x00000400)
#define CRC_BASE                        (PERIPH_BASE        +0x00010000)
#define ATIM_BASE                       (PERIPH_BASE        +0x00013000)
#define GPTIM0_BASE                     (PERIPH_BASE        +0x00014C00)
#define GPTIM1_BASE                     (PERIPH_BASE        +0x00016400)
#define GPTIM2_BASE                     (PERIPH_BASE        +0x00018000)
#define BSTIM32_BASE                    (PERIPH_BASE        +0x00016000)
#define BSTIM16_BASE                    (PERIPH_BASE        +0x00018C00)
#define LPTIM32_BASE                    (PERIPH_BASE        +0x00013400)
#define LPTIM16_BASE                    (PERIPH_BASE        +0x00018800)
#define RTCA_BASE                       (PERIPH_BASE        +0x00011000)
#define RTCB_BASE                       (PERIPH_BASE        +0x0001F000)
#define LCD_BASE                        (PERIPH_BASE        +0x00010C00)
#define ADC_BASE                        (PERIPH_BASE        +0x00015C00)
#define DAC_BASE                        (PERIPH_BASE        +0x00019800)
#define PGL_BASE                        (PERIPH_BASE        +0x00016C00)
#define GPIOA_BASE                      (PERIPH_BASE        +0x00000C00)
#define GPIOB_BASE                      (PERIPH_BASE        +0x00000C40)
#define GPIOC_BASE                      (PERIPH_BASE        +0x00000C80)
#define GPIOD_BASE                      (PERIPH_BASE        +0x00000CC0)
#define GPIOE_BASE                      (PERIPH_BASE        +0x00000D00)
#define GPIO_COMMON_BASE                (PERIPH_BASE        +0x00000DC0)
#define DBG_BASE                        (PERIPH_BASE        +0x00000000)

/* ================================================================================ */
/* ================             Peripheral declaration             ================ */
/* ================================================================================ */

#define FLASH                           ((FLASH_Type        *) FLASH_R_BASE     )
#define PMU                             ((PMU_Type          *) PMU_BASE         )
#define VREFP                           ((VREFP_Type        *) VREFP_BASE       )
#define VREF                            ((VREF_Type         *) VREF_BASE        )
#define VAO                             ((VAO_Type          *) VAO_BASE         )
#define CDIF                            ((CDIF_Type         *) CDIF_BASE        )
#define RMU                             ((RMU_Type          *) RMU_BASE         )
#define IWDT                            ((IWDT_Type         *) IWDT_BASE        )
#define WWDT                            ((WWDT_Type         *) WWDT_BASE        )
#define CMU                             ((CMU_Type          *) CMU_BASE         )
#define SVD                             ((SVD_Type          *) SVD_BASE         )
#define AES                             ((AES_Type          *) AES_BASE         )
#define RNG                             ((RNG_Type          *) RNG_BASE         )
#define OPA                             ((OPA_Type          *) OPA_BASE         )
#define COMP1                           ((COMP_Type         *) COMP1_BASE       )
#define COMP2                           ((COMP_Type         *) COMP2_BASE       )
#define COMP3                           ((COMP_Type         *) COMP3_BASE       )
#define COMP                            ((COMP_COMMON_Type  *)COMP_COMMON_BASE  )
#define DIVAS                           ((DIVAS_Type        *) DIVAS_BASE       )
#define I2C                             ((I2C_Type          *) I2C_BASE         )
#define UART                            ((UART_COMMON_Type  *) UART_COMMON_BASE  )
#define UART0                           ((UART_Type        *) UART0_BASE       )
#define UART1                           ((UART_Type        *) UART1_BASE       )
#define UART3                           ((UART_Type        *) UART3_BASE       )
#define UART4                           ((UART_Type        *) UART4_BASE       )
#define UART5                           ((UART_Type        *) UART5_BASE       )
#define LPUART0                         ((LPUART_Type      *) LPUART0_BASE     )
#define LPUART1                         ((LPUART_Type      *) LPUART1_BASE     )
#define LPUART2                         ((LPUART_Type      *) LPUART2_BASE     )
#define SPI0                            ((SPI_Type          *) SPI0_BASE        )
#define SPI1                            ((SPI_Type          *) SPI1_BASE        )
#define SPI2                            ((SPI_Type          *) SPI2_BASE        )
#define U7816                           ((U7816_Type        *) U7816_BASE       )
#define CAN                             ((CAN_Type          *) CAN_BASE         )
#define DMA                             ((DMA_Type          *) DMA_BASE         )
#define CRC                             ((CRC_Type          *) CRC_BASE         )
#define ATIM                            ((ATIM_Type         *) ATIM_BASE        )
#define GPTIM0                          ((GPTIM_Type       *) GPTIM0_BASE      )
#define GPTIM1                          ((GPTIM_Type       *) GPTIM1_BASE      )
#define GPTIM2                          ((GPTIM_Type       *) GPTIM2_BASE      )
#define BSTIM32                         ((BSTIM32_Type      *) BSTIM32_BASE     )
#define BSTIM16                         ((BSTIM16_Type      *) BSTIM16_BASE     )
#define LPTIM32                         ((LPTIM32_Type      *) LPTIM32_BASE     )
#define LPTIM16                         ((LPTIM16_Type      *) LPTIM16_BASE     )
#define RTCA                            ((RTCA_Type         *) RTCA_BASE        )
#define RTCB                            ((RTCB_Type         *) RTCB_BASE        )
#define LCD                             ((LCD_Type          *) LCD_BASE         )
#define ADC                             ((ADC_Type          *) ADC_BASE         )
#define DAC                             ((DAC_Type          *) DAC_BASE         )
#define PGL                             ((PGL_Type          *) PGL_BASE         )
#define GPIOA                           ((GPIO_Type        *) GPIOA_BASE       )
#define GPIOB                           ((GPIO_Type        *) GPIOB_BASE       )
#define GPIOC                           ((GPIO_Type        *) GPIOC_BASE       )
#define GPIOD                           ((GPIO_Type        *) GPIOD_BASE       )
#define GPIOE                           ((GPIO_Type        *) GPIOE_BASE       )
#define GPIO                            ((GPIO_COMMON_Type  *) GPIO_COMMON_BASE )
#define DBG                             ((DBG_Type          *) DBG_BASE         )

/* ================================================================================ */
/* ================             Peripheral include                 ================ */
/* ================================================================================ */

/** @} */ /* End of group Device_Peripheral_Registers */
/** @} */ /* End of group FM33LG0XX */
/** @} */ /* End of group Keil */

#ifdef __cplusplus
}
#endif

#endif  /* FM33LG0XX_H */

